package com.xisc.pm.api.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/8/27 10:44
 */
@Data
public class BoardContractItemDTO implements Serializable {
    private static final long serialVersionUID = -5208956406186912025L;


    @ApiModelProperty("序号")
    private Long orderSeqNo;

    @ApiModelProperty("合同号")
    private String orderNo;

    @ApiModelProperty("小板厚度")
    private BigDecimal smallPlateThick;

    @ApiModelProperty("小板宽度")
    private BigDecimal smallPlateWidth;

    @ApiModelProperty("小板长度")
    private BigDecimal smallPlateLen;

    @ApiModelProperty("欠件")
    private BigDecimal pdLackQty;

    @ApiModelProperty("超投件数")
    private BigDecimal pdOverDevoQty;

    @ApiModelProperty("超投原因")
    private String pdOverDevoCause;

    @ApiModelProperty("牌号")
    private String sgSign;

    @ApiModelProperty("订货厚度")
    private BigDecimal orderThick;

    @ApiModelProperty("订货宽度")
    private BigDecimal orderWidth;

    @ApiModelProperty("订货宽度区分")
    private Long widthDiv;

    @ApiModelProperty("订货长度")
    private BigDecimal orderLen;

    @ApiModelProperty("长度起")
    private BigDecimal orderMinLen;

    @ApiModelProperty("长度至")
    private BigDecimal orderMaxLen;

    @ApiModelProperty("订货长度区分")
    private Long lenDiv;

    @ApiModelProperty("出钢记号")
    private String stNo;

    @ApiModelProperty("合同类型")
    private String orderTypeCode;

    @ApiModelProperty("到站港")
    private String delivyPlaceName;

    @ApiModelProperty("收货单位")
    private String consignCustCname;
    
    private String virtualSlabNo ;
}
