package com.xisc.pm.api.dto;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/10/10 16:26
 */
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Data
public class PmCastInfoResDTO implements Serializable {
    private static final long serialVersionUID = 1248196903947620771L;

    @ApiModelProperty(value = "预定CAST_LOT号")
    private String precCastLotNo;

    @ApiModelProperty(value = "CAST_LOT号")
    private String castLotNo;

    @ApiModelProperty(value = "坯料类型")
    private String ccType;

    @ApiModelProperty(value = "炉数")
    private Long ccNum;

    @ApiModelProperty(value = "连铸预定计划状态")
    private String csPrecPlanStatus;

    @ApiModelProperty(value = "炼钢申请日期")
    private Date steelAppDate;

    @ApiModelProperty(value = "板坯厚度")
    private BigDecimal slabThick;

    @ApiModelProperty(value = "板坯宽度")
    private BigDecimal slabWidth;

}
