package com.xisc.pm.api.dto;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/8/5 11:19
 */
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Data
public class PmCompositeSlabActLineDTO implements Serializable {
    private static final long serialVersionUID = -5846247979174084414L;

    @ApiModelProperty("明细表id")
    private Long id;

    @ApiModelProperty("层号")
    private Long layerNo;

    @ApiModelProperty("合同号")
    private String baseOrderNo;

    @ApiModelProperty(value = "基材ID")
    private Long baseMatId;

    @ApiModelProperty("基材号")
    private String baseMatNo;

    @ApiModelProperty("基材厚度")
    private BigDecimal matActThk;

    @ApiModelProperty("基材宽度")
    private BigDecimal matActWid;

    @ApiModelProperty("基材长度")
    private BigDecimal matActLen;

    @ApiModelProperty("基材重量")
    private BigDecimal matActWgt;

    @ApiModelProperty("复材号id")
    private Long ssId;

    @ApiModelProperty("复材号")
    private String ssNo;

    @ApiModelProperty("复材炉号")
    private String ssPono;

    @ApiModelProperty("复材类型")
    private String ssType;

    @ApiModelProperty("复材块数")
    private Long ssNum;

    @ApiModelProperty("组坯材料号")
    private String slabNo;

    @ApiModelProperty("熔炼号")
    private String heatNo;

    @ApiModelProperty("制造命令号")
    private String pono;

    @ApiModelProperty("材料实际厚度")
    private BigDecimal actThick;

    @ApiModelProperty("材料实际宽度")
    private BigDecimal actWidth;

    @ApiModelProperty("材料实际长度")
    private BigDecimal actLength;

    @ApiModelProperty("轧制方式")
    private String rollType;

    @ApiModelProperty("轧制目标厚度")
    private BigDecimal rollAimThick;

    @ApiModelProperty("轧制目标宽度")
    private BigDecimal rollAimWidth;
}
