package com.xisc.pm.api.dto;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/8/28 14:06
 */
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Data
public class PmCompositeSlabListResDTO implements Serializable {
    private static final long serialVersionUID = -2043934155929213143L;

    @ApiModelProperty(value = "复合/叠轧坯号")
    private String slabNo;

    @ApiModelProperty("基材每层ID")
    private Long listId ;

    @ApiModelProperty("层号")
    private Long layerNo;

    @ApiModelProperty("基材号")
    private String baseMatNo;

    @ApiModelProperty(value = "基材厚度")
    private BigDecimal baseMatThick;

    @ApiModelProperty(value = "基材宽度")
    private BigDecimal baseMatWidth;

    @ApiModelProperty(value = "基材长度")
    private BigDecimal baseMatLength;

    @ApiModelProperty(value = "基材组板确认状态")
    private String isConfirm;

    @ApiModelProperty(value = "组板方式")
    private String formPlateMode;

    @ApiModelProperty(value = "大板取样头部试材长度")
    private BigDecimal sampleHeadLenPlateValue;

    @ApiModelProperty(value = "大板取样尾部试材长度")
    private BigDecimal sampleTailLenPlateValue;

    @ApiModelProperty("小板位置信息")
    private List<PmSmallPltPosDTO> pmSmallPltPosList;

}
