package com.xisc.pm.api.dto;

import java.io.Serializable;
import java.math.BigDecimal;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 
 * 复合板组板DTO
 * @author jun.zeng
 *
 */
@Data
public class PmCompositeSlabPdDTO implements Serializable {

    private static final long serialVersionUID = 418954919843290876L;
    
    @ApiModelProperty("")
    private Long slabId ;
    
    @ApiModelProperty("")
    private Long listId ;
    
    @ApiModelProperty("坯号")
    private String slabNo;
    
    @ApiModelProperty("层号")
    private String layerNo;
    
    @ApiModelProperty("基材合同ID")
    private String baseOrderId;
    
    @ApiModelProperty("基材合同号")
    private String baseOrderNo;
    
    @ApiModelProperty("状态（中文）")
    private String statusCode;
    
    @ApiModelProperty("去向（目的库区）")
    private String destStockCode;
    
    @ApiModelProperty("熔炼号")
    private String heatNo;
    
    @ApiModelProperty("制造命令号")
    private String pono;
    
    @ApiModelProperty("厚度")
    private BigDecimal actThick;
    
    @ApiModelProperty("宽度")
    private BigDecimal actWidth;
    
    @ApiModelProperty("长")
    private BigDecimal actLength;
    
    @ApiModelProperty("轧制方向")
    private String rollType;
    @ApiModelProperty("轧制目标厚度")
    private BigDecimal rollAimThick;
    
    @ApiModelProperty("轧制目标宽度")
    private BigDecimal rollAimWidth;
    
    @ApiModelProperty("基材号")
    private String baseMatNo;
    
    @ApiModelProperty("基材厚度")
    private BigDecimal baseMatThick;
    
    @ApiModelProperty("基材宽度")
    private BigDecimal baseMatWidth;
    
    @ApiModelProperty("基材长度")
    private BigDecimal baseMatLength;
    
    @ApiModelProperty("基材重量")
    private BigDecimal baseMatWt;
    
    @ApiModelProperty("复材号")
    private String compMatNo;
    
    @ApiModelProperty("复材炉号")
    private String compMatPono;
}

