package com.xisc.pm.api.dto;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/8/1 15:49
 */
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Data
public class PmCompositeSlabResDTO implements Serializable {

    private static final long serialVersionUID = -3928786556654351242L;

    @ApiModelProperty("序号")
    private Long slabId;

    @ApiModelProperty("复合/叠轧坯号")
    private String slabNo;

    @ApiModelProperty("状态")
    private String status;

    @ApiModelProperty("目的库区id")
    private Long stockCodeId;

    @ApiModelProperty("库区去向")
    private String stockCode;

    @ApiModelProperty("组坯类型代码")
    private String slabType;

    @ApiModelProperty("基材合同号集合")
    private List<String> baseOrderNoList;

    @ApiModelProperty("轧制产线号")
    private String mscLineNo;

    @ApiModelProperty("加工厂代码")
    private String factoryCode;

    @ApiModelProperty("加工厂名称")
    private String factoryName;

    @ApiModelProperty("库区产线")
    private String stockLine;

    @ApiModelProperty("创建人")
    private Long createdBy;

    @ApiModelProperty("创建人")
    private String createdByName;

    @ApiModelProperty("创建时间")
    private Date creationDate;

    @ApiModelProperty("修改时间")
    private Date lastUpdateDate;

    @ApiModelProperty("修改者")
    private Long lastUpdatedBy;

    @ApiModelProperty("修改者")
    private String lastUpdatedByName;

}
