package com.xisc.pm.api.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hzero.export.annotation.ExcelColumn;
import org.hzero.export.annotation.ExcelSheet;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/8/27 17:35
 */
@Data
@ExcelSheet(zh = "内部钢种以优充次静态表", en = "PmHtolStatic")
public class PmHtolStaticDTO implements Serializable {
    private static final long serialVersionUID = 4630419683453299690L;

    @ApiModelProperty(value = "主键")
    private Long pmHtolStaticId;

    @ExcelColumn(zh = "主工序代码", en = "mainBacklogCode", order = 1)
    @ApiModelProperty(value = "主工序代码")
    private String mainBacklogCode;

    @ExcelColumn(zh = "优内部钢种", en = "betterStNo", order = 2)
    @ApiModelProperty(value = "优内部钢种")
    private String betterStNo;

    @ExcelColumn(zh = "次内部钢种", en = "worseStNo", order = 3)
    @ApiModelProperty(value = "次内部钢种")
    private String worseStNo;

    @ExcelColumn(zh = "以优充次顺序码", en = "betterToWorseSeq", order = 4)
    @ApiModelProperty(value = "以优充次顺序码")
    private Long betterToWorseSeq;

    @ExcelColumn(zh = "备注", en = "remark", order = 5)
    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "有效标识")
    private String validFlag;

    @ExcelColumn(zh = "有效标识", en = "validFlag", order = 6)
    @ApiModelProperty(value = "有效标识含义")
    private String validFlagDesc;


    @ApiModelProperty(value = "租户ID")
    private Long tenantId;

}
