package com.xisc.pm.api.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hzero.export.annotation.ExcelColumn;
import org.hzero.export.annotation.ExcelSheet;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @author BKGY  MYT
 */
@Data
@ApiModel("不可替代订单DTO")
public class PmIrsubableContRequestDTO {


    private Long id;

    @ApiModelProperty(value = "合同号起")
    private String orderNoFrom;

    @ApiModelProperty(value = "合同号止")
    private String orderNoTo;

    @ApiModelProperty(value = "牌号")
    private String sgSign;

    @ApiModelProperty(value = "内部钢种")
    private String sgStd;

    @ApiModelProperty(value = "订货厚度起")
    private BigDecimal orderThickFrom;

    @ApiModelProperty(value = "订货厚度止")
    private BigDecimal orderThickTo;

    @ApiModelProperty(value = "订货宽度起")
    private BigDecimal orderWidthFrom;

    @ApiModelProperty(value = "订货宽度止")
    private BigDecimal orderWidthTo;

    @ApiModelProperty(value = "订货长度起")
    private BigDecimal orderLenFrom;

    @ApiModelProperty(value = "订货长度起")
    private BigDecimal orderLenTo;

    @ApiModelProperty(value = "交货日期止")
    private Date delivyDateFrom;

    @ApiModelProperty(value = "交货日期止")
    private Date delivyDateTo;

    @ApiModelProperty(value = "租户ID")
    private Long tenantId;
}
