package com.xisc.pm.api.dto;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/8/6 10:42
 */
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Data
public class PmPdCcSlabLineDTO implements Serializable {
    private static final long serialVersionUID = -6559789789155968412L;

    @ApiModelProperty("虚拟板坯号")
    private String virtualSlabNo;

    @ApiModelProperty("炼钢最晚日期")
    private Date steelLatestDate;

    @ApiModelProperty("清理前板坯重量")
    private BigDecimal preCleanSlabWt;

    @ApiModelProperty("出钢记号(内部钢种)")
    private String stNo;

    @ApiModelProperty("清理前板坯厚度")
    private BigDecimal preCleanSlabThick;

    @ApiModelProperty("清理前板坯宽度")
    private BigDecimal preCleanSlabWidth;

    @ApiModelProperty("清理前板坯长度")
    private BigDecimal preCleanSlabLen;

    @ApiModelProperty("炼钢计划日期")
    private Date steelPlanDate;

    @ApiModelProperty("紧急合同标记")
    private String urgOrderFlag;

    @ApiModelProperty("厚板组板状态")
    private String pdStatusHp;

    @ApiModelProperty("轧制厚度")
    private BigDecimal rollAimThick;

    @ApiModelProperty("轧制宽度")
    private BigDecimal rollAimWidth;

    @ApiModelProperty("轴合同号")
    private String orderNo;

    @ApiModelProperty("交货日期")
    private Date delivyDate;

    @ApiModelProperty("收货单位")
    private String consignCustCname;

    @ApiModelProperty("创建时间")
    private Date creationDate;
}
