package com.xisc.pm.api.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 合同组板材料查询响应结果
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/7/30 10:56
 */
@Data
public class PmPdContPanelMaterialDTO implements Serializable {
    private static final long serialVersionUID = 6420566503767558212L;
    @ApiModelProperty("合同号")
    private String orderNo;

    @ApiModelProperty("组板材料号")
    private String pdMatNo;

    @ApiModelProperty("组板状态")
    private String pdStatus;

    @ApiModelProperty("大板小板块数")
    private BigDecimal orderPlateNum;

    @ApiModelProperty("订货重量")
    private BigDecimal orderWt;

    @ApiModelProperty("订货件数")
    private BigDecimal orderQty;

    @ApiModelProperty("组板形成总重量")
    private BigDecimal pdTotWt;

    @ApiModelProperty("组板形成总件数")
    private BigDecimal pdTotQty;

    @ApiModelProperty("组板工序欠量")
    private BigDecimal pdLackWt;

    @ApiModelProperty("组板工序欠件")
    private BigDecimal pdLackQty;

    @ApiModelProperty("冶金规范码")
    private String msc;

    @ApiModelProperty("产品规范码")
    private String psc;

    @ApiModelProperty("产品最终用途码")
    private String apn;

    @ApiModelProperty("合同性质代码")
    private String orderTypeCode;

    @ApiModelProperty(value = "全程工序途径码")
    private String wholeBacklog;
}
