package com.xisc.pm.api.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Set;

/**
 * 中间坯分割信息
 * 
 * @author jun.zeng
 *
 */
@Data
public class PmPdMidSplitRequestDTO implements Serializable {
    
    private static final long serialVersionUID = 1497504776674434902L;
    
    @ApiModelProperty("组板类型")
    private String matDesignKind = "C";
    
    @ApiModelProperty("板坯号")
    private String virtualSlabNo ;
    
    @ApiModelProperty("产线号")
    private String mscLineNo ;
    
    @ApiModelProperty("内部钢种")
    private String stNo ;
    
    @ApiModelProperty("结晶器厚")
    private BigDecimal moldThick ;
    
    @ApiModelProperty("结晶器宽")
    private BigDecimal moldWidth ;
    
    @ApiModelProperty("租户ID")
    private Long tenantId;
    
    @ApiModelProperty("待删除的分割信息表主键")
    private Set<Long> removePdSlabIdList ;

    @ApiModelProperty("是否删除全部")
    private boolean romoveAll;

    @ApiModelProperty(value = "锭坯型")
    private String ingotType;

    @ApiModelProperty("指定长")
    private BigDecimal fixSlabLen;

    @ApiModelProperty("临时收得率")
    private BigDecimal tmpYield ;

    @ApiModelProperty("指定长类型方式,值集范围：0-不指定长，1-指定长，2-奉送样")
    private Long fixSlabLenFlag ;

    @ApiModelProperty("钢锭组板类型")
    private String igMatDesignKind = "C";
    
}