package com.xisc.pm.api.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hzero.export.annotation.ExcelColumn;
import org.hzero.export.annotation.ExcelSheet;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/7/31 9:53
 */
@ExcelSheet(zh = "组板操作记录", en = "PmPdOperationReResponseDTO")
@Data
public class PmPdOperationReResponseDTO implements Serializable {

    private static final long serialVersionUID = -574708154245327801L;

    @ApiModelProperty("组板责任者")
    private Long createBy;

    @ExcelColumn(zh = "组板责任者", en = "createBy", order = 1)
    @ApiModelProperty("组板责任者")
    private String createdByName;

    @ExcelColumn(zh = "员工编号", en = "eventMaker", order = 2)
    @ApiModelProperty("员工编号")
    private String eventMaker;

    @ExcelColumn(zh = "材料号", en = "matNo", order = 3)
    @ApiModelProperty("材料号")
    private String matNo;

    @ApiModelProperty("组板类型")
    private String eventCode;

    @ExcelColumn(zh = "组板类型", en = "eventCode", order = 4)
    @ApiModelProperty("组板类型含义")
    private String eventCodeDesc;

    @ApiModelProperty("组板方式")
    private String formPlateMode;

    @ExcelColumn(zh = "组板方式", en = "formPlateMode", order = 5)
    @ApiModelProperty("组板方式含义")
    private String formPlateModeDesc;

    @ApiModelProperty("自动人工标记")
    private String autoManualFlag;

    @ExcelColumn(zh = "自动人工标记", en = "autoManualFlag", order = 6)
    @ApiModelProperty("自动人工标记含义")
    private String autoManualFlagDesc;

    @ExcelColumn(zh = "合同号", en = "orderNo", order = 7)
    @ApiModelProperty("合同号")
    private String orderNo;

    @ExcelColumn(zh = "合同交货期", en = "delivyDate", order = 8)
    @ApiModelProperty("合同交货期")
    private Date delivyDate;

    @ExcelColumn(zh = "重量", en = "orderWt", order = 9)
    @ApiModelProperty("重量")
    private BigDecimal orderWt;

    @ExcelColumn(zh = "厚", en = "orderThick", order = 10)
    @ApiModelProperty("厚")
    private BigDecimal orderThick;

    @ExcelColumn(zh = "宽", en = "orderWidth", order = 11)
    @ApiModelProperty("宽")
    private BigDecimal orderWidth;

    @ExcelColumn(zh = "长", en = "orderLen", order = 12)
    @ApiModelProperty("长")
    private BigDecimal orderLen;

    @ExcelColumn(zh = "组板时间", en = "createDate", order = 13)
    @ApiModelProperty("组板时间")
    private Date createDate;

}
