package com.xisc.pm.api.dto;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.xisc.pm.domain.entity.PmPdBlockPos;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/9/2 15:52
 */
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Data
public class PmPdPlateDTO implements Serializable {
    private static final long serialVersionUID = 4745390201371979772L;

    @ApiModelProperty("临时命令板坯号")
    private String tmpSlabNo;

    @ApiModelProperty("余材钢板号")
    private String plateNo;

    @ApiModelProperty("组板方式")
    private String formPlateMode;

    @ApiModelProperty("材料实际厚度")
    private BigDecimal matActThick;

    @ApiModelProperty("材料实际宽度")
    private BigDecimal matActWidth;

    @ApiModelProperty("材料实际长度")
    private BigDecimal matActLen;

    @ApiModelProperty("组板工序")
    private String ouBacklogCode;

    @ApiModelProperty("计划员")
    private String pdResp;

    @ApiModelProperty("组板状态")
    private String pdStatusHp;

    @ApiModelProperty("内部钢种")
    private String stNo;

    @ApiModelProperty("牌号")
    private String sgSign;

    @ApiModelProperty("命令收得率")
    private BigDecimal commandYield;

    @ApiModelProperty("轴合同号")
    private String orderNoAxis;

    @ApiModelProperty("产线号")
    private String mscLineNo;

    @ApiModelProperty("合同信息")
    private List<PmPdSlabOrderDTO> pmPdSlabOrderDTOList;

    @ApiModelProperty("组合子板位置信息")
    private List<PmPdBlockPos> pmPdBlockPosList;
}
