package com.xisc.pm.api.dto;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.xisc.pm.domain.entity.PmPdBlockPos;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/9/2 14:32
 */
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Data
public class PmPdSlabDTO implements Serializable {
    private static final long serialVersionUID = -758246447005246849L;

    @ApiModelProperty("虚拟板坯号")
    private String virtualSlabNo;

    @ApiModelProperty("板坯号")
    private String slabNo;

    @ApiModelProperty("内部钢种")
    private String stNo;

    @ApiModelProperty("计划员")
    private String pdResp;

    @ApiModelProperty("组板方式")
    private String formPlateMode;

    @ApiModelProperty("分割")
    private Long slabDivNo;

    @ApiModelProperty("状态")
    private String pdStatusHp;

    @ApiModelProperty("炉别")
    private String furType;

    @ApiModelProperty("板坯厚")
    private BigDecimal matActThick;

    @ApiModelProperty("板坯宽")
    private BigDecimal matActWidth;

    @ApiModelProperty("板坯长")
    private BigDecimal matActLen;

    @ApiModelProperty("板坯重")
    private BigDecimal matActWt;

    @ApiModelProperty("必要板坯长")
    private BigDecimal needSlabLen;

    @ApiModelProperty("进加热炉长")
    private BigDecimal infurSlabLen;

    @ApiModelProperty("清理前长")
    private BigDecimal preCleanSlabLen;

    @ApiModelProperty("轧制方向")
    private String rollDirectCode;

    @ApiModelProperty("剩余坯长")
    private BigDecimal remainSlabLen;

    @ApiModelProperty("组合板宽")
    private BigDecimal combinePlateWidth;

    @ApiModelProperty("组合板长")
    private BigDecimal combinePlateLen;

    @ApiModelProperty("指定长度")
    private BigDecimal fixSlabLen;

    @ApiModelProperty("轧制目标厚度")
    private BigDecimal rollAimThick;

    @ApiModelProperty("轧制目标宽度")
    private BigDecimal rollAimWidth;

    @ApiModelProperty("轧制目标长度")
    private BigDecimal rollAimLen;

    @ApiModelProperty("指定长标记")
    private Long fixSlabLenFlag;

    @ApiModelProperty("基准收得率")
    private BigDecimal normYield;

    @ApiModelProperty("轧制收得率")
    private BigDecimal rollYield;

    @ApiModelProperty("命令收得率")
    private BigDecimal commandYield;

    @ApiModelProperty("清理损失率")
    private BigDecimal slabCleanWtLossRateFr;

    @ApiModelProperty("轴合同号")
    private String orderNoAxis;

    @ApiModelProperty("产线号")
    private String mscLineNo;

    @ApiModelProperty("合同信息")
    private List<PmPdSlabOrderDTO> pmPdSlabOrderDTOList;

    @ApiModelProperty("组合子板位置信息")
    private List<PmPdBlockPos> pmPdBlockPosList;


}
