package com.xisc.pm.api.dto;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/9/2 14:51
 */
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Data
public class PmPdSlabOrderDTO implements Serializable {
    private static final long serialVersionUID = 2522671477059470451L;

    @ApiModelProperty("合同号")
    private String orderNo;

    @ApiModelProperty(value = "轴合同标记")
    private Long axisFlag;

    @ApiModelProperty("合同顺序号")
    private Long orderSeqNo;

    @ApiModelProperty("组板工序欠件")
    private BigDecimal pdLackQty;

    @ApiModelProperty("小板厚度")
    private BigDecimal smallPlateThick;

    @ApiModelProperty("小板宽度")
    private BigDecimal smallPlateWidth;

    @ApiModelProperty("小板长度")
    private BigDecimal smallPlateLen;

    @ApiModelProperty("订货厚度")
    private BigDecimal orderThick;

    @ApiModelProperty("订货宽度")
    private BigDecimal orderWidth;

    @ApiModelProperty("订货长度")
    private BigDecimal orderLen;

    @ApiModelProperty("订货长度下限")
    private BigDecimal orderLenMin;

    @ApiModelProperty("订货长度上限")
    private BigDecimal orderLenMax;

    @ApiModelProperty("出钢记号")
    private String stNo;

}
