package com.xisc.pm.api.dto;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 
 * @author 曾俊 jun.zeng@hand-china.com 2024-07-29 15:50:20
 *
 */
@Data
@ApiModel("生产合同轴合同与非轴合同选择接口参数DTO")
public class PmProContBlockDTO implements Serializable {

    private static final long serialVersionUID = 2406591360035229860L;

    @ApiModelProperty("子板顺序号")
    private Long blockNo;

    @ApiModelProperty("合同号")
    private String orderNo;

    @ApiModelProperty("合同顺序号")
    private Long orderSeqNo;

    @ApiModelProperty("合同组子板数")
    private Long orderBlockNum;

    @ApiModelProperty("订货厚")
    private BigDecimal orderThick;

    @ApiModelProperty("订货宽")
    private BigDecimal orderWidth;

    @ApiModelProperty("订货长")
    private BigDecimal orderLen;

    @ApiModelProperty("订货长上限")
    private BigDecimal orderLenMax;

    @ApiModelProperty("订货长下限")
    private BigDecimal orderLenMin;

    @ApiModelProperty("小板厚")
    private BigDecimal smallPlateThick;

    @ApiModelProperty("小板宽")
    private BigDecimal smallPlateWidth;

    @ApiModelProperty("小板长")
    private BigDecimal smallPlateLen;
    
    @ApiModelProperty("小板排列位置")
    private List<List<Boolean>> spPos ;

}
