package com.xisc.pm.api.dto;

import java.io.Serializable;
import java.math.BigDecimal;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 
 * @author 曾俊 jun.zeng@hand-china.com 
 * 2024-07-29 15:50:20
 *
 */
@Data
@ApiModel("生产合同待收池查询结果DTO")
public class PmProContPoolResposeDTO implements Serializable {

    private static final long serialVersionUID = -4420948535402291343L;

    @ApiModelProperty("合同号")
    private String orderNo;
    
    @ApiModelProperty("合同状态")
    private String orderStatus;
    
    @ApiModelProperty("可走产线号")
    private String mscLineNo;
    
    @ApiModelProperty("合同性质代码")
    private String orderTypeCode;
    
    @ApiModelProperty("交货日期")
    private String delivyDate;
    
    @ApiModelProperty("内部钢种")
    private String stNo;
    
    @ApiModelProperty("标准牌号")
    private String sgSign;
    
    @ApiModelProperty("合同涂漆标记")
    private String needLecquering;
    
    @ApiModelProperty("订货厚度")
    private BigDecimal orderThick;
    
    @ApiModelProperty("订货宽度")
    private BigDecimal orderWidth;
    
    @ApiModelProperty("订货最小长度")
    private BigDecimal orderMinLen;
    
    @ApiModelProperty("订货最大长度")
    private BigDecimal orderMaxLen;
    
    @ApiModelProperty("订货件数")
    private BigDecimal orderQty;
    
    @ApiModelProperty("交货件数正公差")
    private BigDecimal delivyQtyTolPlus;
    
    @ApiModelProperty("交货件数负公差")
    private BigDecimal delivyQtyTolMinus;
    
    @ApiModelProperty("订货重量")
    private BigDecimal orderWt;
    
    @ApiModelProperty("收货用户中文名称")
    private String consignCustCname;
    
    @ApiModelProperty("到站港")
    private String delivyPlaceName;
    
    @ApiModelProperty("订货用户中文名称")
    private String orderCustCname;
    
    @ApiModelProperty("船体分段号")
    private String hullSectionNo;
    
    @ApiModelProperty("是否分段管理")
    private String sectionManageFlag;
    
    @ApiModelProperty("产销合同号")
    private String orderNoErp;
    
    @ApiModelProperty(value = "库存数量")
    private BigDecimal stockNum ;

}
