package com.xisc.pm.api.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 
 * @author 曾俊 jun.zeng@hand-china.com 
 * 2024-07-29 15:50:20
 *
 */
@Data
@ApiModel("生产合同查询结果DTO")
public class PmProContResposeDTO implements Serializable {

    private static final long serialVersionUID = 2140241156838175198L;

    @ApiModelProperty("合同号")
    private String orderNo;
    
    @ApiModelProperty("可走产线号")
    private String mscLineNo;
    
    @ApiModelProperty("订货单重")
    private BigDecimal unitWtAim;
    
    @ApiModelProperty("组板欠件")
    private BigDecimal pdLackQty;
    
    @ApiModelProperty("组板欠量")
    private BigDecimal pdLackWt;
    
    @ApiModelProperty("内部钢种")
    private String stNo;
    
    @ApiModelProperty("奉送样")
    private String giveSampleCode;
    
    @ApiModelProperty("送样长")
    private BigDecimal sampleLenGive;
    
    @ApiModelProperty("交货日期")
    private Date delivyDate;
    
    @ApiModelProperty("牌号（钢级）")
    private String sgSign;
    
    @ApiModelProperty("订货厚度")
    private BigDecimal orderThick;
    
    @ApiModelProperty("订货宽度")
    private BigDecimal orderWidth;
    
    @ApiModelProperty("订货长度")
    private BigDecimal lenAim;
    
    @ApiModelProperty("精炼路径代码")
    private String rfPath;
    
    @ApiModelProperty("切边标记")
    private String trimCode;
    
    @ApiModelProperty("轧制模式")
    private String rollMode;
    
    @ApiModelProperty("AD类型代码")
    private String adTypeCode;
    
    @ApiModelProperty("AD类型代码")
    private String adTypeCodeName;
    
    @ApiModelProperty("压缩比下限")
    private BigDecimal compressMin;
    
    @ApiModelProperty("组板板坯最小厚度")
    private BigDecimal minThick;
    
    @ApiModelProperty("热处理模式")
    private String heatTreatMode;
    
    @ApiModelProperty("超声探伤代码")
    private String ultCode;
    
    @ApiModelProperty("收货用户中文名称")
    private String consignCustCname;
    
    @ApiModelProperty("交货地点名称")
    private String delivyPlaceName;
    
    @ApiModelProperty("运输方式代码")
    private String trnpModeCode;
    
    @ApiModelProperty("宽度上限")
    private BigDecimal widthMax;
    
    @ApiModelProperty("宽度下限")
    private BigDecimal widthMin;
    
    @ApiModelProperty("订货长度上限")
    private BigDecimal orderMaxLen;
    
    @ApiModelProperty("订货长度下限")
    private BigDecimal orderMinLen;
    
    @ApiModelProperty("订货重量")
    private BigDecimal orderWt;
    
    @ApiModelProperty("订货件数")
    private BigDecimal orderQty;
    
    @ApiModelProperty("紧急合同标记")
    private Long urgOrderFlag;
    
    @ApiModelProperty("冶金规范码")
    private String msc;
    
    @ApiModelProperty("组板开始时间")
    private Date pdBeginTime;
    
    @ApiModelProperty("收池时间")
    private Date recCreateTime;
    
    @ApiModelProperty("收池责任者")
    private String recCreator;
    
    @ApiModelProperty("产销合同号")
    private String orderNoErp;
    
    @ApiModelProperty("合同涂漆标志")
    private String needLecquering;
    
    @ApiModelProperty("合同涂漆标志")
    private String needLecqueringName;
    
    @ApiModelProperty("船体分段号")
    private String hullSectionNo;
    
    @ApiModelProperty("是否分段管理")
    private String sectionManage;
    
    @ApiModelProperty("是否分段管理")
    private String sectionManageName;
    
    @ApiModelProperty("控轧代码")
    private String ctrlRollCode;
    
    @ApiModelProperty("合同性质代码")
    private String orderTypeCode;
    
    @ApiModelProperty("合同性质代码")
    private String orderTypeCodeName;
    
    @ApiModelProperty("湘重合同标记")
    private Long xzFlag;
    
    @ApiModelProperty("试样标记")
    private String diFlag;
    
    @ApiModelProperty("试样标记")
    private String diFlagName;
    
    @ApiModelProperty("合同跟踪欠件")
    private BigDecimal ordRemNum;

    @ApiModelProperty(value = "全程热处理模式")
    private String wholeHeatTreatmentType;

    @ApiModelProperty(value = "合同封锁标记", required = true)
    private Long pdHoldFlag;
    
    @ApiModelProperty(value = "合同封锁标记", required = true)
    private String pdHoldFlagName;
    
    @ApiModelProperty(value = "库存数量")
    private BigDecimal stockNum ;

    @ApiModelProperty(value = "合约欠量")
    private BigDecimal cotractNum;

    @ApiModelProperty(value = "组板工序超投件数")
    private BigDecimal pdOverDevoQty;

    @ApiModelProperty(value = "可组板数")
    private BigDecimal userdBoardNum;
}
