package com.xisc.pm.api.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/10/14 10:23
 */
@Data
public class PmRuntimeContractLineReqDTO implements Serializable {
    private static final long serialVersionUID = -3026365841963543660L;


    @ApiModelProperty(value = "合同号")
    private String orderNo;

    @ApiModelProperty(value = "设计产线号")
    private String designProdLineCode;

    @ApiModelProperty(value = "合同性质代码")
    private String orderTypeCode;

    @ApiModelProperty(value = "交货日期")
    private Date delivyDate;

    @ApiModelProperty(value = "标准牌号")
    private String sgSign;

    @ApiModelProperty(value = "涂漆标记（0为不喷，1为厂内喷漆，2为厂外喷漆）")
    private String needLecquering;

    @ApiModelProperty(value = "订货厚度")
    private BigDecimal orderThick;

    @ApiModelProperty(value = "订货宽度")
    private BigDecimal orderWidth;

    @ApiModelProperty(value = "订货长度")
    private BigDecimal orderLen;

    @ApiModelProperty(value = "订货件数")
    private BigDecimal orderNum;

    @ApiModelProperty(value = "订货重量")
    private BigDecimal orderWt;

    @ApiModelProperty(value = "收货用户中文名")
    private String consignCustCname;

    @ApiModelProperty(value = "到站港")
    private String delivyPlaceName;

    @ApiModelProperty(value = "订货用户中文名")
    private String orderCustCname;

    @ApiModelProperty(value = "船体分段号")
    private String hullSectionNo;

    @ApiModelProperty(value = "超声探伤代码")
    private String ultCode;

    @ApiModelProperty(value = "热处理模式")
    private String heatTreatMode;

    @ApiModelProperty(value = "指定产线编码")
    private String prodLineCode;

    @ApiModelProperty(value = "断面厚*宽")
    private String mold;

}
