package com.xisc.pm.api.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.util.Date;


/**
 * 生产线组板方式表(PmSlabMethod)实体类
 *
 * @author jie.yang04@hand-china.com
 * @since 2024-10-09 09:43:33
 */

@Getter
@Setter
@ApiModel("生产线组板方式表")
public class PmSlabMethodDTO implements Serializable {
    private static final long serialVersionUID = 895486118448495269L;

    @ApiModelProperty("ID")
    private Long prodLineStatsId;

    @ApiModelProperty(value = "生产线编码", required = true)
    private Long prodLineCode;

    @ApiModelProperty(value = "生产线ID", required = true)
    private Long prodLineId;

    @ApiModelProperty(value = "组板方式", required = true)
    private String comboSlabMethod;

    @ApiModelProperty(value = "优先级", required = true)
    private Long priority;

    @ApiModelProperty(value = "租户ID", required = true)
    private Long tenantId;

    @ApiModelProperty(value = "创建人")
    private String createdByName;

    @ApiModelProperty(value = "更新人")
    private String updateByName;

    private Date creationDate;
    private Long createdBy;
    private Date lastUpdateDate;
    private Long lastUpdatedBy;
    private Long objectVersionNumber;


    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


}

