package com.xisc.pm.api.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @author BKGY  MYT
 */
@Data
@ApiModel("自动组板日志传参DTO")
public class PmSubOrdResponseDTO {
    
    private Long id;

    @ApiModelProperty(value = "合同号", required = true)
    @NotBlank
    private String orderNo;

    @ApiModelProperty(value = "牌号")
    private String sgSign;

    @ApiModelProperty(value = "内部钢种")
    private String stNo;

    @ApiModelProperty(value = "订货厚度")
    private BigDecimal orderThick;

    @ApiModelProperty(value = "订货宽度")
    private BigDecimal orderWidth;

    @ApiModelProperty(value = "订货长度")
    private BigDecimal lenAim;

    @ApiModelProperty(value = "交货日期")
    private Date delivyDate;

    @ApiModelProperty(value = "轴合同")
    private String axisOrd;

    @ApiModelProperty(value = "欠量")
    private BigDecimal lackNum;

    @ApiModelProperty(value = "超投")
    private BigDecimal overNum;

    @ApiModelProperty(value = "租户ID", required = true)
    private Long tenantId;

    @ApiModelProperty(value = "合同顺序号")
    private Long orderSeqNo;

    @ApiModelProperty(value = "虚拟板批号")
    private String virtualSlabNo;

    @ApiModelProperty(value = "X方向位置")
    private BigDecimal posX;

    @ApiModelProperty(value = "Y方向位置")
    private BigDecimal posY;

    @ApiModelProperty(value = "合同号分组")
    private Long orderGroup;
}
