package com.xisc.pm.api.dto.ctevent;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/9/13 9:39
 */
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Data
public class PmSlabApplyMakeDTO implements Serializable {

    @ApiModelProperty("母材料号（虚拟板坯号/板坯号）")
    private String moMatNo;

    @ApiModelProperty("虚拟板坯号")
    private String matNo;

      @ApiModelProperty("合同号")
    private String orderNo;

    @ApiModelProperty("产品标记")
    private Integer ppFlag;

    @ApiModelProperty("合同材/余材标记(1合同材/余材2")
    private String ordFlag;

    @ApiModelProperty("厚板组板状态")
    private String pdMatStatus;

    @ApiModelProperty("进程状态码")
    private String procCd;

    @ApiModelProperty("全程工序代码")
    private String wholeBacklogCode;

    @ApiModelProperty("材料厚度")
    private BigDecimal thk;

    @ApiModelProperty("材料宽度")
    private BigDecimal wid;

    @ApiModelProperty("材料长度")
    private BigDecimal len;

    @ApiModelProperty("材料重量")
    private BigDecimal wgt;

    @ApiModelProperty("是否有效")
    private String enableFlag;

}
