package com.xisc.pm.api.dto.ctevent;

import java.io.Serializable;
import java.math.BigDecimal;

import com.xisc.pm.infra.util.Utils;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 生产合同超投事件
 * 
 * @author jun.zeng
 *
 */
@Data
public class ProContOverDTO implements Serializable {

    private static final long serialVersionUID = 434796153106056585L;

    @ApiModelProperty("合约号")
    private String contractNum;
    
    @ApiModelProperty("合同号")
    private String orderNo;
    
    @ApiModelProperty("件数")
    private BigDecimal num;
    
    @ApiModelProperty("重量")
    private BigDecimal wgt;
    
    @ApiModelProperty("超投原因标记 必填 XS/SC")
    private String overFlag ;

    public ProContOverDTO(String orderNo, BigDecimal num, BigDecimal wgt , String overFlag) {
        super();
        this.orderNo = orderNo;
        this.num = num;
        this.wgt = wgt;
        this.overFlag = overFlag;
        this.contractNum = Utils.removeLastThreeChars(orderNo);
    }

}
