package com.xisc.pm.api.dto.export;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hzero.export.annotation.ExcelColumn;
import org.hzero.export.annotation.ExcelSheet;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author BKGY  MYT
 */
@ExcelSheet(zh = "不可替代板坯表", en = "PmIrsubableSlab")
@Data
public class PmIrsubableSlabDTO {
    @ApiModelProperty("主键ID")
    private Long id;

    @ExcelColumn(zh = "合同号", en = "slabNo", order = 1)
    @ApiModelProperty(value = "合同号", required = true)
    private String slabNo;

    @ExcelColumn(zh = "牌号", en = "sgSign", order = 2)
    @ApiModelProperty(value = "牌号")
    private String sgSign;

    @ExcelColumn(zh = "内部钢种", en = "stNo", order = 3)
    @ApiModelProperty(value = "内部钢种")
    private String stNo;

    @ExcelColumn(zh = "板坯厚度", en = "matActThick", order = 4)
    @ApiModelProperty(value = "板坯厚度")
    private BigDecimal matActThick;

    @ExcelColumn(zh = "板坯宽度", en = "matActWidth", order = 5)
    @ApiModelProperty(value = "板坯宽度")
    private BigDecimal matActWidth;

    @ExcelColumn(zh = "板坯长度", en = "matActLen", order = 6)
    @ApiModelProperty(value = "板坯长度")
    private BigDecimal matActLen;

    @ExcelColumn(zh = "库区代码", en = "dstockCode", order = 7)
    @ApiModelProperty(value = "库区代码")
    private String dstockCode;

    @ExcelColumn(zh = "创建时间", en = "creationDate", order = 8)
    @ApiModelProperty(value = "创建时间")
    private Date creationDate;

    @ExcelColumn(zh = "创建人", en = "createdBy", order = 9)
    @ApiModelProperty(value = "创建人")
    private Long createdBy;

    @ExcelColumn(zh = "修改时间", en = "lastUpdateDate", order = 10)
    @ApiModelProperty(value = "修改时间")
    private Date lastUpdateDate;

    @ExcelColumn(zh = "修改人", en = "lastUpdatedBy", order = 11)
    @ApiModelProperty(value = "修改人")
    private Long lastUpdatedBy;
}
