package com.xisc.pm.api.dto.export;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hzero.export.annotation.ExcelColumn;
import org.hzero.export.annotation.ExcelSheet;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/9/25 13:52
 */
@ExcelSheet(zh = "低碳钢坯加余量基准表", en = "PmMidSlabAddvBtDTO")
@Data
public class PmMidSlabAddvBtDTO implements Serializable {
    private static final long serialVersionUID = -6985215189095962532L;

    @ApiModelProperty(value = "轧制产线号")
    private String rollLineNo;

    @ExcelColumn(zh = "轧制产线号", en = "rollLineNo", order = 1)
    @ApiModelProperty(value = "轧制产线号")
    private String rollLineNoDesc;

    @ExcelColumn(zh = "内部钢种", en = "stNo", order = 2)
    @ApiModelProperty(value = "内部钢种")
    private String stNo;

    @ExcelColumn(zh = "标准牌号", en = "sgSign", order = 3)
    @ApiModelProperty(value = "标准牌号")
    @NotBlank
    private String sgSign;

    @ExcelColumn(zh = "精轧开轧温度", en = "startRollTemp2Aim", order = 4)
    @ApiModelProperty(value = "精轧开轧温度（取质量二阶段开轧温度，借用开始轧制温度字段，小于等于）")
    private String startRollTemp2Aim;

    @ExcelColumn(zh = "钢板厚度起", en = "plateThickFrom", order = 5)
    @ApiModelProperty(value = "钢板厚度起")
    private BigDecimal plateThickFrom;

    @ExcelColumn(zh = "钢板厚度止", en = "plateThickTo", order = 6)
    @ApiModelProperty(value = "钢板厚度止")
    private BigDecimal plateThickTo;

    @ExcelColumn(zh = "允许长宽差", en = "lenWidthDiff", order = 7)
    @ApiModelProperty(value = "允许长宽差")
    private BigDecimal lenWidthDiff;
}
