package com.xisc.pm.api.dto.export;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hzero.export.annotation.ExcelColumn;
import org.hzero.export.annotation.ExcelSheet;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/8/27 20:15
 */
@ExcelSheet(zh = "组板临时收得率基准表", en = "PmPdTmpYieldBt")
@Data
public class PmPdTmpYieldBtDTO implements Serializable {
    private static final long serialVersionUID = -2144638631612822233L;

    @ApiModelProperty("主键ID")
    private Long pptybId;

    @ApiModelProperty(value = "连铸机类型")
    private String ccType;

    @ExcelColumn(zh = "连铸机类型", en = "ccType", order = 1)
    @ApiModelProperty(value = "连铸机类型含义")
    private String ccTypeDesc;

    @ApiModelProperty(value = "厚板品种代码")
    private String prodCodeHp;

    @ExcelColumn(zh = "厚板品种代码", en = "prodCodeHpDesc", order = 2)
    @ApiModelProperty(value = "厚板品种代码")
    private String prodCodeHpDesc;

    @ApiModelProperty(value = "切边标记")
    private String withSideFlag;

    @ExcelColumn(zh = "切边标记", en = "withSideFlag", order = 3)
    @ApiModelProperty(value = "切边标记含义")
    private String withSideFlagDesc;

    @ExcelColumn(zh = "板坯厚度起", en = "切边标记", order = 4)
    @ApiModelProperty(value = "板坯厚度起")
    private BigDecimal slabThickFrom;

    @ExcelColumn(zh = "板坯厚度止", en = "slabThickTo", order = 5)
    @ApiModelProperty(value = "板坯厚度止")
    private BigDecimal slabThickTo;

    @ExcelColumn(zh = "板坯宽度起", en = "slabWidthFrom", order = 6)
    @ApiModelProperty(value = "板坯宽度起")
    private BigDecimal slabWidthFrom;

    @ExcelColumn(zh = "板坯宽度止", en = "slabWidthTo", order = 7)
    @ApiModelProperty(value = "板坯宽度止")
    private BigDecimal slabWidthTo;

    @ExcelColumn(zh = "钢板厚度起", en = "plateThickFrom", order = 8)
    @ApiModelProperty(value = "钢板厚度起")
    private BigDecimal plateThickFrom;

    @ExcelColumn(zh = "钢板厚度止", en = "plateThickTo", order = 9)
    @ApiModelProperty(value = "钢板厚度止")
    private BigDecimal plateThickTo;

    @ExcelColumn(zh = "临时收得率", en = "tmpYield", order = 10)
    @ApiModelProperty(value = "临时收得率")
    private BigDecimal tmpYield;

    @ApiModelProperty(value = "轧制产线号")
    private String rollLineNo;

    @ExcelColumn(zh = "轧制产线号", en = "rollLineNo", order = 11)
    @ApiModelProperty(value = "轧制产线号含义")
    private String rollLineNoDesc;

    @ApiModelProperty(value = "租户ID")
    private Long tenantId;
}
