package com.xisc.pm.api.dto.export;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hzero.export.annotation.ExcelColumn;
import org.hzero.export.annotation.ExcelSheet;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/8/27 17:08
 */
@ExcelSheet(zh = "钢板切缝切头尾范围基准表", en = "PmPlateCutLenBt")
@Data
public class PmPlateCutLenBtDTO implements Serializable {

    private static final long serialVersionUID = -8497242336658715741L;

    @ApiModelProperty("主键ID")
    @Id
    @GeneratedValue
    private Long ppclbId;

    @ExcelColumn(zh = "钢板厚度起", en = "plateThickFrom", order = 1)
    @ApiModelProperty(value = "钢板厚度起")
    private BigDecimal plateThickFrom;

    @ExcelColumn(zh = "钢板厚度止", en = "plateThickTo", order = 2)
    @ApiModelProperty(value = "钢板厚度止")
    private BigDecimal plateThickTo;

    @ExcelColumn(zh = "组合板宽度起", en = "combinePlateWidthFrom", order = 3)
    @ApiModelProperty(value = "组合板宽度起")
    private BigDecimal combinePlateWidthFrom;

    @ExcelColumn(zh = "组合板宽度止", en = "combinePlateWidthTo", order = 4)
    @ApiModelProperty(value = "组合板宽度止")
    private BigDecimal combinePlateWidthTo;

    @ExcelColumn(zh = "板坯厚度起", en = "slabThickFrom", order = 5)
    @ApiModelProperty(value = "板坯厚度起")
    private BigDecimal slabThickFrom;

    @ExcelColumn(zh = "板坯厚度止", en = "slabThickTo", order = 6)
    @ApiModelProperty(value = "板坯厚度止")
    private BigDecimal slabThickTo;

    @ApiModelProperty(value = "是否展宽")
    private String brrNeed;

    @ExcelColumn(zh = "是否展宽", en = "brrNeed", order = 7)
    @ApiModelProperty(value = "是否展宽含义")
    private String brrNeedDesc;

    @ApiModelProperty(value = "轧制模式")
    private String rollMode;

    @ExcelColumn(zh = "轧制模式", en = "rollMode", order = 8)
    @ApiModelProperty(value = "轧制模式含义")
    private String rollModeDesc;

    @ApiModelProperty(value = "轧制方向代码")
    private String rollDirectCode;


    @ExcelColumn(zh = "轧制方向代码", en = "rollDirectCode", order = 9)
    @ApiModelProperty(value = "轧制方向代码含义")
    private String rollDirectCodeDesc;

    @ApiModelProperty(value = "设计产线号")
    @NotBlank
    private String mscLineNo;

    @ExcelColumn(zh = "设计产线号", en = "mscLineNo", order = 10)
    @ApiModelProperty(value = "设计产线号含义")
    private String mscLineNoDesc;

    @ExcelColumn(zh = "钢板切缝宽度", en = "plateCutWidth", order = 11)
    @ApiModelProperty(value = "钢板切缝宽度")
    private BigDecimal plateCutWidth;

    @ExcelColumn(zh = "头部切舍量", en = "headCut", order = 12)
    @ApiModelProperty(value = "头部切舍量")
    private BigDecimal headCut;

    @ExcelColumn(zh = "尾部切舍量", en = "tailCut", order = 13)
    @ApiModelProperty(value = "尾部切舍量")
    private BigDecimal tailCut;

    @ApiModelProperty(value = "租户ID")
    private Long tenantId;

}
