package com.xisc.pm.api.dto.export;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hzero.export.annotation.ExcelColumn;
import org.hzero.export.annotation.ExcelSheet;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/8/27 19:42
 */
@ExcelSheet(zh = "钢板切边量基准表", en = "PmPlateTrimBt")
@Data
public class PmPlateTrimBtDTO implements Serializable {
    private static final long serialVersionUID = -7265477335895262733L;

    @ApiModelProperty("主键ID")
    private Long pptbId;

    @ExcelColumn(zh = "钢板厚度起", en = "plateThickFrom", order = 1)
    @ApiModelProperty(value = "钢板厚度起")
    private BigDecimal plateThickFrom;

    @ExcelColumn(zh = "钢板厚度止", en = "plateThickTo", order = 2)
    @ApiModelProperty(value = "钢板厚度止")
    private BigDecimal plateThickTo;

    @ExcelColumn(zh = "组合板宽度起", en = "combinePlateWidthFrom", order = 3)
    @ApiModelProperty(value = "组合板宽度起")
    private BigDecimal combinePlateWidthFrom;

    @ExcelColumn(zh = "组合板宽度止", en = "combinePlateWidthTo", order = 4)
    @ApiModelProperty(value = "组合板宽度止")
    private BigDecimal combinePlateWidthTo;

    @ExcelColumn(zh = "小板长度起", en = "smallPlateLenFrom", order = 5)
    @ApiModelProperty(value = "小板长度起")
    private BigDecimal smallPlateLenFrom;

    @ExcelColumn(zh = "小板长度止", en = "smallPlateLenTo", order = 6)
    @ApiModelProperty(value = "小板长度止")
    private BigDecimal smallPlateLenTo;

    @ApiModelProperty(value = "切边标记")
    private String withSideFlag;

    @ExcelColumn(zh = "切边标记", en = "withSideFlag", order = 7)
    @ApiModelProperty(value = "切边标记含义")
    private String withSideFlagDesc;

    @ExcelColumn(zh = "展宽比起", en = "widenFrom", order = 8)
    @ApiModelProperty(value = "展宽比起")
    private BigDecimal widenFrom;

    @ExcelColumn(zh = "展宽比止", en = "widenTo", order = 9)
    @ApiModelProperty(value = "展宽比止")
    private BigDecimal widenTo;

    @ExcelColumn(zh = "切边量", en = "trimWidth", order = 10)
    @ApiModelProperty(value = "切边量")
    private BigDecimal trimWidth;

    @ApiModelProperty(value = "设计产线号")
    @NotBlank
    private String mscLineNo;

    @ExcelColumn(zh = "设计产线号", en = "mscLineNo", order = 11)
    @ApiModelProperty(value = "设计产线号含义")
    private String mscLineNoDesc;

    @ApiModelProperty(value = "租户ID")
    private Long tenantId;
}
