package com.xisc.pm.api.dto.export;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hzero.export.annotation.ExcelColumn;
import org.hzero.export.annotation.ExcelSheet;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author BKGY  MYT
 */
@ExcelSheet(zh = "钢种信息配置", en = "PmRetainSt")
@Data
public class PmRetainStDTO {
    @ApiModelProperty("主键ID")
    private Long id;

    @ExcelColumn(zh = "内部钢种", en = "stNo", order = 1)
    @ApiModelProperty(value = "内部钢种", required = true)
    private String stNo;

//    @ExcelColumn(zh = "钢种描述", en = "stDescribe", order = 2)
//    @ApiModelProperty(value = "钢种描述")
//    private String stDescribe;

    @ExcelColumn(zh = "是否可组板", en = "doFlg", order = 2)
    @ApiModelProperty(value = "是否可组板")
    private BigDecimal doFlg;

    @ExcelColumn(zh = "最低成材率", en = "rate", order = 3)
    @ApiModelProperty(value = "最低成材率")
    private BigDecimal rate;

    @ExcelColumn(zh = "创建时间", en = "creationDate", order = 4)
    @ApiModelProperty(value = "创建时间")
    private Date creationDate;

    @ExcelColumn(zh = "创建人", en = "createdBy", order = 5)
    @ApiModelProperty(value = "创建人")
    private Long createdBy;

    @ExcelColumn(zh = "修改时间", en = "lastUpdateDate", order = 6)
    @ApiModelProperty(value = "修改时间")
    private Date lastUpdateDate;

    @ExcelColumn(zh = "修改人", en = "lastUpdatedBy", order = 7)
    @ApiModelProperty(value = "修改人")
    private Long lastUpdatedBy;
}
