package com.xisc.pm.api.dto.export;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hzero.export.annotation.ExcelColumn;
import org.hzero.export.annotation.ExcelSheet;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author BKGY  MYT
 */
@ExcelSheet(zh = "仓库交货配置表", en = "PmRetainStack")
@Data
public class PmRetainStackDTO {
    @ApiModelProperty("主键ID")
    private Long id;

    @ExcelColumn(zh = "垛位号", en = "stackNo", order = 1)
    @ApiModelProperty(value = "stackNo", required = true)
    private String stackNo;

    @ExcelColumn(zh = "厂别", en = "mainBacklogCode", order = 2)
    @ApiModelProperty(value = "厂别")
    private String mainBacklogCode;

    @ExcelColumn(zh = "是否可替代", en = "doFlg", order = 3)
    @ApiModelProperty(value = "是否可替代")
    private BigDecimal doFlg;

    @ExcelColumn(zh = "备注", en = "remark", order = 4)
    @ApiModelProperty(value = "备注")
    private BigDecimal remark;

    @ExcelColumn(zh = "创建时间", en = "creationDate", order = 5)
    @ApiModelProperty(value = "创建时间")
    private Date creationDate;

    @ExcelColumn(zh = "创建人", en = "createdBy", order = 6)
    @ApiModelProperty(value = "创建人")
    private Long createdBy;

    @ExcelColumn(zh = "修改时间", en = "lastUpdateDate", order = 7)
    @ApiModelProperty(value = "修改时间")
    private Date lastUpdateDate;

    @ExcelColumn(zh = "修改人", en = "lastUpdatedBy", order = 8)
    @ApiModelProperty(value = "修改人")
    private Long lastUpdatedBy;
}
