package com.xisc.pm.api.dto.export;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hzero.export.annotation.ExcelColumn;
import org.hzero.export.annotation.ExcelSheet;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/8/27 19:48
 */
@ExcelSheet(zh = "特殊钢种余量增加表", en = "PmSpeStAddvBt")
@Data
public class PmSpeStAddvBtDTO implements Serializable {
    private static final long serialVersionUID = -8368451707409188099L;

    @ApiModelProperty("主键ID")
    private Long pssabId;

    @ApiModelProperty(value = "产线号")
    private String mscLineNo;

    @ExcelColumn(zh = "产线号", en = "mscLineNoDesc" ,order = 1)
    @ApiModelProperty(value = "产线号含义")
    private String mscLineNoDesc;

    @ExcelColumn(zh = "内部钢种", en = "stNo" ,order = 2)
    @ApiModelProperty(value = "内部钢种")
    private String stNo;

    @ExcelColumn(zh = "外部牌号", en = "sgSign" ,order = 3)
    @ApiModelProperty(value = "外部牌号")
    private String sgSign;

    @ExcelColumn(zh = "板坯厚度起", en = "slabThickFrom" ,order = 4)
    @ApiModelProperty(value = "板坯厚度起")
    private BigDecimal slabThickFrom;

    @ExcelColumn(zh = "板坯厚度止", en = "slabThickTo" ,order = 5)
    @ApiModelProperty(value = "板坯厚度止")
    private BigDecimal slabThickTo;

    @ExcelColumn(zh = "钢板厚度起", en = "plateThickFrom" ,order = 6)
    @ApiModelProperty(value = "钢板厚度起")
    private BigDecimal plateThickFrom;

    @ExcelColumn(zh = "钢板厚度止", en = "plateThickTo" ,order = 7)
    @ApiModelProperty(value = "钢板厚度止")
    private BigDecimal plateThickTo;

    @ExcelColumn(zh = "板坯加料", en = "slabAddv" ,order = 8)
    @ApiModelProperty(value = "板坯加料")
    private BigDecimal slabAddv;

    @ApiModelProperty(value = "有效标识")
    private String validFlag;


    @ExcelColumn(zh = "有效标识", en = "validFlag" ,order = 9)
    @ApiModelProperty(value = "有效标识含义")
    private String validFlagDesc;

    @ApiModelProperty(value = "租户ID")
    private Long tenantId;
}
