package com.xisc.pm.api.dto.export;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hzero.export.annotation.ExcelColumn;
import org.hzero.export.annotation.ExcelSheet;

import java.io.Serializable;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/9/25 14:05
 */
@ExcelSheet(zh = "强度级别对照基准表", en = "PmStCodeBtDTO")
@Data
public class PmStCodeBtDTO implements Serializable {

    private static final long serialVersionUID = 3174386881058122511L;

    @ExcelColumn(zh = "强度级别代码", en = "stCode", order = 1)
    @ApiModelProperty(value = "强度级别代码")
    private String stCode;

    @ExcelColumn(zh = "内部钢种", en = "stNo", order = 2)
    @ApiModelProperty(value = "内部钢种")
    private String stNo;

    @ExcelColumn(zh = "描述", en = "stDesc", order = 3)
    @ApiModelProperty(value = "描述/备注")
    private String stDesc;

    @ApiModelProperty(value = "轧制产线号")
    private String rollLineNo;

    @ExcelColumn(zh = "轧制产线号", en = "rollLineNo", order = 4)
    @ApiModelProperty(value = "轧制产线号")
    private String rollLineNoDesc;

}
