package com.xisc.pm.app.service;

import com.xisc.pm.domain.entity.PmCmdLargePlt;
import com.xisc.pm.domain.entity.PmPdPlateCut;
import com.xisc.pm.domain.vo.PmCmdVO;

import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;

import java.util.List;
import java.util.Map;

/**
 * 命令大板表(PmCmdLargePlt)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-08-01 10:24:39
 */
public interface PmCmdLargePltService {

    /**
     * 查询数据
     *
     * @param pageRequest    分页参数
     * @param pmCmdLargePlts 查询条件
     * @return 返回值
     */
    Page<PmCmdLargePlt> selectList(PageRequest pageRequest, PmCmdLargePlt pmCmdLargePlts);

    /**
     * 保存数据
     *
     * @param pmCmdLargePlts 数据
     */
    void saveData(List<PmCmdLargePlt> pmCmdLargePlts);

    /**
     * 查询大板粗切信息
     *
     * @param pageRequest
     * @param pdMatNoList
     * @param tenantId
     * @return
     */
    Page<PmPdPlateCut> selectplatelist(PageRequest pageRequest, List<String> pdMatNoList, Long tenantId);
    
    /**
     * 通过命令板坯号查询命令参数信息
     * @param ponoSlabNoList
     * @return
     */
    Map<String , PmCmdVO> queryCmdVo(List<String> ponoSlabNoList ,Long tenantId , boolean existsPmCmdSlab);
}

