package com.xisc.pm.app.service;

import com.xisc.pm.api.dto.PmCtCollectPoolReqDTO;
import com.xisc.pm.api.dto.PmCtCollectPoolResDTO;

import java.util.List;

/**
 * 组炉合同收池
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/8/22 14:19
 */
public interface PmCtCollectPoolService {

    /**
     * 组炉合同收池查询
     *
     * @param dto      查询参数
     * @param tenantId 租户
     * @return
     */
    List<PmCtCollectPoolResDTO> list(PmCtCollectPoolReqDTO dto, Long tenantId);

    /**
     * 合同收池
     *
     * @param tenantId    租户
     * @param poolResList 合同列表集合
     */
    void collectList(Long tenantId, List<PmCtCollectPoolResDTO> poolResList);

    /**
     * 超投
     * @param tenantId
     * @param dto
     */
    void overOrderList(Long tenantId, List<PmCtCollectPoolResDTO> dtoList);
}
