package com.xisc.pm.app.service;

import com.xisc.pm.common.dto.PmIngotThickAddvBtDTO;
import com.xisc.pm.domain.entity.PmIngotThickAddvBt;
import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;

import java.util.List;

/**
 * 钢锭厚度余量基准表(PmIngotThickAddvBt)应用服务
 *
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-09-05 15:15:06
 */
public interface PmIngotThickAddvBtService {

    /**
     * 查询数据
     *
     * @param pageRequest        分页参数
     * @param pmIngotThickAddvBt 查询条件
     * @return 返回值
     */
    Page<PmIngotThickAddvBt> selectList(PageRequest pageRequest, PmIngotThickAddvBt pmIngotThickAddvBt);

    /**
     * 保存数据
     *
     * @param tenantId               租户
     * @param pmIngotThickAddvBtList 对象集合
     */
    void saveData(Long tenantId, List<PmIngotThickAddvBt> pmIngotThickAddvBtList);

    /**
     * 删除数据
     *
     * @param pmIngotThickAddvBtList 对象集合
     */
    void deleteForUi(List<PmIngotThickAddvBt> pmIngotThickAddvBtList);

    /**
     * 导出
     * @param pmIngotThickAddvBt
     * @return
     */
    List<PmIngotThickAddvBtDTO> exportList(PmIngotThickAddvBt pmIngotThickAddvBt, Long tenantId);

    /**
     * 获取唯一键
     *
     * @param pmIngotThickAddvBt
     * @return
     */
    String getAddvKey(PmIngotThickAddvBt pmIngotThickAddvBt);
}

