package com.xisc.pm.app.service;

import com.xisc.pm.domain.entity.PmIngotYieldBt;
import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;

import java.util.List;

/**
 * 钢锭收得率基准表(PmIngotYieldBt)应用服务
 *
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-09-05 15:20:29
 */
public interface PmIngotYieldBtService {

    /**
     * 查询数据
     *
     * @param pageRequest    分页参数
     * @param pmIngotYieldBt 查询条件
     * @return 返回值
     */
    Page<PmIngotYieldBt> selectList(PageRequest pageRequest, PmIngotYieldBt pmIngotYieldBt);

    /**
     * 保存数据
     *
     * @param tenantId           租户
     * @param pmIngotYieldBtList 对象集合
     */
    void saveData(Long tenantId, List<PmIngotYieldBt> pmIngotYieldBtList);

    /**
     * 删除数据
     *
     * @param pmIngotYieldBtList 对象
     */
    void deleteForUi(List<PmIngotYieldBt> pmIngotYieldBtList);
}

