package com.xisc.pm.app.service;

import com.xisc.pm.api.dto.export.PmMidSlabAddvBtDTO;
import com.xisc.pm.domain.entity.PmMidSlabAddvBt;
import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;

import java.util.List;

/**
 * 低碳钢坯加余量基准表(PmMidSlabAddvBt)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-09-18 18:31:21
 */
public interface PmMidSlabAddvBtService {

    /**
     * 查询数据
     *
     * @param pageRequest     分页参数
     * @param pmMidSlabAddvBt 查询条件
     * @return 返回值
     */
    Page<PmMidSlabAddvBt> selectList(PageRequest pageRequest, PmMidSlabAddvBt pmMidSlabAddvBt);

    /**
     * 保存数据
     *
     * @param tenantId            租户
     * @param pmMidSlabAddvBtList 对象集合
     */
    void saveData(Long tenantId, List<PmMidSlabAddvBt> pmMidSlabAddvBtList);

    /**
     * 删除数据
     *
     * @param pmMidSlabAddvBtList 对象集合
     */
    void deleteForUi(List<PmMidSlabAddvBt> pmMidSlabAddvBtList);

    /**
     * 导出
     *
     * @param tenantId        租户
     * @param pmMidSlabAddvBt 对象集合
     * @return
     */
    List<PmMidSlabAddvBtDTO> exportList(Long tenantId, PmMidSlabAddvBt pmMidSlabAddvBt);

    /**
     * 获取唯一键key
     * @param pmMidSlabAddvBt
     * @return
     */
    String getPlateFromKey(PmMidSlabAddvBt pmMidSlabAddvBt);
}

