package com.xisc.pm.app.service;

import com.xisc.pm.api.dto.export.PmMoldSpecBtDTO;
import com.xisc.pm.domain.entity.PmMoldSpecBt;
import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;

import java.util.List;

/**
 * 结晶器规格基准表(PmMoldSpecBt)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-22 14:11:31
 */
public interface PmMoldSpecBtService {

    /**
     * 查询数据
     *
     * @param pageRequest      分页参数
     * @param pmMoldSpecBtList 查询条件
     * @return 返回值
     */
    Page<PmMoldSpecBt> selectList(PageRequest pageRequest, PmMoldSpecBt pmMoldSpecBtList);

    /**
     * 保存数据
     *
     * @param tenantId         租户
     * @param pmMoldSpecBtList 对象集合
     */
    void saveData(Long tenantId, List<PmMoldSpecBt> pmMoldSpecBtList);

    /**
     * 删除数据
     *
     * @param pmMoldSpecBtList 数据
     */
    void deleteForUi(List<PmMoldSpecBt> pmMoldSpecBtList);

    /**
     * 导出数据
     *
     * @param tenantId     租户
     * @param pmMoldSpecBt 查询参数
     * @return
     */
    List<PmMoldSpecBtDTO> exportList(Long tenantId, PmMoldSpecBt pmMoldSpecBt);
}

