package com.xisc.pm.app.service;

import com.xisc.pm.domain.entity.PmPdRecCfg;

import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;
/**
 * 组板履历事件配置表应用服务
 *
 * @author 曾俊 jun.zeng@hand-china.com 2024-07-31 08:01:12
 */
public interface PmPdRecCfgService {

    /**
    * 组板履历事件配置表查询参数
    *
    * @param tenantId 租户ID
    * @param pmPdRecCfg 组板履历事件配置表
    * @param pageRequest 分页
    * @return 组板履历事件配置表列表
    */
    Page<PmPdRecCfg> list(Long tenantId, PmPdRecCfg pmPdRecCfg, PageRequest pageRequest);

    /**
     * 组板履历事件配置表详情
     *
     * @param tenantId 租户ID
     * @param pprcId 主键
     * @return 组板履历事件配置表列表
     */
    PmPdRecCfg detail(Long tenantId, Long pprcId);

    /**
     * 创建组板履历事件配置表
     *
     * @param tenantId 租户ID
     * @param pmPdRecCfg 组板履历事件配置表
     * @return 组板履历事件配置表
     */
    PmPdRecCfg create(Long tenantId, PmPdRecCfg pmPdRecCfg);

    /**
     * 更新组板履历事件配置表
     *
     * @param tenantId 租户ID
     * @param pmPdRecCfg 组板履历事件配置表
     * @return 组板履历事件配置表
     */
    PmPdRecCfg update(Long tenantId, PmPdRecCfg pmPdRecCfg);

    /**
     * 删除组板履历事件配置表
     *
     * @param pmPdRecCfg 组板履历事件配置表
     */
    void remove(PmPdRecCfg pmPdRecCfg);
}
