package com.xisc.pm.app.service;

import com.xisc.pm.api.dto.export.PmPlateCutLenBtDTO;
import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;
import com.xisc.pm.domain.entity.PmPlateCutLenBt;

import java.util.List;

/**
 * 钢板切缝切头尾范围基准表(PmPlateCutLenBt)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-24 09:26:44
 */
public interface PmPlateCutLenBtService {

    /**
     * 查询数据
     *
     * @param pageRequest     分页参数
     * @param pmPlateCutLenBt 查询条件
     * @return 返回值
     */
    Page<PmPlateCutLenBt> selectList(PageRequest pageRequest, PmPlateCutLenBt pmPlateCutLenBt);

    /**
     * 保存数据
     *
     * @param tenantId            租户
     * @param pmPlateCutLenBtList 数据集合
     */
    void saveData(Long tenantId, List<PmPlateCutLenBt> pmPlateCutLenBtList);

    /**
     * 删除数据
     *
     * @param pmPlateCutLenBtList 对象集合
     */
    void deleteForUi(List<PmPlateCutLenBt> pmPlateCutLenBtList);

    /**
     * 导出
     *
     * @param pmPlateCutLenBt 查询条件
     * @return
     */
    List<PmPlateCutLenBtDTO> exportList(PmPlateCutLenBt pmPlateCutLenBt);

    /**
     * 获取的校验区间key
     *
     * @param pmPlateCutLenBt 对象
     * @return
     */
    String getPlateFromKey(PmPlateCutLenBt pmPlateCutLenBt);

}

