package com.xisc.pm.app.service;

import com.xisc.pm.api.dto.export.PmPlateTrimBtDTO;
import com.xisc.pm.domain.entity.PmPlateTrimBt;
import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;

import java.util.List;

/**
 * 钢板切边量基准表(PmPlateTrimBt)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-24 10:37:38
 */
public interface PmPlateTrimBtService {

    /**
     * 查询数据
     *
     * @param pageRequest   分页参数
     * @param pmPlateTrimBt 查询条件
     * @return 返回值
     */
    Page<PmPlateTrimBt> selectList(PageRequest pageRequest, PmPlateTrimBt pmPlateTrimBt);

    /**
     * 保存数据
     *
     * @param tenantId          租户
     * @param pmPlateTrimBtList 对象集合
     */
    void saveData(Long tenantId, List<PmPlateTrimBt> pmPlateTrimBtList);

    /**
     * 删除数据
     *
     * @param pmPlateTrimBtList 对象集合
     */
    void deleteForUi(List<PmPlateTrimBt> pmPlateTrimBtList);

    /**
     * 导出
     *
     * @param pmPlateTrimBt 查询条件
     * @return
     */
    List<PmPlateTrimBtDTO> exportList(PmPlateTrimBt pmPlateTrimBt);

    /**
     * 获取唯一性key
     *
     * @param pmPlateTrimBt 对象集合
     * @return
     */
    String getTmpKey(PmPlateTrimBt pmPlateTrimBt);
}

