package com.xisc.pm.app.service;

import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;
import com.xisc.pm.domain.entity.PmPonoWtStaticGd;

import java.util.List;

/**
 * 炉重静态表_钢锭(PmPonoWtStaticGd)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-25 09:41:25
 */
public interface PmPonoWtStaticGdService {

    /**
     * 查询数据
     *
     * @param pageRequest      分页参数
     * @param pmPonoWtStaticGd 查询条件
     * @return 返回值
     */
    Page<PmPonoWtStaticGd> selectList(PageRequest pageRequest, PmPonoWtStaticGd pmPonoWtStaticGd);

    /**
     * 保存数据
     *
     * @param tenantId             租户
     * @param pmPonoWtStaticGdList 对象集合
     */
    void saveData(Long tenantId, List<PmPonoWtStaticGd> pmPonoWtStaticGdList);

    /**
     * 删除数据
     *
     * @param pmPonoWtStaticGdList 对象集合
     */
    void deleteForUi(List<PmPonoWtStaticGd> pmPonoWtStaticGdList);
}

