package com.xisc.pm.app.service;

import com.xisc.pm.domain.entity.PmPonoWtStatic;
import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;

import java.util.List;

/**
 * 炉重静态表(PmPonoWtStatic)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-25 09:12:13
 */
public interface PmPonoWtStaticService {

    /**
     * 查询数据
     *
     * @param pageRequest    分页参数
     * @param pmPonoWtStatic 查询条件
     * @return 返回值
     */
    Page<PmPonoWtStatic> selectList(PageRequest pageRequest, PmPonoWtStatic pmPonoWtStatic);

    /**
     * 保存数据
     *
     * @param tenantId           租户
     * @param pmPonoWtStaticList 对象集合
     */
    void saveData(Long tenantId, List<PmPonoWtStatic> pmPonoWtStaticList);

    /**
     * 删除数据
     *
     * @param pmPonoWtStaticList 对象集合
     */
    void deleteForUi(List<PmPonoWtStatic> pmPonoWtStaticList);
}

