package com.xisc.pm.app.service;

import com.xisc.pm.api.dto.PmProductionLineDTO;
import com.xisc.pm.domain.entity.PmProductionLine;
import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;

import java.util.List;

/**
 * 生产线表(PmProductionLine)应用服务
 *
 * @author jie.yang04@hand-china.com
 * @since 2024-10-09 09:42:01
 */
public interface PmProductionLineService {

    /**
     * 查询数据
     *
     * @param pageRequest 分页参数
     * @param productionLineDTO 查询条件
     * @return 返回值
     */
    Page<PmProductionLineDTO> selectList(PageRequest pageRequest, Long tenantId, PmProductionLineDTO productionLineDTO);

    /**
     * 保存数据
     * @param tenantId 租户ID
     * @param pmProductionLines 数据
     */
    void saveData(Long tenantId, List<PmProductionLine> pmProductionLines);


    /**
     * 删除数据
     *
     * @param tenantId 租户id
     * @param prodLineIds prod线id
     *
     *
     */
    void deleteData(Long tenantId, List<Long> prodLineIds);

}

