package com.xisc.pm.app.service;

import com.xisc.pm.domain.entity.PmSampleReserveBt;
import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;

import java.util.List;

/**
 * 预留试样基表(PmSampleReserveBt)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-12-18 15:15:14
 */
public interface PmSampleReserveBtService {

    /**
     * 查询数据
     *
     * @param pageRequest        分页参数
     * @param pmSampleReserveBt 查询条件
     * @return 返回值
     */
    Page<PmSampleReserveBt> selectList(PageRequest pageRequest, PmSampleReserveBt pmSampleReserveBt);

    /**
     * 保存数据
     *
     * @param pmSampleReserveBtList
     * @param tenantId
     */
    void saveData(List<PmSampleReserveBt> pmSampleReserveBtList, Long tenantId);

    /**
     * 删除
     *
     * @param tenantId
     * @param pmSampleReserveBtList
     */
    void deleteUi(Long tenantId, List<PmSampleReserveBt> pmSampleReserveBtList);
}

