package com.xisc.pm.app.service;

import com.xisc.pm.domain.entity.PmSlabLenConfig;
import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;

import java.util.List;

/**
 * 板坯组矩长度配置表(PmSlabLenConfig)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-25 10:30:14
 */
public interface PmSlabLenConfigService {

    /**
     * 查询数据
     *
     * @param pageRequest     分页参数
     * @param pmSlabLenConfig 查询条件
     * @return 返回值
     */
    Page<PmSlabLenConfig> selectList(PageRequest pageRequest, PmSlabLenConfig pmSlabLenConfig);

    /**
     * 保存数据
     *
     * @param tenantId            租户
     * @param pmSlabLenConfigList 对象集合
     */
    void saveData(Long tenantId, List<PmSlabLenConfig> pmSlabLenConfigList);

    /**
     * 删除数据
     *
     * @param pmSlabLenConfigList 对象集合
     */
    void deleteForUi(List<PmSlabLenConfig> pmSlabLenConfigList);
}

