package com.xisc.pm.app.service;

import com.xisc.pm.api.dto.PmSlabMethodDTO;
import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;
import com.xisc.pm.domain.entity.PmSlabMethod;

import java.util.List;

/**
 * 生产线组板方式表(PmSlabMethod)应用服务
 *
 * @author jie.yang04@hand-china.com
 * @since 2024-10-09 09:43:34
 */
public interface PmSlabMethodService {

    /**
     * 查询数据
     *
     * @param pageRequest 分页参数
     * @param pmSlabMethods 查询条件
     * @return 返回值
     */
    Page<PmSlabMethod> selectList(PageRequest pageRequest, PmSlabMethod pmSlabMethods);

    /**
     * 按prod生产线id列表选择
     *
     * @param pageRequest 页面请求
     * @param tenantId 租户id
     * @param prodLineId prod生产线编号
     * @return {@link Page }<{@link PmSlabMethod }>
     *
     */
    Page<PmSlabMethodDTO> selectByProdLineIdList(PageRequest pageRequest, Long tenantId, Long prodLineId);

    /**
     * 保存数据
     * @param pmSlabMethods 数据
     */
    void saveData(Long tenantId, List<PmSlabMethod> pmSlabMethods);

    /**
     * 删除数据
     *
     * @param tenantId 租户id
     * @param prodLineStatsIds prod line stats ids
     *
     *
     */
    void deleteData(Long tenantId, List<Long> prodLineStatsIds);

}

