package com.xisc.pm.app.service;

import com.xisc.pm.api.dto.export.PmSlabReplBtDTO;
import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;
import com.xisc.pm.domain.entity.PmSlabReplBt;

import java.util.List;

/**
 * 余材组板内部钢种以优充次对照表(PmSlabReplBt)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-24 11:30:29
 */
public interface PmSlabReplBtService {

    /**
     * 查询数据
     *
     * @param pageRequest  分页参数
     * @param pmSlabReplBt 查询条件
     * @return 返回值
     */
    Page<PmSlabReplBt> selectList(PageRequest pageRequest, PmSlabReplBt pmSlabReplBt);

    /**
     * 保存数据
     *
     * @param tenantId         租户
     * @param pmSlabReplBtList 对象集合
     */
    void saveData(Long tenantId, List<PmSlabReplBt> pmSlabReplBtList);

    /**
     * 删除数据
     *
     * @param pmSlabReplBtList 兑现集合
     */
    void deleteForUi(List<PmSlabReplBt> pmSlabReplBtList);

    /**
     * 导出
     *
     * @param pmSlabReplBt 查询条件
     * @return
     */
    List<PmSlabReplBtDTO> exportList(PmSlabReplBt pmSlabReplBt);
}

