package com.xisc.pm.app.service;

import com.xisc.pm.domain.entity.PmSlabSpecBt;
import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;

import java.util.List;

/**
 * 连铸板坯生产规格基准表(PmSlabSpecBt)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-23 08:24:45
 */
public interface PmSlabSpecBtService {

    /**
     * 查询数据
     *
     * @param pageRequest      分页参数
     * @param pmSlabSpecBtList 查询条件
     * @return 返回值
     */
    Page<PmSlabSpecBt> selectList(PageRequest pageRequest, PmSlabSpecBt pmSlabSpecBtList);

    /**
     * 保存数据
     *
     * @param tenantId         租户
     * @param pmSlabSpecBtList 对象列表
     */
    void saveData(Long tenantId, List<PmSlabSpecBt> pmSlabSpecBtList);

    /**
     * 删除数据
     *
     * @param pmSlabSpecBtList 删除的对象列表
     */
    void deleteForUi(List<PmSlabSpecBt> pmSlabSpecBtList);
}

