package com.xisc.pm.app.service;

import com.xisc.pm.api.dto.export.PmSpeStAddvBtDTO;
import com.xisc.pm.domain.entity.PmSpeStAddvBt;
import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;

import java.util.List;

/**
 * 特殊钢种余量增加表(PmSpeStAddvBt)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-25 08:50:16
 */
public interface PmSpeStAddvBtService {

    /**
     * 查询数据
     *
     * @param pageRequest   分页参数
     * @param pmSpeStAddvBt 查询条件
     * @return 返回值
     */
    Page<PmSpeStAddvBt> selectList(PageRequest pageRequest, PmSpeStAddvBt pmSpeStAddvBt);

    /**
     * 保存数据
     *
     * @param tenantId          租户
     * @param pmSpeStAddvBtList 对象集合
     */
    void saveData(Long tenantId, List<PmSpeStAddvBt> pmSpeStAddvBtList);

    /**
     * 删除数据
     *
     * @param pmSpeStAddvBtList 对象集合
     */
    void deleteForUi(List<PmSpeStAddvBt> pmSpeStAddvBtList);

    /**
     * 导出
     *
     * @param pmSpeStAddvBt 查询对象
     * @return
     */
    List<PmSpeStAddvBtDTO> exportList(PmSpeStAddvBt pmSpeStAddvBt);

    /**
     * 获取唯一性key
     *
     * @param pmSpeStAddvBt 对象
     * @return
     */
    String getTmpKey(PmSpeStAddvBt pmSpeStAddvBt);
}

