package com.xisc.pm.app.service.autoboard.dto;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;
import java.util.Map;
import java.util.Set;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 自动组板策略
 * 
 * @author jun.zeng
 *
 */
@Data
public class PmAutoBoardPolicyDTO implements Serializable {

    private static final long serialVersionUID = 3139320309463761440L;

    // 设计产线
    private String mscLineNo;

    // 策略ID
    private Long policyId;

    // 策略编码
    private String policyCode;

    // 断面
    List<PmAutoBoardMoldDTO> moldList;

    // 钢种
    Set<String> stNoList;

    // 组板方式
    List<String> formModeCodeList;

    // 收货单位，可为空，为空表示全部
    private String consignCust;

    // 重要客户
    private Map<String, Long> customerVip;

    @ApiModelProperty(value = "A2板型宽度偏差", required = true)
    private BigDecimal a2WidDeviation;

    @ApiModelProperty(value = "钢种经济批量下限", required = true)
    private BigDecimal stLowerEconomicLots;

    @ApiModelProperty(value = "客户经济批量下限", required = true)
    private BigDecimal custLowerEconomicLots;
    
    // 产线生产产能
    private BigDecimal prodLineProductivity;

}
