package com.xisc.pm.app.service.impl;

import com.xisc.pm.app.service.PmSdivStLimitBtTraService;
import com.xisc.pm.domain.entity.PmSdivStLimitBtTra;
import com.xisc.pm.domain.repository.PmSdivStLimitBtTraRepository;
import io.choerodon.core.domain.Page;
import io.choerodon.mybatis.pagehelper.PageHelper;
import io.choerodon.mybatis.pagehelper.domain.PageRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

/**
 * 剖分组板钢种限制表履历表(PmSdivStLimitBtTra)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-25 08:15:56
 */
@Service
public class PmSdivStLimitBtTraServiceImpl implements PmSdivStLimitBtTraService {
    @Autowired
    private PmSdivStLimitBtTraRepository pmSdivStLimitBtTraRepository;

    @Override
    public Page<PmSdivStLimitBtTra> selectList(PageRequest pageRequest, PmSdivStLimitBtTra pmSdivStLimitBtTra) {
        return PageHelper.doPageAndSort(pageRequest, () -> pmSdivStLimitBtTraRepository.selectList(pmSdivStLimitBtTra));
    }

    @Override
    public void saveData(List<PmSdivStLimitBtTra> pmSdivStLimitBtTras) {
        List<PmSdivStLimitBtTra> insertList = pmSdivStLimitBtTras.stream().filter(line -> line.getTraId() == null).collect(Collectors.toList());
        List<PmSdivStLimitBtTra> updateList = pmSdivStLimitBtTras.stream().filter(line -> line.getTraId() != null).collect(Collectors.toList());
        pmSdivStLimitBtTraRepository.batchInsertSelective(insertList);
        pmSdivStLimitBtTraRepository.batchUpdateByPrimaryKeySelective(updateList);
    }
}

