package com.xisc.pm.domain.entity;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonInclude;

import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * 热处理实绩表
 *
 * @author 曾俊 jun.zeng@hand-china.com 2024-08-27 13:39:27
 */
@Setter
@Getter
@ApiModel("热处理实绩表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "MM_HTMRSLT")
public class MmHtmrslt extends AuditDomain {

    public static final String FIELD_HTMRSLT_ID = "htmrsltId";
    public static final String FIELD_MAT_NO = "matNo";
    public static final String FIELD_HTM_SEQ = "htmSeq";
    public static final String FIELD_OCCR_CD = "occrCd";
    public static final String FIELD_STOCK_CODE = "stockCode";
    public static final String FIELD_MAT_ACT_THK = "matActThk";
    public static final String FIELD_MAT_ACT_WID = "matActWid";
    public static final String FIELD_MAT_ACT_LEN = "matActLen";
    public static final String FIELD_MAT_THEORY_WGT = "matTheoryWgt";
    public static final String FIELD_HOT_TREAT_METHOD_CODE = "hotTreatMethodCode";
    public static final String FIELD_HEAT_TREAT_FURNACE_NO = "heatTreatFurnaceNo";
    public static final String FIELD_LOAD_FUR_TIME = "loadFurTime";
    public static final String FIELD_HEAT_TIME = "heatTime";
    public static final String FIELD_SHIFT = "shift";
    public static final String FIELD_GROUP_CD = "groupCd";
    public static final String FIELD_PROD_EMP = "prodEmp";
    public static final String FIELD_SPECIAL_ASK = "specialAsk";
    public static final String FIELD_IF_EXIST_FILE = "ifExistFile";
    public static final String FIELD_MAT_PLAN_SEQ_NO = "matPlanSeqNo";
    public static final String FIELD_SUB_BACKLOG_CODE = "subBacklogCode";
    public static final String FIELD_SUB_BACKLOG_SEQ = "subBacklogSeq";
    public static final String FIELD_BACKLOG_ADD_DIV = "backlogAddDiv";
    public static final String FIELD_ST_NO = "stNo";
    public static final String FIELD_PROD_CODE_HP = "prodCodeHp";
    public static final String FIELD_STD_SG_CODE = "stdSgCode";
    public static final String FIELD_COOL_PATTERN_CODE = "coolPatternCode";
    public static final String FIELD_COOL_AIM_TEMP = "coolAimTemp";
    public static final String FIELD_QUENCH_FIN_TIME = "quenchFinTime";
    public static final String FIELD_HEAT_TREAT_KEEP = "heatTreatKeep";
    public static final String FIELD_HEAT_TREAT_KEEP_TIME = "heatTreatKeepTime";
    public static final String FIELD_HEAT_TREAT_STAY_TIME = "heatTreatStayTime";
    public static final String FIELD_PLATE_TEMP_AVRG = "plateTempAvrg";
    public static final String FIELD_PLATE_TEMP_SURF = "plateTempSurf";
    public static final String FIELD_PLATE_TEMP_MID = "plateTempMid";
    public static final String FIELD_TEMP_PYROMET = "tempPyromet";
    public static final String FIELD_CHARGE_SPEED = "chargeSpeed";
    public static final String FIELD_DISCHARG_SPEED = "dischargSpeed";
    public static final String FIELD_SWING_MODE = "swingMode";
    public static final String FIELD_HARDNESS_DEGREE_MIC = "hardnessDegreeMic";
    public static final String FIELD_TEMP_QUENCH_WATER = "tempQuenchWater";
    public static final String FIELD_QUENCH_SPEED = "quenchSpeed";
    public static final String FIELD_BACKFIRE_SET_VAL = "backfireSetVal";
    public static final String FIELD_BACKFIRE_SET_HARDNESS_VAL = "backfireSetHardnessVal";
    public static final String FIELD_BACKFIRE_MODEL_TIME = "backfireModelTime";
    public static final String FIELD_QUENCH_COUNT_HARD = "quenchCountHard";
    public static final String FIELD_STRENGTH_WARM_QTY = "strengthWarmQty";
    public static final String FIELD_STRENGTH_BEND_WARM_QTY = "strengthBendWarmQty";
    public static final String FIELD_PLATE_TEMP_AVRG_T = "plateTempAvrgT";
    public static final String FIELD_PLATE_TEMP_SURF_T = "plateTempSurfT";
    public static final String FIELD_PLATE_TEMP_MID_T = "plateTempMidT";
    public static final String FIELD_PLATE_TEMP_AVRG_M = "plateTempAvrgM";
    public static final String FIELD_PLATE_TEMP_SURF_M = "plateTempSurfM";
    public static final String FIELD_PLATE_TEMP_MID_M = "plateTempMidM";
    public static final String FIELD_PLATE_TEMP_AVRG_B = "plateTempAvrgB";
    public static final String FIELD_PLATE_TEMP_SURF_B = "plateTempSurfB";
    public static final String FIELD_PLATE_TEMP_MID_B = "plateTempMidB";
    public static final String FIELD_SHOT_BLAST_FLAG = "shotBlastFlag";
    public static final String FIELD_SHOT_BLAST_TIME = "shotBlastTime";
    public static final String FIELD_BETTER_SURF_WARD_CODE = "betterSurfWardCode";
    public static final String FIELD_MAT_SHAPE_FLAG = "matShapeFlag";
    public static final String FIELD_MAT_THICK1 = "matThick1";
    public static final String FIELD_MAT_THICK2 = "matThick2";
    public static final String FIELD_MAT_THICK3 = "matThick3";
    public static final String FIELD_MAT_LEN1 = "matLen1";
    public static final String FIELD_MAT_LEN2 = "matLen2";
    public static final String FIELD_MAT_LEN3 = "matLen3";
    public static final String FIELD_MAT_LEN4 = "matLen4";
    public static final String FIELD_MAT_LEN5 = "matLen5";
    public static final String FIELD_REMARK = "remark";
    public static final String FIELD_SPARE_FIELD1 = "spareField1";
    public static final String FIELD_SPARE_FIELD2 = "spareField2";
    public static final String FIELD_SPARE_FIELD3 = "spareField3";
    public static final String FIELD_SPARE_FIELD4 = "spareField4";
    public static final String FIELD_SPARE_FIELD5 = "spareField5";
    public static final String FIELD_SPARE_FIELD6 = "spareField6";
    public static final String FIELD_SPARE_FIELD7 = "spareField7";
    public static final String FIELD_SPARE_FIELD8 = "spareField8";
    public static final String FIELD_SPARE_FIELD9 = "spareField9";
    public static final String FIELD_SPARE_FIELD10 = "spareField10";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_OBJECT_VERSION_NUMBER = "objectVersionNumber";
    public static final String FIELD_CREATION_DATE = "creationDate";
    public static final String FIELD_CREATED_BY = "createdBy";
    public static final String FIELD_LAST_UPDATED_BY = "lastUpdatedBy";
    public static final String FIELD_LAST_UPDATE_DATE = "lastUpdateDate";
    public static final String FIELD_STORE_LINE = "storeLine";
    public static final String FIELD_PLAN_NO = "planNo";

    @ApiModelProperty("表ID，主键")
    @Id
    @GeneratedValue
    private Long htmrsltId;
    @ApiModelProperty(value = "钢板号", required = true)
    @NotBlank
    private String matNo;
    @ApiModelProperty(value = "热处理顺序号")
    private Long htmSeq;
    @ApiModelProperty(value = "发生代码", required = true)
    @NotBlank
    private String occrCd;
    @ApiModelProperty(value = "库区代码(作用:全线委外时候知道这些实绩在哪个库做的)")
    private String stockCode;
    @ApiModelProperty(value = "材料实际厚度")
    private Long matActThk;
    @ApiModelProperty(value = "材料实际宽度")
    private Long matActWid;
    @ApiModelProperty(value = "材料实际长度")
    private Long matActLen;
    @ApiModelProperty(value = "材料理论重量")
    private Long matTheoryWgt;
    @ApiModelProperty(value = "热处理方式代码")
    private String hotTreatMethodCode;
    @ApiModelProperty(value = "热处理炉号")
    private String heatTreatFurnaceNo;
    @ApiModelProperty(value = "装炉时间")
    private String loadFurTime;
    @ApiModelProperty(value = "出炉时间")
    private String heatTime;
    @ApiModelProperty(value = "班次号")
    private String shift;
    @ApiModelProperty(value = "班组")
    private String groupCd;
    @ApiModelProperty(value = "生产责任者")
    private String prodEmp;
    @ApiModelProperty(value = "特殊要求")
    private String specialAsk;
    @ApiModelProperty(value = "是否存在文件")
    private String ifExistFile;
    @ApiModelProperty(value = "材料命令顺序号")
    private String matPlanSeqNo;
    @ApiModelProperty(value = "小工序代码")
    private String subBacklogCode;
    @ApiModelProperty(value = "小工序顺序号")
    private Long subBacklogSeq;
    @ApiModelProperty(value = "工序追加区分")
    private String backlogAddDiv;
    @ApiModelProperty(value = "出钢记号/内部钢种")
    private String stNo;
    @ApiModelProperty(value = "厚板品种代码")
    private String prodCodeHp;
    @ApiModelProperty(value = "标准牌号(钢级)代码")
    private String stdSgCode;
    @ApiModelProperty(value = "冷却方式")
    private String coolPatternCode;
    @ApiModelProperty(value = "冷却目标温度")
    private Long coolAimTemp;
    @ApiModelProperty(value = "淬火完成时间")
    private String quenchFinTime;
    @ApiModelProperty(value = "热处理炉保持温度（实绩）")
    private Long heatTreatKeep;
    @ApiModelProperty(value = "热处理炉保持时间")
    private Long heatTreatKeepTime;
    @ApiModelProperty(value = "热处理炉停留时间")
    private Long heatTreatStayTime;
    @ApiModelProperty(value = "板温度（平均）")
    private Long plateTempAvrg;
    @ApiModelProperty(value = "板温度（表面）")
    private Long plateTempSurf;
    @ApiModelProperty(value = "板温度（中央）")
    private Long plateTempMid;
    @ApiModelProperty(value = "板温度(表面,高温计测量)")
    private Long tempPyromet;
    @ApiModelProperty(value = "装入板速度")
    private Long chargeSpeed;
    @ApiModelProperty(value = "板离开速度")
    private Long dischargSpeed;
    @ApiModelProperty(value = "摆动模式")
    private String swingMode;
    @ApiModelProperty(value = "硬度等级")
    private String hardnessDegreeMic;
    @ApiModelProperty(value = "水淬火温度")
    private Long tempQuenchWater;
    @ApiModelProperty(value = "淬火速度")
    private Long quenchSpeed;
    @ApiModelProperty(value = "回火温度设定值")
    private Long backfireSetVal;
    @ApiModelProperty(value = "回火后硬度设定值")
    private Long backfireSetHardnessVal;
    @ApiModelProperty(value = "回火模型计算时间")
    private Long backfireModelTime;
    @ApiModelProperty(value = "淬火后计算硬度")
    private Long quenchCountHard;
    @ApiModelProperty(value = "模型计算抗张强度")
    private Long strengthWarmQty;
    @ApiModelProperty(value = "模型计算屈伸力")
    private Long strengthBendWarmQty;
    @ApiModelProperty(value = "头部钢板温度（平均）")
    private Long plateTempAvrgT;
    @ApiModelProperty(value = "头部钢板温度（表面）")
    private Long plateTempSurfT;
    @ApiModelProperty(value = "头部钢板温度（中央）")
    private Long plateTempMidT;
    @ApiModelProperty(value = "中部钢板温度（平均）")
    private Long plateTempAvrgM;
    @ApiModelProperty(value = "中部钢板温度（表面）")
    private Long plateTempSurfM;
    @ApiModelProperty(value = "中部钢板温度（中央）")
    private Long plateTempMidM;
    @ApiModelProperty(value = "尾部钢板温度（平均）")
    private Long plateTempAvrgB;
    @ApiModelProperty(value = "尾部钢板温度（表面）")
    private Long plateTempSurfB;
    @ApiModelProperty(value = "尾部钢板温度（中央）")
    private Long plateTempMidB;
    @ApiModelProperty(value = "是否抛丸")
    private String shotBlastFlag;
    @ApiModelProperty(value = "抛丸完成时时间")
    private String shotBlastTime;
    @ApiModelProperty(value = "表面朝向")
    private String betterSurfWardCode;
    @ApiModelProperty(value = "材料形态标志")
    private String matShapeFlag;
    @ApiModelProperty(value = "材料厚度1")
    private Long matThick1;
    @ApiModelProperty(value = "材料厚度2")
    private Long matThick2;
    @ApiModelProperty(value = "材料厚度3")
    private Long matThick3;
    @ApiModelProperty(value = "材料长度1")
    private Long matLen1;
    @ApiModelProperty(value = "材料长度2")
    private Long matLen2;
    @ApiModelProperty(value = "材料长度3")
    private Long matLen3;
    @ApiModelProperty(value = "材料长度4")
    private Long matLen4;
    @ApiModelProperty(value = "材料长度5")
    private Long matLen5;
    @ApiModelProperty(value = "备注")
    private String remark;
    @ApiModelProperty(value = "备用字段1")
    private String spareField1;
    @ApiModelProperty(value = "备用字段2")
    private String spareField2;
    @ApiModelProperty(value = "备用字段3")
    private String spareField3;
    @ApiModelProperty(value = "备用字段4")
    private String spareField4;
    @ApiModelProperty(value = "备用字段5")
    private String spareField5;
    @ApiModelProperty(value = "备用字段6")
    private Long spareField6;
    @ApiModelProperty(value = "备用字段7")
    private Long spareField7;
    @ApiModelProperty(value = "备用字段8")
    private Long spareField8;
    @ApiModelProperty(value = "备用字段9")
    private Long spareField9;
    @ApiModelProperty(value = "备用字段10")
    private Long spareField10;
    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;
    @ApiModelProperty(value = "行版本号，用来处理锁", required = true)
    @NotNull
    private Long objectVersionNumber;
    
    @ApiModelProperty(value = "库区产线")
    private String storeLine;
    @ApiModelProperty(value = "计划号")
    private String planNo;

}
