package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;


/**
 * 钢板小工序表(MmPlateSmallPro)实体类
 *
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-08-15 16:30:08
 */

@Getter
@Setter
@ApiModel("钢板小工序表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "MM_PLATE_SMALL_PRO")
public class MmPlateSmallPro extends AuditDomain implements Serializable {
    private static final long serialVersionUID = -29182522939338035L;

    public static final String FIELD_PRO_PLATE_ID = "proPlateId";
    public static final String FIELD_MAT_NO = "matNo";
    public static final String FIELD_STOCK_CODE = "stockCode";
    public static final String FIELD_SUB_BACKLOG_SEQ = "subBacklogSeq";
    public static final String FIELD_SUB_BACKLOG_CODE = "subBacklogCode";
    public static final String FIELD_BACKLOG_ADD_DIV = "backlogAddDiv";
    public static final String FIELD_BACKLOG_ADD_CAUSE_CODE = "backlogAddCauseCode";
    public static final String FIELD_BACKLOG_ADD_TIME = "backlogAddTime";
    public static final String FIELD_BACKLOG_ADD_EMP_ID = "backlogAddEmpId";
    public static final String FIELD_BACKLOG_PASS_TIME = "backlogPassTime";
    public static final String FIELD_BACKLOG_PASS_EMP_ID = "backlogPassEmpId";
    public static final String FIELD_BACKLOG_DECIDE_CODE = "backlogDecideCode";
    public static final String FIELD_ORDER_NO = "orderNo";
    public static final String FIELD_MAT_ACT_THK = "matActThk";
    public static final String FIELD_MAT_ACT_WID = "matActWid";
    public static final String FIELD_MAT_ACT_LEN = "matActLen";
    public static final String FIELD_MAT_ACT_WGT = "matActWgt";
    public static final String FIELD_ST_NO = "stNo";
    public static final String FIELD_SG_STD = "sgStd";
    public static final String FIELD_SPECIAL_ASK = "specialAsk";
    public static final String FIELD_IF_EXIST_FILE = "ifExistFile";
    public static final String FIELD_REMARK1 = "remark1";
    public static final String FIELD_SPARE_FIELD1 = "spareField1";
    public static final String FIELD_SPARE_FIELD2 = "spareField2";
    public static final String FIELD_SPARE_FIELD3 = "spareField3";
    public static final String FIELD_SPARE_FIELD4 = "spareField4";
    public static final String FIELD_SPARE_FIELD5 = "spareField5";
    public static final String FIELD_SPARE_FIELD6 = "spareField6";
    public static final String FIELD_SPARE_FIELD7 = "spareField7";
    public static final String FIELD_SPARE_FIELD8 = "spareField8";
    public static final String FIELD_SPARE_FIELD9 = "spareField9";
    public static final String FIELD_SPARE_FIELD10 = "spareField10";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_REMARK2 = "remark2";
    public static final String FIELD_REMARK3 = "remark3";

    @ApiModelProperty("表ID，主键")
    @Id
    @GeneratedValue
    private Long proPlateId;

    @ApiModelProperty(value = "钢板号", required = true)
    @NotBlank
    private String matNo;

    @ApiModelProperty(value = "库区代码(作用:全线委外时候知道这些实绩在哪个库做的)")
    private String stockCode;

    @ApiModelProperty(value = "小工序顺序号")
    private Long subBacklogSeq;

    @ApiModelProperty(value = "小工序代码")
    private String subBacklogCode;

    @ApiModelProperty(value = "工序追加区分")
    private String backlogAddDiv;

    @ApiModelProperty(value = "工序追加原因代码")
    private String backlogAddCauseCode;

    @ApiModelProperty(value = "工序追加时间")
    private Date backlogAddTime;

    @ApiModelProperty(value = "工序追加人")
    private String backlogAddEmpId;

    @ApiModelProperty(value = "工序通过时间")
    private Date backlogPassTime;

    @ApiModelProperty(value = "工序通过人")
    private String backlogPassEmpId;

    @ApiModelProperty(value = "工序是否合格(0:没做,1:不合格,2:合格)")
    private String backlogDecideCode;

    @ApiModelProperty(value = "合同号")
    private String orderNo;

    @ApiModelProperty(value = "钢板实际厚度", required = true)
    @NotNull
    private Long matActThk;

    @ApiModelProperty(value = "钢板实际宽度", required = true)
    @NotNull
    private Long matActWid;

    @ApiModelProperty(value = "钢板实际长度", required = true)
    @NotNull
    private Long matActLen;

    @ApiModelProperty(value = "钢板实际重量", required = true)
    @NotNull
    private Long matActWgt;

    @ApiModelProperty(value = "出钢记号/内部钢种")
    private String stNo;

    @ApiModelProperty(value = "标准")
    private String sgStd;

    @ApiModelProperty(value = "特殊要求")
    private String specialAsk;

    @ApiModelProperty(value = "是否存在文件")
    private String ifExistFile;

    @ApiModelProperty(value = "备注")
    private String remark1;

    @ApiModelProperty(value = "备用字段1")
    private String spareField1;

    @ApiModelProperty(value = "备用字段2")
    private String spareField2;

    @ApiModelProperty(value = "备用字段3")
    private String spareField3;

    @ApiModelProperty(value = "备用字段4")
    private String spareField4;

    @ApiModelProperty(value = "备用字段5")
    private String spareField5;

    @ApiModelProperty(value = "备用字段6")
    private Long spareField6;

    @ApiModelProperty(value = "备用字段7")
    private Long spareField7;

    @ApiModelProperty(value = "备用字段8")
    private Long spareField8;

    @ApiModelProperty(value = "备用字段9")
    private Long spareField9;

    @ApiModelProperty(value = "备用字段10")
    private Long spareField10;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    @ApiModelProperty(value = "备注2")
    private String remark2;

    @ApiModelProperty(value = "备注3")
    private String remark3;


}
