package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;


/**
 * 纵轧展宽宽度余量基准表(PmAxisBrdTrimBt)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-09-27 13:51:25
 */

@Getter
@Setter
@ApiModel("纵轧展宽宽度余量基准表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_AXIS_BRD_TRIM_BT")
public class PmAxisBrdTrimBt extends AuditDomain implements Serializable {
    private static final long serialVersionUID = 282109538218755686L;

    public static final String FIELD_PABTB_ID = "pabtbId";
    public static final String FIELD_ROLL_LINE_NO = "rollLineNo";
    public static final String FIELD_WITH_SIDE_FLAG = "withSideFlag";
    public static final String FIELD_WIDTH_ADDV = "widthAddv";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";
    public static final String FIELD_VALID_FLAG = "validFlag";

    @ApiModelProperty("主键ID")
    @Id
    @GeneratedValue
    private Long pabtbId;

    @ApiModelProperty(value = "轧制产线号", required = true)
    @NotBlank
    private String rollLineNo;

    @ApiModelProperty(value = "切边标记")
    private String withSideFlag;

    @ApiModelProperty(value = "宽度余量", required = true)
    @NotNull
    private BigDecimal widthAddv;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;

    @ApiModelProperty(value = "是否启用纵轧展宽")
    private Long validFlag;


}
