package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;


/**
 * 充当规则集(PmCdRuleSet)实体类
 *
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-08-16 10:57:16
 */

@Getter
@Setter
@ApiModel("充当规则集")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_CD_RULE_SET")
public class PmCdRuleSet extends AuditDomain implements Serializable {
    private static final long serialVersionUID = -50875576046675253L;

    public static final String FIELD_RULE_SET_ID = "ruleSetId";
    public static final String FIELD_VALID_FLAG = "validFlag";
    public static final String FIELD_RULE_NO = "ruleNo";
    public static final String FIELD_RULE_SET_TYPE = "ruleSetType";
    public static final String FIELD_RULE_SEQ_NO = "ruleSeqNo";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("表ID，主键")
    @Id
    @GeneratedValue
    private Long ruleSetId;

    @ApiModelProperty(value = "生效标记（0：不生效，1：生效）", required = true)
    @NotNull
    private Long validFlag;

    @ApiModelProperty(value = "规则号", required = true)
    @NotNull
    private Long ruleNo;

    @ApiModelProperty(value = "规则集类型", required = true)
    @NotBlank
    private String ruleSetType;

    @ApiModelProperty(value = "规则序号", required = true)
    @NotNull
    private Long ruleSeqNo;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;

    @ApiModelProperty(value = "规则描述")
    @Transient
    private String ruleDesc;

    @ApiModelProperty(value = "记录创建责任者")
    @Transient
    private String recCreator;

    @ApiModelProperty(value = "记录创建时刻")
    @Transient
    private String recCreateTime;

    @ApiModelProperty(value = "记录修改责任者")
    @Transient
    private String recRevisor;

    @ApiModelProperty(value = "记录修改时刻")
    @Transient
    private String recReviseTime;
}
