package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import java.io.Serializable;


/**
 * 复合板成品合同与基材合同对应关系表(PmCompositeOrderRel)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-09-25 09:20:37
 */

@Getter
@Setter
@ApiModel("复合板成品合同与基材合同对应关系表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_COMPOSITE_ORDER_REL")
public class PmCompositeOrderRel extends AuditDomain implements Serializable {
    private static final long serialVersionUID = 244380641836546834L;

    public static final String FIELD_REL_ID = "relId";
    public static final String FIELD_PRODUCT_ORDER_NO = "productOrderNo";
    public static final String FIELD_BASE_ORDER_NO = "baseOrderNo";
    public static final String FIELD_IP_ADDRESS = "ipAddress";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("表ID，主键")
    @Id
    @GeneratedValue
    private Long relId;

    @ApiModelProperty(value = "成品合同号")
    private String productOrderNo;

    @ApiModelProperty(value = "基材合同号")
    private String baseOrderNo;

    @ApiModelProperty(value = "维护人的IP地址")
    private String ipAddress;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


}
