package com.xisc.pm.domain.entity;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonInclude;

import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * 复合/叠轧坯分张命令表
 *
 * @author 曾俊 jun.zeng@hand-china.com 2024-09-05 10:20:49
 */
@Setter
@Getter
@ApiModel("复合/叠轧坯分张命令表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_COMPOSITE_SLAB_DIV")
public class PmCompositeSlabDiv extends AuditDomain {

    public static final String FIELD_DIV_ID = "divId";
    public static final String FIELD_PONO_SLAB = "ponoSlab";
    public static final String FIELD_AIM_PONO_SLAB = "aimPonoSlab";
    public static final String FIELD_LAYER_NO = "layerNo";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_OBJECT_VERSION_NUMBER = "objectVersionNumber";
    public static final String FIELD_CREATION_DATE = "creationDate";
    public static final String FIELD_CREATED_BY = "createdBy";
    public static final String FIELD_LAST_UPDATED_BY = "lastUpdatedBy";
    public static final String FIELD_LAST_UPDATE_DATE = "lastUpdateDate";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("表ID，主键")
    @Id
    @GeneratedValue
    private Long divId;
    @ApiModelProperty(value = "复合命令板坯号", required = true)
    @NotBlank
    private String ponoSlab;
    @ApiModelProperty(value = "分张命令板坯号", required = true)
    @NotBlank
    private String aimPonoSlab;
    @ApiModelProperty(value = "位置(从下至上依次为1,2,3…)", required = true)
    @NotNull
    private Long layerNo;
    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;
    @ApiModelProperty(value = "行版本号，用来处理锁", required = true)
    @NotNull
    private Long objectVersionNumber;
   
    @ApiModelProperty(value = "")
    private String attribute1;
    @ApiModelProperty(value = "")
    private String attribute2;
    @ApiModelProperty(value = "")
    private String attribute3;
    @ApiModelProperty(value = "")
    private String attribute4;
    @ApiModelProperty(value = "")
    private String attribute5;

}
