package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;


/**
 * 复合/叠轧坯明细信息表(PmCompositeSlabList)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-08-01 15:40:17
 */

@Getter
@Setter
@ApiModel("复合/叠轧坯明细信息表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_COMPOSITE_SLAB_LIST")
public class PmCompositeSlabList extends AuditDomain implements Serializable {
    private static final long serialVersionUID = -98856639319101647L;

    public static final String FIELD_LIST_ID = "listId";
    public static final String FIELD_SLAB_ID = "slabId";
    public static final String FIELD_LAYER_NO = "layerNo";
    public static final String FIELD_BASE_ORDER_ID = "baseOrderId";
    public static final String FIELD_BASE_ORDER_NO = "baseOrderNo";
    public static final String FIELD_BASE_MAT_ID = "baseMatId";
    public static final String FIELD_BASE_MAT_NO = "baseMatNo";
    public static final String FIELD_BASE_MAT_THICK = "baseMatThick";
    public static final String FIELD_BASE_MAT_WIDTH = "baseMatWidth";
    public static final String FIELD_BASE_MAT_LENGTH = "baseMatLength";
    public static final String FIELD_BASE_MAT_WT = "baseMatWt";
    public static final String FIELD_COMP_MAT_TYPE = "compMatType";
    public static final String FIELD_COMP_MAT_NO = "compMatNo";
    public static final String FIELD_COMP_MAT_PONO = "compMatPono";
    public static final String FIELD_COMP_MAT_NUM = "compMatNum";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("表ID，主键")
    @Id
    @GeneratedValue
    private Long listId;

    @ApiModelProperty(value = "复合/叠轧坯ID", required = true)
    @NotNull
    private Long slabId;

    @ApiModelProperty(value = "层号(从上至下依次为1,2,3…)", required = true)
    @NotNull
    private Long layerNo;

    @ApiModelProperty(value = "基材合同ID")
    private Long baseOrderId;

    @ApiModelProperty(value = "基材合同号")
    private String baseOrderNo;

    @ApiModelProperty(value = "基材ID")
    private Long baseMatId;

    @ApiModelProperty(value = "基材号")
    private String baseMatNo;

    @ApiModelProperty(value = "基材厚度")
    private BigDecimal baseMatThick;

    @ApiModelProperty(value = "基材宽度")
    private BigDecimal baseMatWidth;

    @ApiModelProperty(value = "基材长度")
    private BigDecimal baseMatLength;

    @ApiModelProperty(value = "基材重量")
    private BigDecimal baseMatWt;

    @ApiModelProperty(value = "复材类型代码(定义见代码手册)")
    private String compMatType;

    @ApiModelProperty(value = "复材材料号")
    private String compMatNo;

    @ApiModelProperty(value = "复材炉号")
    private String compMatPono;

    @ApiModelProperty(value = "复材块数")
    private Long compMatNum;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;

    @ApiModelProperty(value = "复材id")
    private Long compMatId;


}
