package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;


/**
 * 合同指定产线断面表(PmContractLineSpec)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-10-12 09:37:25
 */

@Getter
@Setter
@ApiModel("合同指定产线断面表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_CONTRACT_LINE_SPEC")
public class PmContractLineSpec extends AuditDomain implements Serializable {
    private static final long serialVersionUID = 743037839360302650L;

    public static final String FIELD_ORDER_SPECTION_ID = "orderSpectionId";
    public static final String FIELD_ORDER_NO = "orderNo";
    public static final String FIELD_ASSIGNED_PROD_LINE_ID = "assignedProdLineId";
    public static final String FIELD_MOLD_THICK = "moldThick";
    public static final String FIELD_MOLD_WID = "moldWid";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("合同指定ID")
    @Id
    @GeneratedValue
    private Long orderSpectionId;

    @ApiModelProperty(value = "合同号", required = true)
    @NotBlank
    private String orderNo;

    @ApiModelProperty(value = "指定产线ID", required = true)
    @NotNull
    private Long assignedProdLineId;

    @ApiModelProperty(value = "断面厚")
    private BigDecimal moldThick;

    @ApiModelProperty(value = "断面宽")
    private BigDecimal moldWid;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


}
