package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;


/**
 * 组炉默认热处理去向配置表(PmHotConfig)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-29 16:13:12
 */

@Getter
@Setter
@ApiModel("组炉默认热处理去向配置表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_HOT_CONFIG")
public class PmHotConfig extends AuditDomain implements Serializable {
    private static final long serialVersionUID = 665358446863942055L;

    public static final String FIELD_ID = "id";
    public static final String FIELD_HEAT_TREAT_MODE = "heatTreatMode";
    public static final String FIELD_MSC_LINE_NO = "mscLineNo";
    public static final String FIELD_DEFAULT_DEST = "defaultDest";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";
    public static final String FIELD_PLATE_THICK_FROM = "plateThickFrom";
    public static final String FIELD_PLATE_THICK_TO = "plateThickTo";
    public static final String FIELD_PLATE_WID_FROM = "plateWidFrom";
    public static final String FIELD_PLATE_WID_TO = "plateWidTo";
    public static final String FIELD_PLATE_LEN_FROM = "plateLenFrom";
    public static final String FIELD_PLATE_LEN_TO = "plateLenTo";

    @Id
    @GeneratedValue
    private Long id;

    @ApiModelProperty(value = "热处理模式")
    private String heatTreatMode;

    @ApiModelProperty(value = "默认热处理去向")
    private String defaultDest;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;

    @ApiModelProperty(value = "钢板厚度起")
    private BigDecimal plateThickFrom;

    @ApiModelProperty(value = "钢板厚度止")
    private BigDecimal plateThickTo;

    @ApiModelProperty(value = "钢板宽度起")
    private BigDecimal plateWidFrom;

    @ApiModelProperty(value = "钢板宽度止")
    private BigDecimal plateWidTo;

    @ApiModelProperty(value = "钢板长度起")
    private BigDecimal plateLenFrom;

    @ApiModelProperty(value = "钢板长度止")
    private BigDecimal plateLenTo;

    @ApiModelProperty(value = "产线号")
    private String mscLineNo;


}
