package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;


/**
 * 结晶器规格基准表(PmMoldSpecBt)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-22 14:11:31
 */

@Getter
@Setter
@ApiModel("结晶器规格基准表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_MOLD_SPEC_BT")
public class PmMoldSpecBt extends AuditDomain implements Serializable {
    private static final long serialVersionUID = -29665356092174058L;

    public static final String FIELD_PMSB_ID = "pmsbId";
    public static final String FIELD_CC_TYPE = "ccType";
    public static final String FIELD_CC_DESC = "ccDesc";
    public static final String FIELD_CAST_THICK = "castThick";
    public static final String FIELD_CAST_WIDTH = "castWidth";
    public static final String FIELD_MSC_LINE_NO = "mscLineNo";
    public static final String FIELD_TENANT_ID = "tenantId";

    @ApiModelProperty("主键ID")
    @Id
    @GeneratedValue
    private Long pmsbId;

    @ApiModelProperty(value = "连铸机类型", required = true)
    @NotBlank
    private String ccType;

    @ApiModelProperty(value = "连铸机描述", required = true)
    @NotBlank
    private String ccDesc;

    @ApiModelProperty(value = "铸造厚", required = true)
    @NotNull
    private BigDecimal castThick;

    @ApiModelProperty(value = "铸造宽", required = true)
    @NotNull
    private BigDecimal castWidth;

    @ApiModelProperty(value = "设计产线号", required = true)
    @NotBlank
    private String mscLineNo;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;


}
