package com.xisc.pm.domain.entity;

import java.math.BigDecimal;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonInclude;

import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * 组合子板位置表
 *
 * @author 曾俊 jun.zeng@hand-china.com 2024-08-02 08:02:38
 */
@Setter
@Getter
@ApiModel("组合子板位置表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_PD_BLOCK_POS")
public class PmPdBlockPos extends AuditDomain {

    public static final String FIELD_PD_BLOCK_POS_ID = "pdBlockPosId";
    public static final String FIELD_PD_MAT_NO = "pdMatNo";
    public static final String FIELD_ORDER_BLOCK_NO = "orderBlockNo";
    public static final String FIELD_ORDER_NO = "orderNo";
    public static final String FIELD_PRO_CONT_ID = "proContId";
    public static final String FIELD_ORDER_SEQ_NO = "orderSeqNo";
    public static final String FIELD_BLOCK_PLATE_NUM = "blockPlateNum";
    public static final String FIELD_SLAB_NO = "slabNo";
    public static final String FIELD_PLATE_NO = "plateNo";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_OBJECT_VERSION_NUMBER = "objectVersionNumber";
    public static final String FIELD_CREATION_DATE = "creationDate";
    public static final String FIELD_CREATED_BY = "createdBy";
    public static final String FIELD_LAST_UPDATED_BY = "lastUpdatedBy";
    public static final String FIELD_LAST_UPDATE_DATE = "lastUpdateDate";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("主键ID")
    @Id
    @GeneratedValue
    private Long pdBlockPosId;
    @ApiModelProperty(value = "组板材料号")
    private String pdMatNo;
    @ApiModelProperty(value = "厚板组板块号")
    private Long orderBlockNo;
    @ApiModelProperty(value = "合同号")
    private String orderNo;
    @ApiModelProperty(value = "生产合同主表主键", required = true)
    @NotNull
    private Long proContId;
    @ApiModelProperty(value = "合同顺序号")
    private Long orderSeqNo;
    @ApiModelProperty(value = "子板小板块数")
    private BigDecimal blockPlateNum;
    @ApiModelProperty(value = "板坯号")
    private String slabNo;
    @ApiModelProperty(value = "钢板号")
    private String plateNo;
    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;
    @ApiModelProperty(value = "行版本号，用来处理锁", required = true)
    @NotNull
    private Long objectVersionNumber;
    @ApiModelProperty(value = "")
    private String attribute1;
    @ApiModelProperty(value = "")
    private String attribute2;
    @ApiModelProperty(value = "")
    private String attribute3;
    @ApiModelProperty(value = "")
    private String attribute4;
    @ApiModelProperty(value = "")
    private String attribute5;

}
