package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 组板合同总量表(PmPdContSumTra)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-11-26 10:56:18
 */

@Getter
@Setter
@ApiModel("组板合同总量表-履历表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_PD_CONT_SUM_TRA")
public class PmPdContSumTra extends AuditDomain {
    private static final long serialVersionUID = 231211895224565461L;

    public static final String FIELD_TRA_ID = "traId";
    public static final String FIELD_OPERATION_TYPE = "operationType";
    public static final String FIELD_OPERATION_USER = "operationUser";
    public static final String FIELD_OPERATION_TIME = "operationTime";
    public static final String FIELD_PPCS_ID = "ppcsId";
    public static final String FIELD_PRO_CONT_ID = "proContId";
    public static final String FIELD_PD_MAT_NO = "pdMatNo";
    public static final String FIELD_ORDER_NO = "orderNo";
    public static final String FIELD_ORDER_SEQ_NO = "orderSeqNo";
    public static final String FIELD_ORDER_PLATE_NUM = "orderPlateNum";
    public static final String FIELD_PD_MAT_TYPE = "pdMatType";
    public static final String FIELD_SLAB_NO = "slabNo";
    public static final String FIELD_PLATE_NO = "plateNo";
    public static final String FIELD_PD_STATUS = "pdStatus";
    public static final String FIELD_AXIS_FLAG = "axisFlag";
    public static final String FIELD_ORDER_THICK = "orderThick";
    public static final String FIELD_ORDER_WIDTH = "orderWidth";
    public static final String FIELD_ORDER_LEN = "orderLen";
    public static final String FIELD_ORDER_LEN_MIN = "orderLenMin";
    public static final String FIELD_ORDER_LEN_MAX = "orderLenMax";
    public static final String FIELD_SMALL_PLATE_THICK = "smallPlateThick";
    public static final String FIELD_SMALL_PLATE_WIDTH = "smallPlateWidth";
    public static final String FIELD_SMALL_PLATE_LEN = "smallPlateLen";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("履历主键ID")
    @Id
    @GeneratedValue
    private Long traId;

    @ApiModelProperty(value = "操作类型(I:插入，U:修改，D:删除)", required = true)
    @NotBlank
    private String operationType;

    @ApiModelProperty(value = "操作者", required = true)
    @NotBlank
    private String operationUser;

    @ApiModelProperty(value = "操作时间", required = true)
    @NotNull
    private Date operationTime;

    @ApiModelProperty(value = "合同ID", required = true)
    @NotNull
    private Long ppcsId;

    @ApiModelProperty(value = "生产合同主表主键", required = true)
    @NotNull
    private Long proContId;

    @ApiModelProperty(value = "组板材料号")
    private String pdMatNo;

    @ApiModelProperty(value = "合同号")
    private String orderNo;

    @ApiModelProperty(value = "合同顺序号")
    private Long orderSeqNo;

    @ApiModelProperty(value = "大板小板块数")
    private Long orderPlateNum;

    @ApiModelProperty(value = "组板材料类型")
    private String pdMatType;

    @ApiModelProperty(value = "板坯号")
    private String slabNo;

    @ApiModelProperty(value = "钢板号")
    private String plateNo;

    @ApiModelProperty(value = "组板状态")
    private String pdStatus;

    @ApiModelProperty(value = "轴合同标记", required = true)
    @NotNull
    private Long axisFlag;

    @ApiModelProperty(value = "订货厚度", required = true)
    @NotNull
    private BigDecimal orderThick;

    @ApiModelProperty(value = "订货宽度", required = true)
    @NotNull
    private BigDecimal orderWidth;

    @ApiModelProperty(value = "订货长度", required = true)
    @NotNull
    private BigDecimal orderLen;

    @ApiModelProperty(value = "订货长度下限", required = true)
    @NotNull
    private BigDecimal orderLenMin;

    @ApiModelProperty(value = "订货长度上限", required = true)
    @NotNull
    private BigDecimal orderLenMax;

    @ApiModelProperty(value = "小板厚度", required = true)
    @NotNull
    private BigDecimal smallPlateThick;

    @ApiModelProperty(value = "小板宽度", required = true)
    @NotNull
    private BigDecimal smallPlateWidth;

    @ApiModelProperty(value = "小板长度", required = true)
    @NotNull
    private BigDecimal smallPlateLen;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


}

