package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.Date;


/**
 * 钢板轧制规格基准表履历表(PmPlateSpecBtTra)实体类
 *
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-09-06 08:37:17
 */

@Getter
@Setter
@ApiModel("钢板轧制规格基准表履历表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_PLATE_SPEC_BT_TRA")
public class PmPlateSpecBtTra extends AuditDomain implements Serializable {
    private static final long serialVersionUID = -72398430760227270L;

    public static final String FIELD_TRA_ID = "traId";
    public static final String FIELD_OPERATION_TYPE = "operationType";
    public static final String FIELD_OPERATION_USER = "operationUser";
    public static final String FIELD_OPERATION_TIME = "operationTime";
    public static final String FIELD_PPTAB_ID = "pptabId";
    public static final String FIELD_ST_CODE = "stCode";
    public static final String FIELD_FORM_PLATE_MODE = "formPlateMode";
    public static final String FIELD_AD_TYPE_MODE = "adTypeMode";
    public static final String FIELD_ROLL_MODE = "rollMode";
    public static final String FIELD_WHOLE_HEAT_TREATMENT_TYPE = "wholeHeatTreatmentType";
    public static final String FIELD_ROLL_LINE_NO = "rollLineNo";
    public static final String FIELD_PLATE_THICK_FROM = "plateThickFrom";
    public static final String FIELD_PLATE_THICK_TO = "plateThickTo";
    public static final String FIELD_COMBINE_PLATE_WIDTH_FROM = "combinePlateWidthFrom";
    public static final String FIELD_COMBINE_PLATE_WIDTH_TO = "combinePlateWidthTo";
    public static final String FIELD_COMBINE_PLATE_LEN_MAX = "combinePlateLenMax";
    public static final String FIELD_REMARK = "remark";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("履历主键ID")
    @Id
    @GeneratedValue
    private Long traId;

    @ApiModelProperty(value = "操作类型(I:插入，U:修改，D:删除)", required = true)
    @NotBlank
    private String operationType;

    @ApiModelProperty(value = "操作者", required = true)
    @NotBlank
    private String operationUser;

    @ApiModelProperty(value = "操作时间", required = true)
    @NotNull
    private Date operationTime;

    @ApiModelProperty(value = "主键ID", required = true)
    @NotNull
    private Long pptabId;

    @ApiModelProperty(value = "强度级别代码", required = true)
    @NotBlank
    private String stCode;

    @ApiModelProperty(value = "组板方式", required = true)
    @NotBlank
    private String formPlateMode;

    @ApiModelProperty(value = "AD模式，分为D和ND")
    private String adTypeMode;

    @ApiModelProperty(value = "轧制模式, * 匹配所有轧制模式", required = true)
    @NotBlank
    private String rollMode;

    @ApiModelProperty(value = "全程热处理类型，Q（全程热处理类型含Q），* 匹配全部热处理类型", required = true)
    @NotBlank
    private String wholeHeatTreatmentType;

    @ApiModelProperty(value = "轧制产线号", required = true)
    @NotBlank
    private String rollLineNo;

    @ApiModelProperty(value = "钢板厚度起", required = true)
    @NotNull
    private Long plateThickFrom;

    @ApiModelProperty(value = "钢板厚度止", required = true)
    @NotNull
    private Long plateThickTo;

    @ApiModelProperty(value = "组合板宽度起", required = true)
    @NotNull
    private Long combinePlateWidthFrom;

    @ApiModelProperty(value = "组合板宽度止", required = true)
    @NotNull
    private Long combinePlateWidthTo;

    @ApiModelProperty(value = "组合板长度上限", required = true)
    @NotNull
    private Long combinePlateLenMax;

    @ApiModelProperty(value = "备注说明")
    private String remark;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


}
