package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;


/**
 * 组炉规则配置表-履历表(PmPnsortTra)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-09-11 16:00:11
 */

@Getter
@Setter
@ApiModel("组炉规则配置表-履历表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_PNSORT_TRA")
public class PmPnsortTra extends AuditDomain implements Serializable {
    private static final long serialVersionUID = 482562411949543253L;

    public static final String FIELD_TRA_ID = "traId";
    public static final String FIELD_OPERATION_TYPE = "operationType";
    public static final String FIELD_OPERATION_USER = "operationUser";
    public static final String FIELD_OPERATION_TIME = "operationTime";
    public static final String FIELD_ID = "id";
    public static final String FIELD_MAIN_BACKLOG_CODE = "mainBacklogCode";
    public static final String FIELD_CC_TYPE = "ccType";
    public static final String FIELD_PRIORITY1 = "priority1";
    public static final String FIELD_PRIORITY2 = "priority2";
    public static final String FIELD_PRIORITY3 = "priority3";
    public static final String FIELD_PRIORITY4 = "priority4";
    public static final String FIELD_PRIORITY5 = "priority5";
    public static final String FIELD_PRIORITY6 = "priority6";
    public static final String FIELD_PRIORITY7 = "priority7";
    public static final String FIELD_PRIORITY8 = "priority8";
    public static final String FIELD_SORT_FLAG = "sortFlag";
    public static final String FIELD_VALID_FLAG = "validFlag";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("履历主键ID")
    @Id
    @GeneratedValue
    private Long traId;

    @ApiModelProperty(value = "操作类型(I:插入，U:修改，D:删除)", required = true)
    @NotBlank
    private String operationType;

    @ApiModelProperty(value = "操作者", required = true)
    @NotBlank
    private String operationUser;

    @ApiModelProperty(value = "操作时间", required = true)
    @NotNull
    private Date operationTime;

    @ApiModelProperty(value = "${column.comment}", required = true)
    @NotNull
    private Long id;

    @ApiModelProperty(value = "厂别")
    private String mainBacklogCode;

    @ApiModelProperty(value = "连铸机类型")
    private String ccType;

    @ApiModelProperty(value = "排序优先级1")
    private String priority1;

    @ApiModelProperty(value = "排序优先级2")
    private String priority2;

    @ApiModelProperty(value = "排序优先级3")
    private String priority3;

    @ApiModelProperty(value = "排序优先级4")
    private String priority4;

    @ApiModelProperty(value = "排序优先级5")
    private String priority5;

    @ApiModelProperty(value = "排序优先级6")
    private String priority6;

    @ApiModelProperty(value = "排序优先级7")
    private String priority7;

    @ApiModelProperty(value = "排序优先级8")
    private String priority8;

    @ApiModelProperty(value = "降序/升序")
    private String sortFlag;

    @ApiModelProperty(value = "生效标记")
    private String validFlag;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


}
