package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

/**
 * 策略组与评价指标关系表(PmPolicyGrKpi)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-11-08 12:29:11
 */

@Getter
@Setter
@ApiModel("策略组与评价指标关系表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_POLICY_GR_KPI")
public class PmPolicyGrKpi extends AuditDomain {
    private static final long serialVersionUID = 310377559720469707L;

    public static final String FIELD_POLICY_GROUP_KPI_ID = "policyGroupKpiId";
    public static final String FIELD_POLICY_GROUP_ID = "policyGroupId";
    public static final String FIELD_KPI_TYPE = "kpiType";
    public static final String FIELD_KPI_PERCENT = "kpiPercent";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("预设请求策略与评价指标关系ID")
    @Id
    @GeneratedValue
    private Long policyGroupKpiId;

    @ApiModelProperty(value = "策略组ID", required = true)
    @NotNull
    private Long policyGroupId;

    @ApiModelProperty(value = "评价指标类型", required = true)
    @NotBlank
    private String kpiType;

    @ApiModelProperty(value = "评价指标百分比", required = true)
    @NotNull
    private BigDecimal kpiPercent;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


}

