package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

/**
 * 策略组与合同分组表(PmPolictGrOrder)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-11-08 12:28:51
 */

@Getter
@Setter
@ApiModel("策略组与合同分组表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_POLICY_GR_ORDER")
public class PmPolicyGrOrder extends AuditDomain {
    private static final long serialVersionUID = -93303410464151317L;

    public static final String FIELD_POLICY_GROUP_ORDER_ID = "policyGroupOrderId";
    public static final String FIELD_POLICY_GROUP_ID = "policyGroupId";
    public static final String FIELD_PRIORITY = "priority";
    public static final String FIELD_GROUP_DIMENSION = "groupDimension";
    public static final String FIELD_GROUP_SEQ = "groupSeq";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("策略组与合同分组头ID")
    @Id
    @GeneratedValue
    private Long policyGroupOrderId;

    @ApiModelProperty(value = "策略组ID", required = true)
    @NotNull
    private Long policyGroupId;

    @ApiModelProperty(value = "优先级", required = true)
    @NotNull
    private Long priority;

    @ApiModelProperty(value = "分组维度，逗号分隔", required = true)
    @NotBlank
    private String groupDimension;

    @ApiModelProperty(value = "分组排序，逗号分隔", required = true)
    @NotNull
    private String groupSeq;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


}

