package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 策略组扩展表(PmPolicyGroupAttr)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-11-14 15:58:27
 */

@Getter
@Setter
@ApiModel("策略组扩展表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_POLICY_GROUP_ATTR")
public class PmPolicyGroupAttr extends AuditDomain {
    private static final long serialVersionUID = -62756652359517742L;

    public static final String FIELD_POLICY_GROUP_ID = "policyGroupId";
    public static final String FIELD_PRIORITY_DELIVY_DATE_TO = "priorityDelivyDateTo";
    public static final String FIELD_PRIORITY_CONTRACT_ALLOWANCE = "priorityContractAllowance";
    public static final String FIELD_CLEAR_DELIVY_DATE_TO = "clearDelivyDateTo";
    public static final String FIELD_CLEAR_CONTRACT_ALLOWANCE = "clearContractAllowance";
    public static final String FIELD_SINGLE_YIELD = "singleYield";
    public static final String FIELD_A2_WID_DEVIATION = "a2WidDeviation";
    public static final String FIELD_OVERCAST_QTY = "overcastQty";
    public static final String FIELD_OVERCAST_DELIVY_DATE_TO = "overcastDelivyDateTo";
    public static final String FIELD_DESIGN_LENGTH_MAX = "designLengthMax";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("策略组ID")
    @Id
    @GeneratedValue
    private Long policyGroupId;

    @ApiModelProperty(value = "尾量优先-交货期止", required = true)
    @NotNull
    private Date priorityDelivyDateTo;

    @ApiModelProperty(value = "尾量优先-合约欠量", required = true)
    @NotNull
    private BigDecimal priorityContractAllowance;

    @ApiModelProperty(value = "尾量清零-交货期止")
    private Date clearDelivyDateTo;

    @ApiModelProperty(value = "尾量清零-合约欠量")
    private BigDecimal clearContractAllowance;

    @ApiModelProperty(value = "单板收得率")
    private BigDecimal singleYield;

    @ApiModelProperty(value = "A2板型宽度偏差")
    private BigDecimal a2WidDeviation;

    @ApiModelProperty(value = "允许超投件数")
    private BigDecimal overcastQty;

    @ApiModelProperty(value = "允许超投交货期止")
    private Date overcastDelivyDateTo;

    @ApiModelProperty(value = "指定长上限")
    private BigDecimal designLengthMax;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


}

