package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

/**
 * 策略组与策略关系表(PmPolicyGroupRel)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-11-08 09:39:41
 */

@Getter
@Setter
@ApiModel("策略组与策略关系表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_POLICY_GROUP_REL")
public class PmPolicyGroupRel extends AuditDomain {
    private static final long serialVersionUID = 625878561804150374L;

    public static final String FIELD_POLICY_GROUP_REL_ID = "policyGroupRelId";
    public static final String FIELD_POLICY_GROUP_ID = "policyGroupId";
    public static final String FIELD_POLICY_ID = "policyId";
    public static final String FIELD_SEQ = "seq";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("策略组与策略关系ID")
    @Id
    @GeneratedValue
    private Long policyGroupRelId;

    @ApiModelProperty(value = "策略组ID", required = true)
    @NotNull
    private Long policyGroupId;

    @ApiModelProperty(value = "策略ID", required = true)
    @NotBlank
    private String policyId;

    @ApiModelProperty(value = "排序", required = true)
    @NotNull
    private Long seq;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


    @Transient
    @ApiModelProperty(value = "策略编码")
    private String policyCodeValue;


}

