package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;


/**
 * 策略合同分组明细(PmPolicyOrderDtl)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-10-16 10:45:40
 */

@Getter
@Setter
@ApiModel("策略合同分组明细")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_POLICY_ORDER_DTL")
@Deprecated
public class PmPolicyOrderDtl extends AuditDomain implements Serializable {
    private static final long serialVersionUID = 938977638845599967L;

    public static final String FIELD_TEST_ID = "testId";
    public static final String FIELD_POLICY_GROUP_ID = "policyGroupId";
    public static final String FIELD_GROUP_DIMENSION = "groupDimension";
    public static final String FIELD_GROUP_SEQ = "groupSeq";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";
    public static final String FIELD_POLICY_ID = "policyId";

    @ApiModelProperty("策略与合同分组行ID")
    @Id
    @GeneratedValue
    private Long testId;

    @ApiModelProperty(value = "策略分组组ID", required = true)
    @NotNull
    private Long policyGroupId;

    @ApiModelProperty(value = "分组维度", required = true)
    @NotBlank
    private String groupDimension;

    @ApiModelProperty(value = "组内顺序", required = true)
    @NotNull
    private Long groupSeq;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;

    @ApiModelProperty(value = "策略ID", required = true)
    @NotNull
    private Long policyId;

}
