package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;


/**
 * 策略信息与断面关系表(PmPolicySection)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-10-16 10:46:26
 */

@Getter
@Setter
@ApiModel("策略信息与断面关系表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_POLICY_SECTION")
public class PmPolicySection extends AuditDomain implements Serializable {
    private static final long serialVersionUID = 390965780175797681L;

    public static final String FIELD_POLICY_SECTION_ID = "policySectionId";
    public static final String FIELD_POLICY_ID = "policyId";
    public static final String FIELD_MOLD_THICK = "moldThick";
    public static final String FIELD_MOLD_WID = "moldWid";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_PRIORITY = "priority";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("策略与断面关系ID")
    @Id
    @GeneratedValue
    private Long policySectionId;

    @ApiModelProperty(value = "策略ID", required = true)
    @NotNull
    private Long policyId;

    @ApiModelProperty(value = "断面厚", required = true)
    @NotNull
    private BigDecimal moldThick;

    @ApiModelProperty(value = "断面宽", required = true)
    @NotNull
    private BigDecimal moldWid;
    
    @ApiModelProperty(value = "优先级", required = true)
    @NotNull
    private Long priority;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


}
