package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;


/**
 * 策略信息与重要客户关系表(PmPolicyVip)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-10-16 10:48:16
 */

@Getter
@Setter
@ApiModel("策略信息与重要客户关系表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_POLICY_VIP")
public class PmPolicyVip extends AuditDomain implements Serializable {
    private static final long serialVersionUID = -64133219284852235L;

    public static final String FIELD_POLICY_VIP_CUST_ID = "policyVipCustId";
    public static final String FIELD_POLICY_ID = "policyId";
    public static final String FIELD_CUSTOMER_CODE = "customerCode";
    public static final String FIELD_PRIORITY = "priority";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("策略信息与重要客户关系ID")
    @Id
    @GeneratedValue
    private Long policyVipCustId;

    @ApiModelProperty(value = "策略ID", required = true)
    @NotNull
    private Long policyId;

    @ApiModelProperty(value = "客户编码", required = true)
    @NotBlank
    private String customerCode;

    @ApiModelProperty(value = "优先级", required = true)
    @NotNull
    private Long priority;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


}
