package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;


/**
 * 产线断面关系表(PmProdLineSection)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-10-10 09:19:36
 */

@Getter
@Setter
@ApiModel("产线断面关系表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_PROD_LINE_SECTION")
public class PmProdLineSection extends AuditDomain implements Serializable {
    private static final long serialVersionUID = 457731811235995443L;

    public static final String FIELD_PROD_LINE_SECTION_ID = "prodLineSectionId";
    public static final String FIELD_PROD_LINE_ID = "prodLineId";
    public static final String FIELD_MOLD_THICK = "moldThick";
    public static final String FIELD_MOLD_WID = "moldWid";
    public static final String FIELD_PRIORITY = "priority";
    public static final String FIELD_VALID_FLAG = "validFlag";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("产线断面关系ID")
    @Id
    @GeneratedValue
    private Long prodLineSectionId;

    @ApiModelProperty(value = "产线ID", required = true)
    @NotNull
    private Long prodLineId;

    @ApiModelProperty(value = "断面厚度", required = true)
    @NotNull
    private BigDecimal moldThick;

    @ApiModelProperty(value = "断面宽度", required = true)
    @NotNull
    private BigDecimal moldWid;

    @ApiModelProperty(value = "优先级", required = true)
    @NotNull
    private Long priority;

    @ApiModelProperty(value = "生效标记", required = true)
    @NotNull
    private Long validFlag;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;

    @Transient
    @ApiModelProperty(value = "产线ID")
    private List<Long> prodLineIdList;

    @Transient
    @ApiModelProperty(value = "产线编码")
    private String prodLineCode;

    @Transient
    @ApiModelProperty(value = "产线描述")
    private String prodLineName;

    @Transient
    @ApiModelProperty(value = "操作人名称")
    private String createdByName;

    @Transient
    @ApiModelProperty(value = "更新人名称")
    private String lastUpdatedByName;


}
