package com.xisc.pm.domain.entity;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonInclude;

import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * 请求策略与合同分组头表
 *
 * @author jun.zeng 2024-11-25 14:56:45
 */
@Setter
@Getter
@ApiModel("请求策略与合同分组头表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_RE_POLICY_ORDER_REL")
public class PmRePolicyOrderRel extends AuditDomain {

    public static final String FIELD_REQUEST_ORDER_GROUP_ID = "requestOrderGroupId";
    public static final String FIELD_REQUEST_ID = "requestId";
    public static final String FIELD_PRIORITY = "priority";
    public static final String FIELD_GROUP_DIMENSION = "groupDimension";
    public static final String FIELD_TENNT_ID = "tenantId";
    public static final String FIELD_OBJECT_VERSION_NUMBER = "objectVersionNumber";
    public static final String FIELD_CRETION_DTE = "creationDate";
    public static final String FIELD_CRETED_BY = "createdBy";
    public static final String FIELD_LST_UPDTED_BY = "lastUpdatedBy";
    public static final String FIELD_LST_UPDTE_DTE = "lastUpdateDate";
    public static final String FIELD_TTRIBUTE1 = "attribute1";
    public static final String FIELD_TTRIBUTE2 = "attribute2";
    public static final String FIELD_TTRIBUTE3 = "attribute3";
    public static final String FIELD_TTRIBUTE4 = "attribute4";
    public static final String FIELD_TTRIBUTE5 = "attribute5";

    @ApiModelProperty("请求策略与合同分组关系头ID")
    @Id
    @GeneratedValue
    private Long requestOrderGroupId;
    @ApiModelProperty(value = "请求ID", required = true)
    @NotNull
    private Long requestId;
    @ApiModelProperty(value = "优先级", required = true)
    @NotNull
    private Long priority;
    @ApiModelProperty(value = "分组维度", required = true)
    @NotBlank
    private String groupDimension;
    
    @ApiModelProperty(value = "分组排序", required = true)
    private String groupSeq ;
    
    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;
    @ApiModelProperty(value = "行版本号，用来处理锁", required = true)
    @NotNull
    private Long objectVersionNumber;
}