package com.xisc.pm.domain.entity;

import java.math.BigDecimal;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonInclude;

import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * 请求策略明细表
 *
 * @author jun.zeng 2024-11-25 14:51:08
 */
@Setter
@Getter
@ApiModel("请求策略明细表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_REQUEST_POLICY")
public class PmRequestPolicy extends AuditDomain {

    public static final String FIELD_REQUEST_POLICY_ID = "requestPolicyId";
    public static final String FIELD_REQUEST_ID = "requestId";
    public static final String FIELD_POLICY_ID = "policyId";
    public static final String FIELD_POLICY_SEQ = "policySeq";
    public static final String FIELD_2_WID_DEVITION = "a2WidDeviation";
    public static final String FIELD_CONSIGN_CUST = "consignCust";
    public static final String FIELD_ST_LOWER_ECONOMIC_LOTS = "stLowerEconomicLots";
    public static final String FIELD_CUST_LOWER_ECONOMIC_LOTS = "custLowerEconomicLots";
    public static final String FIELD_TENNT_ID = "tenantId";
    public static final String FIELD_OBJECT_VERSION_NUMBER = "objectVersionNumber";
    public static final String FIELD_CRETION_DTE = "creationDate";
    public static final String FIELD_CRETED_BY = "createdBy";
    public static final String FIELD_LST_UPDTED_BY = "lastUpdatedBy";
    public static final String FIELD_LST_UPDTE_DTE = "lastUpdateDate";
    public static final String FIELD_TTRIBUTE1 = "attribute1";
    public static final String FIELD_TTRIBUTE2 = "attribute2";
    public static final String FIELD_TTRIBUTE3 = "attribute3";
    public static final String FIELD_TTRIBUTE4 = "attribute4";
    public static final String FIELD_TTRIBUTE5 = "attribute5";
    public static final String FIELD_ST_GROUP_CODE = "stGroupCode";
    public static final String FIELD_ST_NO = "stNo";
    public static final String FIELD_MSC_LINE_NO = "mscLineNo";

    @ApiModelProperty("请求与策略关系ID")
    @Id
    @GeneratedValue
    private Long requestPolicyId;
    @ApiModelProperty(value = "请求ID", required = true)
    @NotNull
    private Long requestId;
    @ApiModelProperty(value = "策略ID", required = true)
    @NotNull
    private Long policyId;
    @ApiModelProperty(value = "执行顺序", required = true)
    @NotNull
    private Long policySeq;
    @ApiModelProperty(value = "A2板型宽度偏差", required = true)
    @NotNull
    private BigDecimal a2WidDeviation;
    @ApiModelProperty(value = "收货单位")
    private String consignCust;
    @ApiModelProperty(value = "钢种经济批量下限", required = true)
    @NotNull
    private BigDecimal stLowerEconomicLots;
    @ApiModelProperty(value = "客户经济批量下限", required = true)
    @NotNull
    private BigDecimal custLowerEconomicLots;
    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;
    @ApiModelProperty(value = "行版本号，用来处理锁", required = true)
    @NotNull
    private Long objectVersionNumber;
    
    private String stGroupCode ;
    
    private String stNo ;
    
    private String mscLineNo ;

    private String policyCode ;
}