package com.xisc.pm.domain.entity;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonInclude;

import javax.validation.constraints.NotBlank;

import io.choerodon.mybatis.domain.AuditDomain;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * 请求策略与重要客户关系表
 *
 * @author jun.zeng 2024-11-25 14:51:09
 */
@Setter
@Getter
@ApiModel("请求策略与重要客户关系表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_REQUEST_POLICY_VIP")
public class PmRequestPolicyVip extends AuditDomain {

    public static final String FIELD_REQUEST_POLICY_VIP_CUST_ID = "requestPolicyVipCustId";
    public static final String FIELD_REQUEST_POLICY_ID = "requestPolicyId";
    public static final String FIELD_PRIORITY = "priority";
    public static final String FIELD_CUSTOMER_CODE = "customerCode";
    public static final String FIELD_TENNT_ID = "tenantId";
    public static final String FIELD_OBJECT_VERSION_NUMBER = "objectVersionNumber";
    public static final String FIELD_CRETION_DTE = "creationDate";
    public static final String FIELD_CRETED_BY = "createdBy";
    public static final String FIELD_LST_UPDTED_BY = "lastUpdatedBy";
    public static final String FIELD_LST_UPDTE_DTE = "lastUpdateDate";
    public static final String FIELD_TTRIBUTE1 = "attribute1";
    public static final String FIELD_TTRIBUTE2 = "attribute2";
    public static final String FIELD_TTRIBUTE3 = "attribute3";
    public static final String FIELD_TTRIBUTE4 = "attribute4";
    public static final String FIELD_TTRIBUTE5 = "attribute5";

    @ApiModelProperty("请求策略与客户关系ID")
    @Id
    @GeneratedValue
    private Long requestPolicyVipCustId;
    @ApiModelProperty(value = "请求与策略关系ID", required = true)
    @NotNull
    private Long requestPolicyId;
    @ApiModelProperty(value = "优先级", required = true)
    @NotNull
    private Long priority;
    @ApiModelProperty(value = "客户名称", required = true)
    @NotBlank
    private String customerCode;
    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;
    @ApiModelProperty(value = "行版本号，用来处理锁", required = true)
    @NotNull
    private Long objectVersionNumber;

}
