package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;


/**
 * 板坯组矩长度配置表(PmSlabLenConfig)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-25 10:30:14
 */

@Getter
@Setter
@ApiModel("板坯组矩长度配置表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_SLAB_LEN_CONFIG")
public class PmSlabLenConfig extends AuditDomain implements Serializable {
    private static final long serialVersionUID = 549353753789852404L;

    public static final String FIELD_ID = "id";
    public static final String FIELD_SLAB_MIN_LEN = "slabMinLen";
    public static final String FIELD_SLAB_MAX_LEN = "slabMaxLen";
    public static final String FIELD_VALID_FLAG = "validFlag";
    public static final String FIELD_MSC_LINE_NO = "mscLineNo";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @Id
    @GeneratedValue
    private Long id;

    @ApiModelProperty(value = "板坯长度最小值")
    private BigDecimal slabMinLen;

    @ApiModelProperty(value = "板坯长度最大值")
    private BigDecimal slabMaxLen;

    @ApiModelProperty(value = "生效标记")
    private String validFlag;

    @ApiModelProperty(value = "产线号")
    private String mscLineNo;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


}
