package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;


/**
 * 组炉板坯合并表(PmSlabMerge)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-11-18 18:18:00
 */

@Getter
@Setter
@ApiModel("组炉板坯合并表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_SLAB_MERGE")
public class PmSlabMerge extends AuditDomain {
    private static final long serialVersionUID = -25301245314439366L;

    public static final String FIELD_ID = "id";
    public static final String FIELD_MERGE_SLAB_NO = "mergeSlabNo";
    public static final String FIELD_TMP_SLAB_NO = "tmpSlabNo";
    public static final String FIELD_VIRTUAL_SLAB_NO = "virtualSlabNo";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";
    public static final String FIELD_PREC_SLAB_NO = "precSlabNo";
    public static final String FIELD_PONO_SLAB_NO = "ponoSlabNo";
    public static final String FIELD_TMP_PONO_SLAB_NO = "tmpPonoSlabNo";

    @Id
    @GeneratedValue
    private Long id;

    @ApiModelProperty(value = "合并板坯号")
    private String mergeSlabNo;

    @ApiModelProperty(value = "临时命令板坯号")
    private String tmpSlabNo;

    @ApiModelProperty(value = "虚拟板坯号")
    private String virtualSlabNo;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;

    @ApiModelProperty(value = "命令板坯号")
    private String precSlabNo;

    @ApiModelProperty(value = "合并命令板坯号")
    private String ponoSlabNo;

    @ApiModelProperty(value = "合并临时命令板坯号")
    private String tmpPonoSlabNo;


}

