package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;


/**
 * 炼钢连铸制造命令铸机流-接口表(PmSteelCastFlowItf)实体类
 *
 * @author jie.yang04@hand-chian.com
 * @since 2024-10-16 14:38:20
 */

@Getter
@Setter
@ApiModel("炼钢连铸制造命令铸机流-接口表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_STEEL_CAST_FLOW_ITF")
public class PmSteelCastFlowItf extends AuditDomain implements Serializable {
    private static final long serialVersionUID = -94493566949339826L;

    public static final String FIELD_ITF_ID = "itfId";
    public static final String FIELD_MAIN_BACKLOG_CODE = "mainBacklogCode";
    public static final String FIELD_PONO = "pono";
    public static final String FIELD_STRAND_NO = "strandNo";
    public static final String FIELD_HEAT_SLAB_NUM = "heatSlabNum";
    public static final String FIELD_SLAB_THICK = "slabThick";
    public static final String FIELD_SLAB_WIDTH = "slabWidth";
    public static final String FIELD_ADJUST_WIDTH_NUM = "adjustWidthNum";
    public static final String FIELD_UNAPP_SLAB_LEN = "unappSlabLen";
    public static final String FIELD_UNAPP_SLAB_LEN_MAX = "unappSlabLenMax";
    public static final String FIELD_UNAPP_SLAB_LEN_MIN = "unappSlabLenMin";
    public static final String FIELD_ITF_BATCH_ID = "itfBatchId";
    public static final String FIELD_ITF_STATUS = "itfStatus";
    public static final String FIELD_ITF_MESSAGE = "itfMessage";
    public static final String FIELD_ITF_RETRY_TIMES = "itfRetryTimes";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("接口表主键ID")
    @Id
    @GeneratedValue
    private Long itfId;

    @ApiModelProperty(value = "主工序代码")
    private String mainBacklogCode;

    @ApiModelProperty(value = "LOT命令号")
    private String pono;

    @ApiModelProperty(value = "流号")
    private String strandNo;

    @ApiModelProperty(value = "炉内板坯块数")
    private String heatSlabNum;

    @ApiModelProperty(value = "板坯厚度")
    private BigDecimal slabThick;

    @ApiModelProperty(value = "板坯宽度")
    private BigDecimal slabWidth;

    @ApiModelProperty(value = "调宽次数")
    private Long adjustWidthNum;

    @ApiModelProperty(value = "请求外板坯长度")
    private Long unappSlabLen;

    @ApiModelProperty(value = "请求外板坯长度上限")
    private Long unappSlabLenMax;

    @ApiModelProperty(value = "请求外板坯长度下限")
    private Long unappSlabLenMin;

    @ApiModelProperty(value = "接口表数据批次（Linux时间戳）")
    private Long itfBatchId;

    @ApiModelProperty(value = "接口表数据状态（N 未处理 P 处理中 S 处理成功 E 处理失败）")
    private String itfStatus;

    @ApiModelProperty(value = "接口表处理消息")
    private String itfMessage;

    @ApiModelProperty(value = "接口表重试次数")
    private Long itfRetryTimes;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


}

