package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.validator.constraints.Length;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;


/**
 * 炼钢连铸制造命令炉次-接口表 (PmSteelCastHeatItf)实体类
 *
 * @author jie.yang04@hand-chian.com
 * @since 2024-10-16 14:44:08
 */

@Getter
@Setter
@ApiModel("炼钢连铸制造命令炉次-接口表 ")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_STEEL_CAST_HEAT_ITF")
public class PmSteelCastHeatItf extends AuditDomain implements Serializable {
    private static final long serialVersionUID = 328821864305426866L;

    public static final String FIELD_ITF_ID = "itfId";
    public static final String FIELD_MAIN_BACKLOG_CODE = "mainBacklogCode";
    public static final String FIELD_PONO = "pono";
    public static final String FIELD_PONO_STATUS = "ponoStatus";
    public static final String FIELD_CC_SEQ = "ccSeq";
    public static final String FIELD_ST_NO = "stNo";
    public static final String FIELD_SG_SIGN = "sgSign";
    public static final String FIELD_CAST_LOT_NO = "castLotNo";
    public static final String FIELD_CAST_LOT_DIV_NO = "castLotDivNo";
    public static final String FIELD_CAST_LOT_SUM = "castLotSum";
    public static final String FIELD_CC_MACH_NO = "ccMachNo";
    public static final String FIELD_CC_TYPE = "ccType";
    public static final String FIELD_RESTRAND_FLG = "restrandFlg";
    public static final String FIELD_BACKLOG_EA = "backlogEa";
    public static final String FIELD_REFINE_ROUTE_CODE = "refineRouteCode";
    public static final String FIELD_SMELT_MODE = "smeltMode";
    public static final String FIELD_PLAN_TAP_WT = "planTapWt";
    public static final String FIELD_APN = "apn";
    public static final String FIELD_DEST = "dest";
    public static final String FIELD_NEW_TEST_NO = "newTestNo";
    public static final String FIELD_STEEL_PLAN_DATE = "steelPlanDate";
    public static final String FIELD_STEEL_APP_DATE = "steelAppDate";
    public static final String FIELD_PLAN_DATE = "planDate";
    public static final String FIELD_CC_REQ_TIME = "ccReqTime";
    public static final String FIELD_CC_REQ_TIME_FLAG = "ccReqTimeFlag";
    public static final String FIELD_HEAT_CONFM_TIME = "heatConfmTime";
    public static final String FIELD_HOT_REQ_TIME = "hotReqTime";
    public static final String FIELD_HOT_SEND_FLAG = "hotSendFlag";
    public static final String FIELD_HOT_CHARGE_FLAG = "hotChargeFlag";
    public static final String FIELD_TD_CHG_FLG = "tdChgFlg";
    public static final String FIELD_PONO_OLD = "ponoOld";
    public static final String FIELD_SLAB_REQ = "slabReq";
    public static final String FIELD_FLAME_CLEAN_DIV = "flameCleanDiv";
    public static final String FIELD_SHIFT_POINT = "shiftPoint";
    public static final String FIELD_SHIFT_NO = "shiftNo";
    public static final String FIELD_SHIFT_GROUP = "shiftGroup";
    public static final String FIELD_HOLD_PLANNER = "holdPlanner";
    public static final String FIELD_HOLD_TIME = "holdTime";
    public static final String FIELD_PLAN_RELEASER = "planReleaser";
    public static final String FIELD_REL_TIME = "relTime";
    public static final String FIELD_SEND_PLANNER = "sendPlanner";
    public static final String FIELD_SEND_TIME = "sendTime";
    public static final String FIELD_CC_BASE = "ccBase";
    public static final String FIELD_POUR_TIME = "pourTime";
    public static final String FIELD_ADJUST_FLAG = "adjustFlag";
    public static final String FIELD_ITF_BATCH_ID = "itfBatchId";
    public static final String FIELD_ITF_STATUS = "itfStatus";
    public static final String FIELD_ITF_MESSAGE = "itfMessage";
    public static final String FIELD_ITF_RETRY_TIMES = "itfRetryTimes";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    public static final String FIELD_REFINE_DIV = "refineDiv";
    public static final String FIELD_DIS_FLAG = "disFlag";
    @ApiModelProperty("接口表主键ID")
    @Id
    @GeneratedValue
    private Long itfId;

    @ApiModelProperty(value = "炉次LOT删除区分")
    private String disFlag;

    @ApiModelProperty(value = "厂别")
    private String mainBacklogCode;

    @ApiModelProperty(value = "制造命令号")
    private String pono;

    @ApiModelProperty(value = "制造命令状态")
    private Long ponoStatus;

    @ApiModelProperty(value = "连铸计划顺序号")
    private Long ccSeq;

    @ApiModelProperty(value = "内部钢种")
    private String stNo;

    @ApiModelProperty(value = "牌号")
    private String sgSign;

    @ApiModelProperty(value = "浇次号")
    private String castLotNo;

    @ApiModelProperty(value = "浇次分割号")
    private Long castLotDivNo;

    @ApiModelProperty(value = "浇次内炉数")
    private Long castLotSum;

    @ApiModelProperty(value = "连铸机号")
    private String ccMachNo;

    @ApiModelProperty(value = "连铸机类型(1.板坯2.方坯3.钢锭)")
    private String ccType;

    @ApiModelProperty(value = "计划浇次头/尾炉标记")
    private String restrandFlg;

    @ApiModelProperty(value = "钢区工序途径")
    private String backlogEa;

    @ApiModelProperty(value = "计划精炼路径代码")
    private String refineDiv;

    @ApiModelProperty(value = "冶炼模式")
    private Long smeltMode;

    @ApiModelProperty(value = "计划出钢重量")
    private BigDecimal planTapWt;

    @ApiModelProperty(value = "产品最终用途码")
    private String apn;

    @ApiModelProperty(value = "板坯计划去向")
    private String dest;

    @ApiModelProperty(value = "新试号")
    private String newTestNo;

    @ApiModelProperty(value = "炼钢计划日期")
    private String steelPlanDate;

    @ApiModelProperty(value = "炼钢申请日期")
    private String steelAppDate;

    @ApiModelProperty(value = "计划日期")
    private String planDate;

    @ApiModelProperty(value = "CC要求时刻设定")
    private String ccReqTime;

    @ApiModelProperty(value = "CC要求时刻指定标记")
    private String ccReqTimeFlag;

    @ApiModelProperty(value = "判钢时间")
    private String heatConfmTime;

    @ApiModelProperty(value = "热送要求时间")
    private String hotReqTime;

    @ApiModelProperty(value = "热送标记")
    private String hotSendFlag;

    @ApiModelProperty(value = "热装标记")
    private String hotChargeFlag;

    @ApiModelProperty(value = "中间包更换标志")
    private Long tdChgFlg;

    @ApiModelProperty(value = "前制造命令")
    private String ponoOld;

    @ApiModelProperty(value = "板坯要求")
    private String slabReq;

    @ApiModelProperty(value = "火焰清理区分")
    private String flameCleanDiv;

    @ApiModelProperty(value = "班要点")
    private String shiftPoint;

    @ApiModelProperty(value = "班次号")
    private String shiftNo;

    @ApiModelProperty(value = "班组")
    private String shiftGroup;

    @ApiModelProperty(value = "封锁计划员")
    private String holdPlanner;

    @ApiModelProperty(value = "封锁时刻")
    private String holdTime;

    @ApiModelProperty(value = "计划释放者")
    private String planReleaser;

    @ApiModelProperty(value = "释放时刻")
    private String relTime;

    @ApiModelProperty(value = "下达计划员")
    private String sendPlanner;

    @ApiModelProperty(value = "下达时刻")
    private String sendTime;

    @ApiModelProperty(value = "连连铸基准")
    private String ccBase;

    @ApiModelProperty(value = "浇注时间")
    private Long pourTime;

    @ApiModelProperty(value = "调整标记")
    private String adjustFlag;

    @ApiModelProperty(value = "接口表数据批次（Linux时间戳）")
    private Long itfBatchId;

    @ApiModelProperty(value = "接口表数据状态（N 未处理 P 处理中 S 处理成功 E 处理失败）")
    private String itfStatus;

    @ApiModelProperty(value = "接口表处理消息")
    private String itfMessage;

    @ApiModelProperty(value = "接口表重试次数")
    private Long itfRetryTimes;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;



}

