package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;


/**
 * 炼钢连铸制造命令LOT-接口表(PmSteelCastLotItf)实体类
 *
 * @author jie.yang04@hand-chian.com
 * @since 2024-10-17 14:28:16
 */

@Getter
@Setter
@ApiModel("炼钢连铸制造命令LOT-接口表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_STEEL_CAST_LOT_ITF")
public class PmSteelCastLotItf extends AuditDomain implements Serializable {
    private static final long serialVersionUID = 190216010663536756L;

    public static final String FIELD_ITF_ID = "itfId";
    public static final String FIELD_MAIN_BACKLOG_CODE = "mainBacklogCode";
    public static final String FIELD_CAST_LOT_NO = "castLotNo";
    public static final String FIELD_ST_NO = "stNo";
    public static final String FIELD_SG_SIGN = "sgSign";
    public static final String FIELD_LOT_STATUS = "lotStatus";
    public static final String FIELD_CC_TYPE = "ccType";
    public static final String FIELD_CC_PLAN_MODE = "ccPlanMode";
    public static final String FIELD_URGENCY_ORDER_MARK = "urgencyOrderMark";
    public static final String FIELD_APP_TYPE = "appType";
    public static final String FIELD_BILLET_TYPE = "billetType";
    public static final String FIELD_SLAB_GROUP_SUM = "slabGroupSum";
    public static final String FIELD_SLAB_THICK = "slabThick";
    public static final String FIELD_SLAB_NUM = "slabNum";
    public static final String FIELD_ITF_BATCH_ID = "itfBatchId";
    public static final String FIELD_ITF_STATUS = "itfStatus";
    public static final String FIELD_ITF_MESSAGE = "itfMessage";
    public static final String FIELD_ITF_RETRY_TIMES = "itfRetryTimes";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("接口表主键ID")
    @Id
    @GeneratedValue
    private Long itfId;

    @ApiModelProperty(value = "主工序代码")
    private String mainBacklogCode;

    @ApiModelProperty(value = "CAST_LOT号")
    private String castLotNo;

    @ApiModelProperty(value = "内部钢种")
    private String stNo;

    @ApiModelProperty(value = "牌号")
    private String sgSign;

    @ApiModelProperty(value = "LOT状态")
    private Long lotStatus;

    @ApiModelProperty(value = "连铸机类型")
    private String ccType;

    @ApiModelProperty(value = "连铸计划模式")
    private String ccPlanMode;

    @ApiModelProperty(value = "紧急合同标志")
    private String urgencyOrderMark;

    @ApiModelProperty(value = "材料申请类型")
    private String appType;

    @ApiModelProperty(value = "钢坯类型")
    private String billetType;

    @ApiModelProperty(value = "板坯组数")
    private Long slabGroupSum;

    @ApiModelProperty(value = "板坯厚度")
    private BigDecimal slabThick;

    @ApiModelProperty(value = "板坯块数")
    private Long slabNum;

    @ApiModelProperty(value = "接口表数据批次（Linux时间戳）")
    private Long itfBatchId;

    @ApiModelProperty(value = "接口表数据状态（N 未处理 P 处理中 S 处理成功 E 处理失败）")
    private String itfStatus;

    @ApiModelProperty(value = "接口表处理消息")
    private String itfMessage;

    @ApiModelProperty(value = "接口表重试次数")
    private Long itfRetryTimes;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


}

