package com.xisc.pm.domain.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.choerodon.mybatis.annotation.ModifyAudit;
import io.choerodon.mybatis.annotation.VersionAudit;
import io.choerodon.mybatis.domain.AuditDomain;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;


/**
 * 厚板产线_命令余材长度基准表-履历表(PmWmWwBtTra)实体类
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-09-11 15:03:15
 */

@Getter
@Setter
@ApiModel("厚板产线_命令余材长度基准表-履历表")
@VersionAudit
@ModifyAudit
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Table(name = "PM_WM_WW_BT_TRA")
public class PmWmWwBtTra extends AuditDomain implements Serializable {
    private static final long serialVersionUID = 597075393248755431L;

    public static final String FIELD_TRA_ID = "traId";
    public static final String FIELD_OPERATION_TYPE = "operationType";
    public static final String FIELD_OPERATION_USER = "operationUser";
    public static final String FIELD_OPERATION_TIME = "operationTime";
    public static final String FIELD_ID = "id";
    public static final String FIELD_WHOLE_BACKLOG_CODE = "wholeBacklogCode";
    public static final String FIELD_SLAB_WIDTH_FROM = "slabWidthFrom";
    public static final String FIELD_SLAB_WIDTH_TO = "slabWidthTo";
    public static final String FIELD_SLAB_THICK_FROM = "slabThickFrom";
    public static final String FIELD_SLAB_THICK_TO = "slabThickTo";
    public static final String FIELD_CC_TYPE = "ccType";
    public static final String FIELD_FILL_SLAB_LEN_MAX = "fillSlabLenMax";
    public static final String FIELD_FILL_SLAB_LEN_MIN = "fillSlabLenMin";
    public static final String FIELD_UNAPP_SLAB_LEN = "unappSlabLen";
    public static final String FIELD_UNAPP_SLAB_LEN_MAX = "unappSlabLenMax";
    public static final String FIELD_UNAPP_SLAB_LEN_MIN = "unappSlabLenMin";
    public static final String FIELD_CAST_HEAD_LEN_MAX = "castHeadLenMax";
    public static final String FIELD_CAST_HEAD_LEN_MIN = "castHeadLenMin";
    public static final String FIELD_CAST_TAIL_LEN_MAX = "castTailLenMax";
    public static final String FIELD_CAST_TAIL_LEN_MIN = "castTailLenMin";
    public static final String FIELD_CAST_HEAD_SLAB_NUM = "castHeadSlabNum";
    public static final String FIELD_CAST_TAIL_SLAB_NUM = "castTailSlabNum";
    public static final String FIELD_MSC_LINE_NO = "mscLineNo";
    public static final String FIELD_TENANT_ID = "tenantId";
    public static final String FIELD_ATTRIBUTE1 = "attribute1";
    public static final String FIELD_ATTRIBUTE2 = "attribute2";
    public static final String FIELD_ATTRIBUTE3 = "attribute3";
    public static final String FIELD_ATTRIBUTE4 = "attribute4";
    public static final String FIELD_ATTRIBUTE5 = "attribute5";

    @ApiModelProperty("履历主键ID")
    @Id
    @GeneratedValue
    private Long traId;

    @ApiModelProperty(value = "操作类型(I:插入，U:修改，D:删除)", required = true)
    @NotBlank
    private String operationType;

    @ApiModelProperty(value = "操作者", required = true)
    @NotBlank
    private String operationUser;

    @ApiModelProperty(value = "操作时间", required = true)
    @NotNull
    private Date operationTime;

    @ApiModelProperty(value = "${column.comment}", required = true)
    @NotNull
    private Long id;

    @ApiModelProperty(value = "全程工序代码")
    private String wholeBacklogCode;

    @ApiModelProperty(value = "板坯宽度起")
    private Long slabWidthFrom;

    @ApiModelProperty(value = "板坯宽度止")
    private Long slabWidthTo;

    @ApiModelProperty(value = "板坯厚度起")
    private Long slabThickFrom;

    @ApiModelProperty(value = "板坯厚度止")
    private Long slabThickTo;

    @ApiModelProperty(value = "连铸机类型")
    private String ccType;

    @ApiModelProperty(value = "无委充当板坯长度上限")
    private Long fillSlabLenMax;

    @ApiModelProperty(value = "无委充当板坯长度下限")
    private Long fillSlabLenMin;

    @ApiModelProperty(value = "请求外板坯长度")
    private Long unappSlabLen;

    @ApiModelProperty(value = "请求外板坯长度上限")
    private Long unappSlabLenMax;

    @ApiModelProperty(value = "请求外板坯长度下限")
    private Long unappSlabLenMin;

    @ApiModelProperty(value = "轻压下CAST头部余材长度上限")
    private Long castHeadLenMax;

    @ApiModelProperty(value = "轻压下CAST头部余材长度下限")
    private Long castHeadLenMin;

    @ApiModelProperty(value = "轻压下CAST尾部余材长度上限")
    private Long castTailLenMax;

    @ApiModelProperty(value = "轻压下CAST尾部余材长度下限")
    private Long castTailLenMin;

    @ApiModelProperty(value = "轻压下CAST头部余材板坯块数")
    private Long castHeadSlabNum;

    @ApiModelProperty(value = "轻压下CAST尾部余材板坯块数")
    private Long castTailSlabNum;

    @ApiModelProperty(value = "产线号")
    private String mscLineNo;

    @ApiModelProperty(value = "租户ID", required = true)
    @NotNull
    private Long tenantId;

    private String attribute1;

    private String attribute2;

    private String attribute3;

    private String attribute4;

    private String attribute5;


}
