package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.vo.MmPlateVO;
import com.xisc.pm.domain.vo.MmRollingVo;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 钢板主数据表(MmPlate)资源库
 *
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-08-14 15:37:09
 */
public interface MmPlateRepository extends BaseRepository<MmPlateVO> {
    /**
     * 查询
     *
     * @param mmPlateVO 查询条件
     * @return 返回值
     */
    List<MmPlateVO> selectList(MmPlateVO mmPlateVO);

    /**
     * 根据主键查询（可关联表）
     *
     * @param plateId 主键
     * @return 返回值
     */
    MmPlateVO selectByPrimary(Long plateId);

    /**
     * 余材钢板充当材料信息列表
     *
     * @param dto
     * @return
     */
    List<MmPlateVO> surplusSteelPlateList(MmPlateVO dto);

    /**
     * 查询轧制产线号信息
     * @param tenantId
     * @param matNo
     * @param prodYear
     * @param rollLineNo
     * @return
     */
    MmRollingVo selectMmRolling(Long tenantId , String matNo , String prodYear , String rollLineNo);

    /**
     * 根据钢板号查询prodYear
     *
     * @param matNoList
     * @param tenantId
     * @return
     */
    List<MmPlateVO> getMmPlateByMatNo(List<String> matNoList, Long tenantId);

    /**
     * 根据mm_Plate_id查询
     *
     * @param mmPlateIdList
     * @param tenantId
     * @return
     */
    List<MmPlateVO> getMmPlateByPrimaryPlateId(List<Long> mmPlateIdList, Long tenantId);
}
