package com.xisc.pm.domain.repository;

import org.hzero.mybatis.base.BaseRepository;
import com.xisc.pm.domain.entity.PmAxisBrdTrimBt;

import java.util.List;

/**
 * 纵轧展宽宽度余量基准表(PmAxisBrdTrimBt)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-09-23 09:16:10
 */
public interface PmAxisBrdTrimBtRepository extends BaseRepository<PmAxisBrdTrimBt> {
    /**
     * 查询
     *
     * @param pmAxisBrdTrimBt 查询条件
     * @return 返回值
     */
    List<PmAxisBrdTrimBt> selectList(PmAxisBrdTrimBt pmAxisBrdTrimBt);

    /**
     * 根据主键查询（可关联表）
     *
     * @param pabtbId 主键
     * @return 返回值
     */
    PmAxisBrdTrimBt selectByPrimary(Long pabtbId);
    
    /**
     * 通过产线号和切边标记获取新宽度余量
     * @param tenantId
     * @param mscLineNo
     * @param withSideFlag
     * @return
     */
    PmAxisBrdTrimBt selectPmAxisBrdTrimBt(Long tenantId, String mscLineNo, String withSideFlag);
}
