package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmCmdLargePlt;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 命令大板表(PmCmdLargePlt)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-08-01 10:24:39
 */
public interface PmCmdLargePltRepository extends BaseRepository<PmCmdLargePlt> {
    /**
     * 查询
     *
     * @param pmCmdLargePlt 查询条件
     * @return 返回值
     */
    List<PmCmdLargePlt> selectList(PmCmdLargePlt pmCmdLargePlt);

    /**
     * 根据主键查询（可关联表）
     *
     * @param pmCmdLargePltId 主键
     * @return 返回值
     */
    PmCmdLargePlt selectByPrimary(Long pmCmdLargePltId);

    /**
     * 命令板坯号查询大板表
     *
     * @param ponoSlabList
     * @param tenantId
     * @return
     */
    List<PmCmdLargePlt> selectByPonoSlabList(List<String> ponoSlabList, Long tenantId);

    /**
     * 根据临时命令板坯号查询
     *
     * @param tmpSlabNoList
     * @param tenantId
     * @return
     */
    List<PmCmdLargePlt> selectByTmpSlabNoList(List<String> tmpSlabNoList, Long tenantId);

    /**
     * 根据板坯号查询
     *
     * @param slabNoList
     * @param tenantId
     * @return
     */
    List<PmCmdLargePlt> selectBySlabNoList(List<String> slabNoList, Long tenantId);

    /**
     * 根据命令板坯号和钢板号查询
     *
     * @param ponoSlabNoList
     * @param plateNoList
     * @param tenantId
     * @return
     */
    List<PmCmdLargePlt> selectByPonoAndPlateNo(List<String> ponoSlabNoList, List<String> plateNoList, Long tenantId);
}
