package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmCmdLargePlt;
import com.xisc.pm.domain.entity.PmCmdLargePltTra;
import org.hzero.mybatis.base.BaseRepository;

import java.util.Date;
import java.util.List;

/**
 * 命令大板表(PmCmdLargePltTra)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-11-28 17:20:32
 */
public interface PmCmdLargePltTraRepository extends BaseRepository<PmCmdLargePltTra> {
    /**
     * 查询
     *
     * @param pmCmdLargePltTra 查询条件
     * @return 返回值
     */
    List<PmCmdLargePltTra> selectList(PmCmdLargePltTra pmCmdLargePltTra);

    /**
     * 根据主键查询（可关联表）
     *
     * @param traId 主键
     * @return 返回值
     */
    PmCmdLargePltTra selectByPrimary(Long traId);

    /**
     * 创建履历表
     *
     * @param pmCmdLargePltList
     * @param operationType
     * @param operationTime
     * @param operationUser
     * @return
     */
    List<PmCmdLargePltTra> buildPmCmdLargePltTraList(List<PmCmdLargePlt> pmCmdLargePltList, String operationType, Date operationTime, String operationUser);

    /**
     * 根据命令板坯号查询最新的一条
     * @param ponoSlabList
     * @param tenantId
     * @return
     */
    List<PmCmdLargePltTra> selectByPonoSlabList(List<String> ponoSlabList, Long tenantId);
}
