package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmCmdSlab;
import com.xisc.pm.domain.entity.PmCmdSlabTra;
import org.hzero.mybatis.base.BaseRepository;

import java.util.Date;
import java.util.List;

/**
 * 命令板坯表(PmCmdSlabTra)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-11-28 17:19:49
 */
public interface PmCmdSlabTraRepository extends BaseRepository<PmCmdSlabTra> {
    /**
     * 查询
     *
     * @param pmCmdSlabTra 查询条件
     * @return 返回值
     */
    List<PmCmdSlabTra> selectList(PmCmdSlabTra pmCmdSlabTra);

    /**
     * 根据主键查询（可关联表）
     *
     * @param traId 主键
     * @return 返回值
     */
    PmCmdSlabTra selectByPrimary(Long traId);

    /**
     * 创建履历表数据
     *
     * @param pmCmdSlabList
     * @param operationType
     * @param operationTime
     * @param operationUser
     * @return
     */
    List<PmCmdSlabTra> buildPmCmdSlabTraList(List<PmCmdSlab> pmCmdSlabList, String operationType, Date operationTime, String operationUser);
}
