package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmCmdSmallPlt;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 命令小板表(PmCmdSmallPlt)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-08-01 10:25:35
 */
public interface PmCmdSmallPltRepository extends BaseRepository<PmCmdSmallPlt> {
    /**
     * 查询
     *
     * @param pmCmdSmallPlt 查询条件
     * @return 返回值
     */
    List<PmCmdSmallPlt> selectList(PmCmdSmallPlt pmCmdSmallPlt);

    /**
     * 根据主键查询（可关联表）
     *
     * @param pmCmdSmallPltId 主键
     * @return 返回值
     */
    PmCmdSmallPlt selectByPrimary(Long pmCmdSmallPltId);

    List<PmCmdSmallPlt> selectByPonoSlabList(List<String> ponoSlabList, Long tenantId);

    /**
     * 根据临时命令板坯号查询
     *
     * @param tmpSlabNoList
     * @param tenantId
     * @return
     */
    List<PmCmdSmallPlt> selectByTmpSlabNoList(List<String> tmpSlabNoList, Long tenantId);

    /**
     * 根据命令板坯号和钢板号查询
     *
     * @param ponoSlabNoList
     * @param plateNoList
     * @param tenantId
     * @return
     */
    List<PmCmdSmallPlt> selectByPonoAndPlateNo(List<String> ponoSlabNoList, List<String> plateNoList, Long tenantId);
}
