package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmCompositeOrderRel;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 复合板成品合同与基材合同对应关系表(PmCompositeOrderRel)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-09-25 09:20:37
 */
public interface PmCompositeOrderRelRepository extends BaseRepository<PmCompositeOrderRel> {
    /**
     * 查询
     *
     * @param pmCompositeOrderRel 查询条件
     * @return 返回值
     */
    List<PmCompositeOrderRel> selectList(PmCompositeOrderRel pmCompositeOrderRel);

    /**
     * 根据主键查询（可关联表）
     *
     * @param relId 主键
     * @return 返回值
     */
    PmCompositeOrderRel selectByPrimary(Long relId);

    /**
     * 根据合同号查询
     *
     * @param orderNoList
     * @param tenantId
     * @return
     */
    List<PmCompositeOrderRel>  selectByOrderList(List<String> orderNoList, Long tenantId);

    /**
     * 根据成品合同和基材合同查询
     *
     * @param productOrderNo
     * @param orderNoList
     * @param tenantId
     * @return
     */
    List<PmCompositeOrderRel> selectByProductAndOrderList(String productOrderNo, List<String> orderNoList, Long tenantId);
}
