package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmIngotCutLenBt;
import org.hzero.mybatis.base.BaseRepository;

import java.math.BigDecimal;
import java.util.List;

/**
 * 钢锭切缝量基准表(PmIngotCutLenBt)资源库
 *
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-09-05 15:18:17
 */
public interface PmIngotCutLenBtRepository extends BaseRepository<PmIngotCutLenBt> {
    /**
     * 查询
     *
     * @param pmIngotCutLenBt 查询条件
     * @return 返回值
     */
    List<PmIngotCutLenBt> selectList(PmIngotCutLenBt pmIngotCutLenBt);

    /**
     * 根据主键查询（可关联表）
     *
     * @param piclbId 主键
     * @return 返回值
     */
    PmIngotCutLenBt selectByPrimary(Long piclbId);

    /**
     * 通过轴合同订货厚度获取钢锭切缝宽度
     * @param orderThick
     * @param tenantId
     * @return
     */
    PmIngotCutLenBt selectByOrderThick(BigDecimal orderThick, Long tenantId);
}
