package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmIngotSpecTrimBt;
import org.hzero.mybatis.base.BaseRepository;

import java.math.BigDecimal;
import java.util.List;

/**
 * 钢锭轧制规格及切边量基准表(PmIgnotSpecTrimBt)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-24 15:01:54
 */
public interface PmIngotSpecTrimBtRepository extends BaseRepository<PmIngotSpecTrimBt> {
    /**
     * 查询
     *
     * @param pmIngotSpecTrimBt 查询条件
     * @return 返回值
     */
    List<PmIngotSpecTrimBt> selectList(PmIngotSpecTrimBt pmIngotSpecTrimBt);

    /**
     * 根据主键查询（可关联表）
     *
     * @param pistbId 主键
     * @return 返回值
     */
    PmIngotSpecTrimBt selectByPrimary(Long pistbId);

    /**
     * 
     * @param tenantId 租户
     * @param prodSideMark 切边标记
     * @param orderThick 轴合同订货首都
     * @param szWidth 组合板宽
     * @param mscLineNo 设计产线号
     * @return
     */
    List<PmIngotSpecTrimBt> selectBy(Long tenantId,String rollDirectCode, String prodSideMark, BigDecimal orderThick, BigDecimal szWidth,
            String mscLineNo);

    /**
     * 钢坯轧制规格
     * @param tenantId
     * @param ingotType
     * @param guaranteeQuality
     * @param mscLineNo
     * @return
     */
    PmIngotSpecTrimBt selectBy(Long tenantId, String ingotType, String guaranteeQuality, String mscLineNo);
}
