package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmIngotThickAddvBt;
import org.hzero.mybatis.base.BaseRepository;

import java.math.BigDecimal;
import java.util.List;

/**
 * 钢锭厚度余量基准表(PmIngotThickAddvBt)资源库
 *
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-09-05 15:15:06
 */
public interface PmIngotThickAddvBtRepository extends BaseRepository<PmIngotThickAddvBt> {
    /**
     * 查询
     *
     * @param pmIngotThickAddvBt 查询条件
     * @return 返回值
     */
    List<PmIngotThickAddvBt> selectList(PmIngotThickAddvBt pmIngotThickAddvBt);

    /**
     * 根据主键查询（可关联表）
     *
     * @param pitabId 主键
     * @return 返回值
     */
    PmIngotThickAddvBt selectByPrimary(Long pitabId);

    /**
     * 获取钢锭坯厚度余量
     * @param tenantId 租户ID
     * @param ingotType 钢锭坯类型代码
     * @param rollMode 轧制模式
     * @param heatTreatMode 热处理类型
     * @param rollDirectCode 轧制方向代码
     * @param orderThick 轴合同厚度
     * @param szWidth 组合板宽
     * @return
     */
    PmIngotThickAddvBt selectTaimAddv(Long tenantId, String ingotType, String rollMode, String heatTreatMode,
            String rollDirectCode, BigDecimal orderThick, BigDecimal szWidth);
}
