package com.xisc.pm.domain.repository;

import org.hzero.mybatis.base.BaseRepository;
import com.xisc.pm.domain.entity.PmMidSlabAddvBt;

import java.math.BigDecimal;
import java.util.List;

/**
 * 低碳钢坯加余量基准表(PmMidSlabAddvBt)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-09-25 15:18:47
 */
public interface PmMidSlabAddvBtRepository extends BaseRepository<PmMidSlabAddvBt> {
    /**
     * 查询
     *
     * @param pmMidSlabAddvBt 查询条件
     * @return 返回值
     */
    List<PmMidSlabAddvBt> selectList(PmMidSlabAddvBt pmMidSlabAddvBt);

    /**
     * 根据主键查询（可关联表）
     *
     * @param pmsabId 主键
     * @return 返回值
     */
    PmMidSlabAddvBt selectByPrimary(Long pmsabId);
    
    /**
     * 获取低碳钢坯加余量基准表PM_MID_SLAB_ADDV_BT的允许长宽差LEN_WIDTH_DIFF
     * @param taim
     * @param orderNo
     * @param mscLineNo
     * @param stNo
     * @param sgSgin
     * @param tenantId
     * @return
     */
    BigDecimal queryLenWidthDiff(BigDecimal taim, String orderNo, String mscLineNo, String stNo, String sgSgin, BigDecimal slabThk, Long tenantId);
}
