package com.xisc.pm.domain.repository;

import org.hzero.mybatis.base.BaseRepository;
import com.xisc.pm.domain.entity.PmMinThickTolBt;

import java.math.BigDecimal;
import java.util.List;

/**
 * 最小轧制厚度公差范围基准表(PmMinThickTolBt)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-23 11:11:38
 */
public interface PmMinThickTolBtRepository extends BaseRepository<PmMinThickTolBt> {
    /**
     * 查询
     *
     * @param pmMinThickTolBt 查询条件
     * @return 返回值
     */
    List<PmMinThickTolBt> selectList(PmMinThickTolBt pmMinThickTolBt);

    /**
     * 根据主键查询（可关联表）
     *
     * @param pmttbId 主键
     * @return 返回值
     */
    PmMinThickTolBt selectByPrimary(Long pmttbId);

    /**
     * 通过产线号与轴合同订货厚度，获取最小厚度公差MIN_THICK_TOL
     * @param tennantId
     * @param mscLineNo
     * @param orderThick
     * @return
     */
    PmMinThickTolBt selectByRollLineNoAndAxisOrderThick(Long tennantId ,String mscLineNo, BigDecimal orderThick);
}
