package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmPdBlockPos;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 组合子板位置表资源库
 *
 * @author 曾俊 jun.zeng@hand-china.com 2024-08-02 08:02:38
 */
public interface PmPdBlockPosRepository extends BaseRepository<PmPdBlockPos> {

    /**
     * 通过虚拟板坯号查询组合子板位置表
     * @param tenantId
     * @param virtualSlabNo
     * @return
     */
    List<PmPdBlockPos> selectByPdMatNo(Long tenantId, String virtualSlabNo);

    /**
     * 按虚拟板坯号删除
     * @param tenantId
     * @param removePdMatNo
     */
    int deleteByMatNo(Long tenantId, List<String> removePdMatNo);

    /**
     * 通过虚拟板坯号查询组合子板位置表
     *
     * @param pdMatNoList
     * @param tenantId
     * @return
     */
    List<PmPdBlockPos> selectByPdMatNoList(List<String> pdMatNoList, Long tenantId);
}
