package com.xisc.pm.domain.repository;

import com.xisc.pm.api.dto.PmPdContPanelMaterialDTO;
import com.xisc.pm.domain.entity.PmPdContSum;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 组板合同总量表(PmPdContSum)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-30 10:29:33
 */
public interface PmPdContSumRepository extends BaseRepository<PmPdContSum> {
    /**
     * 查询
     *
     * @param pmPdContSum 查询条件
     * @return 返回值
     */
    List<PmPdContSum> selectList(PmPdContSum pmPdContSum);

    /**
     * 根据主键查询（可关联表）
     *
     * @param ppcsId 主键
     * @return 返回值
     */
    PmPdContSum selectByPrimary(Long ppcsId);

    /**
     * 根据合同号起止查询组板合同组板材料
     *
     * @param orderNoFrom 合同号起
     * @param orderNoTo   合同号止
     * @param tenantId    租户
     * @return 返回list集合
     */
    List<PmPdContPanelMaterialDTO> selectConPanelMaterialsList(String orderNoFrom, String orderNoTo, Long tenantId);
    
    /**
     * 
     * 根据合同标号集合查询
     * 
     * @param orderNoList 合同编号集合
     * @param tenantId 租户
     * @return 返回list集合
     */
    List<PmPdContSum> selectByOrderNoList(List<String> orderNoList, Long tenantId);

    /**
     * 基于虚拟板坯号查询合同总量表信息
     * @param tenantId
     * @param virtualSlabNo
     * @return
     */
    List<PmPdContSum> selectByPdMatNo(Long tenantId, String virtualSlabNo);

    /**
     * 按虚拟板坯号删除
     * @param tenantId
     * @param removePdMatNo
     */
    int deleteByMatNo(Long tenantId, List<String> removePdMatNo);

    /**
     * 更加虚拟板坯号集合查询合同信息
     * @param tenantId
     * @param virtualSlabNoList
     * @return
     */
    List<PmPdContSum> selectByPdMatNoList(Long tenantId, List<String> virtualSlabNoList);

    /**
     * 根据板坯号查询
     *
     * @param slabNoList
     * @param tenantId
     * @return
     */
    List<PmPdContSum> selectBySlabNoList(List<String> slabNoList, Long tenantId);
}
