package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmPdPlateCut;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 大板粗切位置表资源库
 *
 * @author 曾俊 jun.zeng@hand-china.com 2024-08-02 08:02:38
 */
public interface PmPdPlateCutRepository extends BaseRepository<PmPdPlateCut> {

    /**
     * 通过虚拟板坯号查询大板粗切位置
     * @param tenantId
     * @param virtualSlabNo
     * @return
     */
    List<PmPdPlateCut> selectByPdMatNo(Long tenantId, String virtualSlabNo);

    /**
     * 按虚拟板坯号删除
     * @param tenantId
     * @param removePdMatNo
     */
    int deleteByMatNo(Long tenantId, List<String> removePdMatNo);

    /**
     * 根据虚拟板坯号查询大板粗切
     *
     * @param virtualSlabNoList
     * @param tenantId
     */
    List<PmPdPlateCut>  selectByPdMatNoList(List<String> virtualSlabNoList, Long tenantId);
}
