package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmPdPlateInfo;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 钢板信息表(PmPdPlateInfo)资源库
 *
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-08-22 19:58:30
 */
public interface PmPdPlateInfoRepository extends BaseRepository<PmPdPlateInfo> {
    /**
     * 查询
     *
     * @param pmPdPlateInfo 查询条件
     * @return 返回值
     */
    List<PmPdPlateInfo> selectList(PmPdPlateInfo pmPdPlateInfo);

    /**
     * 根据主键查询（可关联表）
     *
     * @param plateInfoId 主键
     * @return 返回值
     */
    PmPdPlateInfo selectByPrimary(Long plateInfoId);

    /**
     * 根据钢板号查询
     *
     * @param tenantId
     * @param plateNoList
     * @return
     */
    List<PmPdPlateInfo> selectByPlateNoList(Long tenantId, List<String> plateNoList);
}
