package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmPdPlate;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 组板钢板表(PmPdPlate)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-31 16:31:09
 */
public interface PmPdPlateRepository extends BaseRepository<PmPdPlate> {
    /**
     * 查询
     *
     * @param pmPdPlate 查询条件
     * @return 返回值
     */
    List<PmPdPlate> selectList(PmPdPlate pmPdPlate);

    /**
     * 根据主键查询（可关联表）
     *
     * @param pdPlateId 主键
     * @return 返回值
     */
    PmPdPlate selectByPrimary(Long pdPlateId);

    /**
     * 根据钢板号查询
     *
     * @param tenantId
     * @param plateNoList
     * @return
     */
    List<PmPdPlate> selectByPlateNoList(Long tenantId, List<String> plateNoList);
}
