package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmPdSlabInfo;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 板坯信息表(PmPdSlabInfo)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-08-12 14:59:21
 */
public interface PmPdSlabInfoRepository extends BaseRepository<PmPdSlabInfo> {
    /**
     * 查询
     *
     * @param pmPdSlabInfo 查询条件
     * @return 返回值
     */
    List<PmPdSlabInfo> selectList(PmPdSlabInfo pmPdSlabInfo);

    /**
     * 根据主键查询（可关联表）
     *
     * @param slabInfoId 主键
     * @return 返回值
     */
    PmPdSlabInfo selectByPrimary(Long slabInfoId);

    /**
     * 通过板坯号查询板坯信息
     * @param slabNo
     * @param organizationId
     * @return
     */
    PmPdSlabInfo selectBySlabNo(String slabNo, Long organizationId);

    /**
     * 根据板坯号查询
     *
     * @param slabNoList
     * @param tenantId
     * @return
     */
    List<PmPdSlabInfo> selectBySlabNoList(List<String> slabNoList, Long tenantId);
}
