package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmPlateSpecBt;
import org.hzero.mybatis.base.BaseRepository;

import java.math.BigDecimal;
import java.util.List;

/**
 * 钢板轧制规格基准表(PmPlateSpecBt)资源库
 *
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-09-05 14:45:53
 */
public interface PmPlateSpecBtRepository extends BaseRepository<PmPlateSpecBt> {
    /**
     * 查询
     *
     * @param pmPlateSpecBt 查询条件
     * @return 返回值
     */
    List<PmPlateSpecBt> selectList(PmPlateSpecBt pmPlateSpecBt);

    /**
     * 根据主键查询（可关联表）
     *
     * @param pptabId 主键
     * @return 返回值
     */
    PmPlateSpecBt selectByPrimary(Long pptabId);

    /**
     * 匹配轧制规格
     * @param rollMode
     * @param adModeCode
     * @param formPlateMode
     * @param stCode
     * @param heatTreatMode
     * @param mscLineNoToRoolLineNo
     * @return
     */
    PmPlateSpecBt selectLenAndWidthLimit(BigDecimal orderThick ,BigDecimal szWidth, String rollMode, String adModeCode, String formPlateMode, String stCode,
            String heatTreatMode, String rollLineNo , Long tenantId);
    
    /**
     * 获取最大的组合板长度上限
     * @param tenantId
     * @return
     */
    BigDecimal maxCombinePlateLenMax(Long tenantId) ;
}
