package com.xisc.pm.domain.repository;

import org.hzero.mybatis.base.BaseRepository;
import com.xisc.pm.domain.entity.PmPlateTrimBt;

import java.math.BigDecimal;
import java.util.List;

/**
 * 钢板切边量基准表(PmPlateTrimBt)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-24 10:37:37
 */
public interface PmPlateTrimBtRepository extends BaseRepository<PmPlateTrimBt> {
    /**
     * 查询
     *
     * @param pmPlateTrimBt 查询条件
     * @return 返回值
     */
    List<PmPlateTrimBt> selectList(PmPlateTrimBt pmPlateTrimBt);

    /**
     * 根据主键查询（可关联表）
     *
     * @param pptbId 主键
     * @return 返回值
     */
    PmPlateTrimBt selectByPrimary(Long pptbId);

    /**
     * 
     * @param tenantId 租户ID
     * @param rollMode 根据轧制方向ROLL_DIRECT_CODE=roll_direct_code
     * @param prodSideMark 切边标记WITH_SIDE_FLAG = prod_side_mark
     * @param orderThick 钢板厚度起止PLATE_THICK_FROM/TO 包含轴合同厚度order_thick
     * @param szWidth 组合板宽度起止COMBINE_PLATE_WIDTH_FROM/TO 包含组合板宽combine_plate_width
     * @param modeWidth 组合板宽度起止COMBINE_PLATE_WIDTH_FROM/TO 包含组合板宽combine_plate_width
     * @param mscLineNo 产线号为msc_line_no
     */
    List<PmPlateTrimBt> selectMaxTrimWidth(Long tenantId, String prodSideMark, BigDecimal orderThick, BigDecimal szWidth,BigDecimal modeWidth,
            String mscLineNo);
}
