package com.xisc.pm.domain.repository;

import com.xisc.pm.api.dto.PmPolicyGroupReqDTO;
import com.xisc.pm.app.service.autoboard.dto.PmOrderGroupDTO;
import com.xisc.pm.domain.entity.PmPolicyGroup;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 策略组表(PmPolicyGroup)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-11-08 09:38:30
 */
public interface PmPolicyGroupRepository extends BaseRepository<PmPolicyGroup> {
    /**
     * 查询
     *
     * @param pmPolicyGroup 查询条件
     * @return 返回值
     */
    List<PmPolicyGroup> selectList(PmPolicyGroup pmPolicyGroup);

    /**
     * 根据主键查询（可关联表）
     *
     * @param policyGroupId 主键
     * @return 返回值
     */
    PmPolicyGroup selectByPrimary(Long policyGroupId);

    /**
     * 查询策略组数据
     *
     * @param dto      参数
     * @param tenantId 租户
     * @return
     */
    List<PmPolicyGroup> queryList(PmPolicyGroupReqDTO dto, Long tenantId, List<String> policyIdList );
    
    /**
     * 
     */
    List<PmOrderGroupDTO> selectContGroupConditionByGroupId(Long policyGroupId, Long tenantId);
}
