package com.xisc.pm.domain.repository;

import com.xisc.pm.api.dto.PmPolicyReqDTO;
import com.xisc.pm.domain.entity.PmPolicy;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 策略信息表(PmPolicy)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-10-16 10:43:05
 */
public interface PmPolicyRepository extends BaseRepository<PmPolicy> {
    /**
     * 查询
     *
     * @param dto      入参
     * @param tenantId 租户
     * @param policyIdList 策略ID
     * @return
     */
    List<PmPolicy> selectList( PmPolicyReqDTO dto,Long tenantId, List<Long> policyIdList, List<String> stNoList);
    
    /**
     * 通过策略组查询策略，按优先级排序
     * @param tenantId
     * @param policyGroupId
     * @return
     */
    List<PmPolicy> selectByPolicyGroupId(Long tenantId , Long policyGroupId);
}
