package com.xisc.pm.domain.repository;

import org.hzero.mybatis.base.BaseRepository;

import com.xisc.pm.app.service.autoboard.dto.PmPolicyStDTO;
import com.xisc.pm.domain.entity.PmPolicySteelGroup;

import java.util.List;

/**
 * 策略信息与钢种组关系表(PmPolicySteelGroup)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-10-16 10:47:22
 */
public interface PmPolicySteelGroupRepository extends BaseRepository<PmPolicySteelGroup> {
    /**
     * 查询
     *
     * @param pmPolicySteelGroup 查询条件
     * @return 返回值
     */
    List<PmPolicySteelGroup> selectList(PmPolicySteelGroup pmPolicySteelGroup);

    /**
     * 根据主键查询（可关联表）
     *
     * @param policyStGroupId 主键
     * @return 返回值
     */
    PmPolicySteelGroup selectByPrimary(Long policyStGroupId);
    
    /**
     * 通过策略查询钢种信息
     * @param policyCodeList
     * @return
     */
    List<PmPolicyStDTO> selectStNoList(List<Long> policyIdList , Long tenantId);
}
