package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmPonoWtInfo;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 炉重信息表(PmPonoWtInfo)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-08-12 08:26:58
 */
public interface PmPonoWtInfoRepository extends BaseRepository<PmPonoWtInfo> {
    /**
     * 查询
     *
     * @param pmPonoWtInfo 查询条件
     * @return 返回值
     */
    List<PmPonoWtInfo> selectList(PmPonoWtInfo pmPonoWtInfo);

    /**
     * 根据主键查询（可关联表）
     *
     * @param pmPonoWtInfoId 主键
     * @return 返回值
     */
    PmPonoWtInfo selectByPrimary(Long pmPonoWtInfoId);

    /**
     * 根据预浇次号和制造命令号查询
     *
     * @param precCastLotNoList
     * @param prePonoList
     * @param tenantId
     * @return
     */
    List<PmPonoWtInfo> selectByPrecCastAndPonoList(List<String> precCastLotNoList, List<String> prePonoList, Long tenantId);
}
