package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmSlabEstaPlan;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 组炉编制表(PmSlabEstaPlan)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-08-09 16:31:17
 */
public interface PmSlabEstaPlanRepository extends BaseRepository<PmSlabEstaPlan> {
    /**
     * 查询
     *
     * @param pmSlabEstaPlan 查询条件
     * @return 返回值
     */
    List<PmSlabEstaPlan> selectList(PmSlabEstaPlan pmSlabEstaPlan);

    /**
     * 根据主键查询（可关联表）
     *
     * @param slabEstaPlanId 主键
     * @return 返回值
     */
    PmSlabEstaPlan selectByPrimary(Long slabEstaPlanId);

    /**
     * 根据pono查询
     *
     * @param ponoList
     * @param tenantId
     */
    List<PmSlabEstaPlan> selectByPonoList(List<String> ponoList, Long tenantId);

    /**
     * 根据预浇次号查询
     *
     * @param tenantId
     * @param precCastLotNoList
     * @return
     */
    List<PmSlabEstaPlan> selectByPreCastLotNoList(Long tenantId, List<String> precCastLotNoList);
}
