package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmSlabMerge;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 组炉板坯合并表(PmSlabMerge)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-09-04 15:13:40
 */
public interface PmSlabMergeRepository extends BaseRepository<PmSlabMerge> {
    /**
     * 查询
     *
     * @param pmSlabMerge 查询条件
     * @return 返回值
     */
    List<PmSlabMerge> selectList(PmSlabMerge pmSlabMerge);

    /**
     * 根据主键查询（可关联表）
     *
     * @param id 主键
     * @return 返回值
     */
    PmSlabMerge selectByPrimary(Long id);

    /**
     * 根据合并临时命令板坯号查询
     *
     * @param mergeTemSlabNoList
     * @param tenantId
     * @return
     */
    List<PmSlabMerge> selectByMerTmpSlabNoList(List<String> mergeTemSlabNoList, Long tenantId);

    /**
     * 根据合并虚拟板坯号
     * @param merVirtualSlabNoList
     * @param tenantId
     * @return
     */
    List<PmSlabMerge> selectByMergeSlabNoList(List<String> merVirtualSlabNoList, Long tenantId);

    /**
     * 根据临时命令板坯号查询
     *
     * @param tmpSlabNoList
     * @param tenantId
     * @return
     */
    List<PmSlabMerge> selectByTmpSlabNoList(List<String> tmpSlabNoList, Long tenantId);

    /**
     * 根据合并命令板坯号查询
     *
     * @param mergePonoSlabNoList
     * @param tenantId
     * @return
     */
    List<PmSlabMerge> selectByMerPonoSlabNoList(List<String> mergePonoSlabNoList, Long tenantId);
}
