package com.xisc.pm.domain.repository;

import java.math.BigDecimal;
import java.util.List;

import org.hzero.mybatis.base.BaseRepository;

import com.xisc.pm.domain.entity.PmSlabScrapLenBt;

/**
 * 余坯组板采用判定基准表(PmSlabScrapLenBt)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-23 14:28:34
 */
public interface PmSlabScrapLenBtRepository extends BaseRepository<PmSlabScrapLenBt> {
    /**
     * 查询
     *
     * @param pmSlabScrapLenBt 查询条件
     * @return 返回值
     */
    List<PmSlabScrapLenBt> selectList(PmSlabScrapLenBt pmSlabScrapLenBt);

    /**
     * 根据主键查询（可关联表）
     *
     * @param psslbId 主键
     * @return 返回值
     */
    PmSlabScrapLenBt selectByPrimary(Long psslbId);

    /**
     * 通过产线号，板坯剩余长，板坯宽，板坯厚获取允许切废长度度
     * @param tenantId
     * @param remainSlabLen
     * @param moldThick
     * @param moldWidth
     * @param mscLineNo
     * @return
     */
    PmSlabScrapLenBt selectCanScrapLen(Long tenantId, BigDecimal remainSlabLen, BigDecimal moldThick, BigDecimal moldWidth,
            String mscLineNo);
    
    List<PmSlabScrapLenBt> selectCanScrapLen(Long tenantId, BigDecimal moldThick, BigDecimal moldWidth,
            String mscLineNo);
}
