package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmPdSlabInfo;
import com.xisc.pm.domain.entity.PmSlabSpecBt;
import org.hzero.mybatis.base.BaseRepository;

import java.math.BigDecimal;
import java.util.List;

/**
 * 连铸板坯生产规格基准表(PmSlabSpecBt)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-23 08:24:44
 */
public interface PmSlabSpecBtRepository extends BaseRepository<PmSlabSpecBt> {
    /**
     * 查询
     *
     * @param pmSlabSpecBt 查询条件
     * @return 返回值
     */
    List<PmSlabSpecBt> selectList(PmSlabSpecBt pmSlabSpecBt);
    
    /**
     * 通过轧制产线好与CcType查询结果
     * @param tenantId
     * @param rollLineNo
     * @param ccType
     * @return
     */
    List<PmSlabSpecBt> selectByLineNoAndCcType(Long tenantId , String rollLineNo , String ccType , String ...orderBy);
    
    /**
     * 
     * @param tenantId
     * @param rollLineNo
     * @param ccType
     * @param furType
     * @param thick
     * @param width
     * @return
     */
    List<PmSlabSpecBt> selectBy(Long tenantId , String rollLineNo , String ccType , String furType , BigDecimal thick , BigDecimal width);

    /**
     * 通过板坯信息表查询，最小加热炉长度配置
     * @param pmPdSlabInfo
     * @return
     */
    PmSlabSpecBt selectMinSlabLenByPmPdSlabInfo(PmPdSlabInfo pmPdSlabInfo);

}
