package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmSmallPltPos;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 组板小板位置表资源库
 *
 * @author 曾俊 jun.zeng@hand-china.com 2024-08-02 08:02:39
 */
public interface PmSmallPltPosRepository extends BaseRepository<PmSmallPltPos> {

    /**
     * 通过虚拟板坯号查询组板小板位置表资源库
     * @param tenantId
     * @param virtualSlabNo
     * @return
     */
    List<PmSmallPltPos> selectByPdMatNo(Long tenantId, String virtualSlabNo);

    /**
     * 按虚拟板坯号删除
     * @param tenantId
     * @param removePdMatNo
     */
    int deleteByMatNo(Long tenantId, List<String> removePdMatNo);

    /**
     * 
     * @param tenantId
     * @param virtualSlabNoList
     * @return
     */
    List<PmSmallPltPos> selectPmSmallPltPos(Long tenantId, List<String> virtualSlabNoList);

    /**
     * 根据虚拟板坯号查询
     *
     * @param virtualNoList
     * @param tenantId
     * @return
     */
    List<PmSmallPltPos> selectByPdMatNoList(List<String> virtualNoList, Long tenantId);
    
    /**
     * 获取同一个板坯中，最大的小板分割号
     * @param tenantId
     * @param slabNo
     * @return
     */
    String selectMaxSmallDivNoBySlabNo(Long tenantId, String slabNo);
}
