package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmSteelCastHeat;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 炼钢连铸制造命令炉次表 (PmSteelCastHeat)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-08-15 08:20:13
 */
public interface PmSteelCastHeatRepository extends BaseRepository<PmSteelCastHeat> {
    /**
     * 查询
     *
     * @param pmSteelCastHeat 查询条件
     * @return 返回值
     */
    List<PmSteelCastHeat> selectList(PmSteelCastHeat pmSteelCastHeat);

    /**
     * 根据主键查询（可关联表）
     *
     * @param steelCastHeatId 主键
     * @return 返回值
     */
    PmSteelCastHeat selectByPrimary(Long steelCastHeatId);

    /**
     * 根据制造命令号删除
     *
     * @param ponoList
     * @param tenantId
     * @return
     */
    List<PmSteelCastHeat> selectByPonoList(List<String> ponoList, Long tenantId);

    /**
     * 根据浇
     * @param castLotNoList
     * @param tenantId
     * @return
     */
    List<PmSteelCastHeat> selectByCastLotNoList(List<String> castLotNoList, Long tenantId);
}
