package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.entity.PmSteelCastSlab;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 炼钢连铸制造命令板坯表(PmSteelCastSlab)资源库
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-08-15 10:21:18
 */
public interface PmSteelCastSlabRepository extends BaseRepository<PmSteelCastSlab> {
    /**
     * 查询
     *
     * @param pmSteelCastSlab 查询条件
     * @return 返回值
     */
    List<PmSteelCastSlab> selectList(PmSteelCastSlab pmSteelCastSlab);

    /**
     * 根据主键查询（可关联表）
     *
     * @param steelCastSlabId 主键
     * @return 返回值
     */
    PmSteelCastSlab selectByPrimary(Long steelCastSlabId);

    /**
     * 根据制造命令号查询
     * @param ponoList
     * @param tenantId
     */
    List<PmSteelCastSlab> selectByPonoList(List<String> ponoList, Long tenantId);

    /**
     * 根据浇次号查询
     *
     * @param castLotNoList
     * @param tenantId
     * @return
     */
    List<PmSteelCastSlab> selectByCastLotNoList(List<String> castLotNoList, Long tenantId);
}
