package com.xisc.pm.domain.repository;

import java.math.BigDecimal;
import java.util.List;

import org.hzero.mybatis.base.BaseRepository;

import com.xisc.pm.domain.entity.PmThickAddvBt;

/**
 * 钢板厚度余量基准表(PmThickAddvBt)资源库
 *
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-09-05 15:04:57
 */
public interface PmThickAddvBtRepository extends BaseRepository<PmThickAddvBt> {
    /**
     * 查询
     *
     * @param pmThickAddvBt 查询条件
     * @return 返回值
     */
    List<PmThickAddvBt> selectList(PmThickAddvBt pmThickAddvBt);

    /**
     * 根据主键查询（可关联表）
     *
     * @param pptabId 主键
     * @return 返回值
     */
    PmThickAddvBt selectByPrimary(Long pptabId);
    
    /**
     * 厚度余量配置
     * @param tenantId 租户
     * @param tolTypeCode 公差类型
     * @param heatTreatMode 热处理模式
     * @param rollLineNo 轧制产线号
     * @param orderThick 轴合同厚度
     * @param szWidth 组合板宽
     * @return
     */
    PmThickAddvBt selectTaimAddv(Long tenantId, String axisOrderNo,
            String heatTreatMode, String mscLineNo, BigDecimal orderThick, BigDecimal szWidth) ;
}
