package com.xisc.pm.domain.repository;

import com.xisc.pm.domain.vo.WmMatPileVO1;
import com.xisc.pm.domain.vo.WmMatPileVo;
import org.hzero.mybatis.base.BaseRepository;

import java.util.List;

/**
 * 材料垛位信息表(WmMatPile)资源库
 *
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-08-16 16:17:29
 */
public interface PmWmMatPileRepository extends BaseRepository<WmMatPileVO1> {
    /**
     * 查询
     *
     * @param wmMatPileVO1 查询条件
     * @return 返回值
     */
    List<WmMatPileVO1> selectList(WmMatPileVO1 wmMatPileVO1);

    /**
     * 根据主键查询（可关联表）
     *
     * @param matPileId 主键
     * @return 返回值
     */
    WmMatPileVO1 selectByPrimary(Long matPileId);

    /**
     * 通过材料号查询垛位信息
     *
     * @param matNo
     * @param tenantId
     * @return
     */
    WmMatPileVo selectWmMatPileByMatNo(String matNo, Long tenantId);
}
