package com.xisc.pm.domain.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/8/22 16:48
 */
@Data
public class CdAndQtCollectPoolVO implements Serializable {
    private static final long serialVersionUID = -436665136446092957L;

    @ApiModelProperty("合同号")
    private String orderNo;

    @ApiModelProperty("差欠重量")
    private BigDecimal ordRemWgt;

    @ApiModelProperty("合同欠件数")
    private BigDecimal ordRemNum;

    @ApiModelProperty("计划重量")
    private BigDecimal planWgt;

    @ApiModelProperty("计划结束日期")
    private Date planEndDate;

    @ApiModelProperty("最晚结束日期")
    private Date latestEndDate;

    @ApiModelProperty("紧急合同标记")
    private String urgOrderFlag;

    @ApiModelProperty("订货重量")
    private BigDecimal orderWt;

    @ApiModelProperty("交货重量正公差")
    private BigDecimal delivyWtTolPlus;

    @ApiModelProperty("交货重量负公差")
    private BigDecimal delivyWtTolMinus;

    @ApiModelProperty("可收池量")
    private BigDecimal canChooseWt;

    @ApiModelProperty("订货最小重量")
    private BigDecimal orderWtMin;

    @ApiModelProperty("订货最大重量")
    private BigDecimal orderWtMax;

    @ApiModelProperty("交货日期")
    private String delivyDate;

    @ApiModelProperty("合同性质代码")
    private String orderTypeCode;

    @ApiModelProperty("牌号")
    private String sgSign;

    @ApiModelProperty("牌号代码")
    private String sgCode;

    @ApiModelProperty("全程工序代码")
    private String wholeBacklogCode;

    @ApiModelProperty("拖期标记")
    private String delayFlag;

    @ApiModelProperty("订货厚度")
    private BigDecimal orderThick;

    @ApiModelProperty("订货长度")
    private BigDecimal orderLen;

    @ApiModelProperty("订货最大长度")
    private BigDecimal orderMaxLen;

    @ApiModelProperty("订货最小长度")
    private BigDecimal orderMinLen;

    @ApiModelProperty("订货宽度")
    private BigDecimal orderWidth;

    @ApiModelProperty("订货重量单件目标值")
    private BigDecimal orderUnitAimWt;

    @ApiModelProperty("订货重量单件最大值")
    private BigDecimal orderUnitMaxWt;

    @ApiModelProperty("订货重量单件最小值")
    private BigDecimal orderUnitMinWt;
}
