package com.xisc.pm.domain.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.Id;
import javax.persistence.Transient;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;


/**
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-08-14 15:48:38
 */

@Data
public class CtDetVO implements Serializable {
    private static final long serialVersionUID = -24562663125256279L;

    @ApiModelProperty("流向记录ID")
    @Id
    private Long detId;

    @ApiModelProperty(value = "合约号")
    private String contractNum;

    @ApiModelProperty(value = "合同号")
    private String orderNo;

    @ApiModelProperty(value = "全程工序代码")
    private String wholeBacklogCode;

    @ApiModelProperty(value = "小工序代码")
    private String subBacklogCode;

    @ApiModelProperty(value = "可编计划重量")
    private Long insWgt;

    @ApiModelProperty(value = "可编计划件数")
    private Long insNum;

    @ApiModelProperty(value = "在库重量")
    private Long stockWgt;

    @ApiModelProperty(value = "在库件数")
    private Long stockNum;

    @ApiModelProperty(value = "计划重量")
    private Long planWgt;

    @ApiModelProperty(value = "计划个数")
    private Long planNum;

    @ApiModelProperty(value = "可组板数")
    private BigDecimal userdBoardNum;

    @ApiModelProperty(value = "通过重量")
    private Long passWgt;

    @ApiModelProperty(value = "通过件数")
    private Long passNum;

    @ApiModelProperty(value = "差欠重量")
    private Long lackWgt;

    @ApiModelProperty(value = "差欠件数")
    private Long lackNum;

    @ApiModelProperty(value = "排入生产重量")
    private Long scheProdWgt;

    @ApiModelProperty(value = "排入生产件数")
    private Long scheProdNum;

    @ApiModelProperty(value = "封锁重量")
    private Long holdWgt;

    @ApiModelProperty(value = "封锁件数")
    private Long holdNum;

    @ApiModelProperty(value = "转入重量")
    private Long moveInWgt;

    @ApiModelProperty(value = "转入件数")
    private Long moveInNum;

    @ApiModelProperty(value = "转出重量")
    private Long moveOutWgt;

    @ApiModelProperty(value = "转出件数")
    private Long moveOutNum;

    @ApiModelProperty(value = "超投重量")
    private Long overDevoWgt;

    @ApiModelProperty(value = "超投件数")
    private Long overDevoNum;

    @ApiModelProperty(value = "补投重量")
    private Long supDevoWgt;

    @ApiModelProperty(value = "补投件数")
    private Long supDevoNum;

    @ApiModelProperty(value = "返工重量")
    private Long reworkWgt;

    @ApiModelProperty(value = "返工件数")
    private Long reworkNum;

    @ApiModelProperty(value = "判废重量")
    private Long wasteWgt;

    @ApiModelProperty(value = "判废件数")
    private Long wasteNum;

    @ApiModelProperty(value = "完成重量")
    private Long endWgt;

    @ApiModelProperty(value = "完成件数")
    private Long endNum;

    @ApiModelProperty(value = "租户ID")
    private Long tenantId;

    @ApiModelProperty(value = "全程工序途径吗")
    @Transient
    private List<String> wholeBacklogCodeList ;
    
    @ApiModelProperty(value = "订单编码")
    @Transient
    private List<String> orderNoList ;
    
    
}
