package com.xisc.pm.domain.vo;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @author jun.zeng
 * @since 2024/8/9 8:58
 */
@JsonInclude(value = JsonInclude.Include.NON_NULL)
@Data
public class CtMainVO implements Serializable {
    private static final long serialVersionUID = 8197590179481895295L;

    @ApiModelProperty("合同号")
    private String orderNo;

    @ApiModelProperty(value = "订货件数")
    private BigDecimal orderNum;

    @ApiModelProperty("CT_MAIN的ORD_REM_WGT  组板工序欠量")
    private BigDecimal ordRemWgt;
    
    @ApiModelProperty("CT_MAIN的ORD_REM_NUM 组板工序欠件")
    private BigDecimal ordRemNum;
    
    @ApiModelProperty(value = "尾量标记", required = true)
    private Long tailFlag;

    @ApiModelProperty("合同状态")
    private String orderStatus;
    
    @ApiModelProperty(value = "库存数量")
    private BigDecimal stockNum ;

    @ApiModelProperty(value = "可组板数")
    private BigDecimal userdBoardNum;

    @ApiModelProperty(value = "合约欠量")
    private BigDecimal contractNum;

    @ApiModelProperty(value = "合约号")
    private String contractOrder;

    @ApiModelProperty(value = "发运完成件数")
    private BigDecimal shipEndNum;

    @ApiModelProperty(value = "计划个数")
    private BigDecimal planNum;

    @ApiModelProperty(value = "超投重量")
    private BigDecimal overDevoWgtTotal;

    @ApiModelProperty(value = "超投数量")
    private BigDecimal overDevoNumTotal;

    @ApiModelProperty(value = "计划重量")
    private BigDecimal planWgt;

    @ApiModelProperty(value = "可收池量")
    private BigDecimal stockWgt;


}
