package com.xisc.pm.domain.vo;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * 二级接口 接口  XBHE07  vo
 *
 * @author 汉得-杨杰
 * @date 2024/10/14
 */
@Data
public class InterfaceXBHE07VO {


    @ApiModelProperty(value = "炉次LOT删除区分")
    @JsonProperty("DIS_FLAG")
    private String disFlag;

    @ApiModelProperty(value = "主工序代码")
    @JsonProperty("MAIN_BACKLOG_CODE")
    private String mainBacklogCode;

    @ApiModelProperty(value = "制造命令号")
    @JsonProperty("PONO")
    private String pono;

    @ApiModelProperty(value = "制造命令状态")
    @JsonProperty("PONO_STATUS")
    private Long ponoStatus;

    @ApiModelProperty(value = "连铸顺序号")
    @JsonProperty("CC_SEQ")
    private Long ccSeq;

    @ApiModelProperty(value = "出钢记号")
    @JsonProperty("ST_NO")
    private String stNo;

    @ApiModelProperty(value = "牌号（钢级）")
    @JsonProperty("SG_SIGN")
    private String sgSign;

    @ApiModelProperty(value = "CAST_LOT号")
    @JsonProperty("CAST_LOT_NO")
    private String castLotNo;

    @ApiModelProperty(value = "CAST_LOT分割号")
    @JsonProperty("CAST_LOT_DIV_NO")
    private Long castLotDivNo;

    @ApiModelProperty(value = "CAST_LOT内炉数")
    @JsonProperty("CAST_LOT_SUM")
    private Long castLotSum;

    @ApiModelProperty(value = "连铸机号")
    @JsonProperty("CC_MACH_NO")
    private String ccMachNo;

    @ApiModelProperty(value = "连铸机类型")
    @JsonProperty("CC_TYPE")
    private String ccType;

    @ApiModelProperty(value = "重引锭标志")
    @JsonProperty("RESTRAND_FLG")
    private String restrandFlg;

    @ApiModelProperty(value = "钢区工序途径")
    @JsonProperty("BACKLOG_EA")
    private String backlogEa;

    @ApiModelProperty(value = "精炼路径代码")
    @JsonProperty("REFINE_DIV")
    private String refineDiv;

    @ApiModelProperty(value = "冶炼模式")
    @JsonProperty("SMELT_MODE")
    private Long smeltMode;

    @ApiModelProperty(value = "计划出钢重量")
    @JsonProperty("PLAN_TAP_WT")
    private BigDecimal planTapWt;

    @ApiModelProperty(value = "产品最终用途码")
    @JsonProperty("APN")
    private String apn;

    @ApiModelProperty(value = "去向")
    @JsonProperty("DEST")
    private String dest;

    @ApiModelProperty(value = "新试号")
    @JsonProperty("NEW_TEST_NO")
    private String newTestNo;

    @ApiModelProperty(value = "炼钢计划日期")
    @JsonProperty("STEEL_PLAN_DATE")
    private String steelPlanDate;

    @ApiModelProperty(value = "炼钢申请日期")
    @JsonProperty("STEEL_APP_DATE")
    private String steelAppDate;

    @ApiModelProperty(value = "计划日期")
    @JsonProperty("PLAN_DATE")
    private String planDate;

    @ApiModelProperty(value = "CC要求时刻设定")
    @JsonProperty("CC_REQ_TIME")
    private String ccReqTime;

    @ApiModelProperty(value = "CC要求时刻指定标记")
    @JsonProperty("CC_REQ_TIME_FLAG")
    private String ccReqTimeFlag;

    @ApiModelProperty(value = "炉次确定时刻")
    @JsonProperty("HEAT_CONFM_TIME")
    private String heatConfmTime;

    @ApiModelProperty(value = "热送要求时间")
    @JsonProperty("HOT_REQ_TIME")
    private String hotReqTime;

    @ApiModelProperty(value = "热送标记")
    @JsonProperty("HOT_SEND_FLAG")
    private String hotSendFlag;

    @ApiModelProperty(value = "热装标记")
    @JsonProperty("HOT_CHARGE_FLAG")
    private String hotChargeFlag;

    @ApiModelProperty(value = "中间包更换标志")
    @JsonProperty("TD_CHG_FLG")
    private Long tdChgFlg;

    @ApiModelProperty(value = "前制造命令")
    @JsonProperty("PONO_OLD")
    private String ponoOld;

    @ApiModelProperty(value = "板坯要求")
    @JsonProperty("SLAB_REQ")
    private String slabReq;

    @ApiModelProperty(value = "火焰清理区分")
    @JsonProperty("FLAME_CLEAN_DIV")
    private String flameCleanDiv;

    @ApiModelProperty(value = "班要点")
    @JsonProperty("SHIFT_POINT")
    private String shiftPoint;

    @ApiModelProperty(value = "班次号")
    @JsonProperty("SHIFT_NO")
    private String shiftNo;

    @ApiModelProperty(value = "班组")
    @JsonProperty("SHIFT_GROUP")
    private String shiftGroup;

    @ApiModelProperty(value = "封锁计划员")
    @JsonProperty("HOLD_PLANNER")
    private String holdPlanner;

    @ApiModelProperty(value = "封锁时刻")
    @JsonProperty("HOLD_TIME")
    private String holdTime;

    @ApiModelProperty(value = "计划释放者")
    @JsonProperty("PLAN_RELEASER")
    private String planReleaser;

    @ApiModelProperty(value = "释放时刻")
    @JsonProperty("REL_TIME")
    private String relTime;

    @ApiModelProperty(value = "下达计划员")
    @JsonProperty("SEND_PLANNER")
    private String sendPlanner;

    @ApiModelProperty(value = "下达时刻")
    @JsonProperty("SEND_TIME")
    private String sendTime;

    @ApiModelProperty(value = "连铸基准")
    @JsonProperty("CC_BASE")
    private String ccBase;

    @ApiModelProperty(value = "浇注时间")
    @JsonProperty("POUR_TIME")
    private Long pourTime;

    @ApiModelProperty(value = "调整标记")
    @JsonProperty("ADJUST_FLAG")
    private String adjustFlag;

}
