package com.xisc.pm.domain.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;


@Data
@ApiModel("命令板坯表")
public class PmCmdSlabVO implements Serializable {

    private static final long serialVersionUID = 492884385865185945L;

    @ApiModelProperty(value = "主键ID")
    private Long pmCmdSlabId;

    @ApiModelProperty(value = "命令板坯号")
    private String ponoSlabNo;

    @ApiModelProperty(value = "临时命令板坯号")
    private String tmpSlabNo;

    @ApiModelProperty(value = "组批工序顺序号")
    private Long pdBacklogSeq;

    @ApiModelProperty(value = "组批工序代码")
    private String pdBacklogCode;

    @ApiModelProperty(value = "板坯号")
    private String slabNo;

    @ApiModelProperty(value = "虚拟板坯号")
    private String virtualSlabNo;

    @ApiModelProperty(value = "厚板组板状态")
    private String pdStatusHp;

    @ApiModelProperty(value = "长板坯含短板坯块数")
    private Long shortSlabNumInLong;

    @ApiModelProperty(value = "长板坯含大板块数")
    private Long bigPlateNum;

    @ApiModelProperty(value = "板坯分割号")
    private Long slabDivNo;

    @ApiModelProperty(value = "板内合同个数")
    private Long orderNumInPlate;

    @ApiModelProperty(value = "轴合同号")
    private String orderNoAxis;

    @ApiModelProperty(value = "合同材/预备材区分")
    private String orderRemainDiv;

    @ApiModelProperty(value = "材料设计种类")
    private String matDesignKind;

    @ApiModelProperty(value = "厚板品种代码")
    private String prodCodeHp;

    @ApiModelProperty(value = "牌号（钢级）")
    private String sgSign;

    @ApiModelProperty(value = "出钢记号")
    private String stNo;

    @ApiModelProperty(value = "头尾板坯标记")
    private String slabHtFlag;

    @ApiModelProperty(value = "清理前板坯厚度")
    private BigDecimal preCleanSlabThick;

    @ApiModelProperty(value = "清理前板坯宽度")
    private BigDecimal preCleanSlabWidth;

    @ApiModelProperty(value = "清理前板坯长度")
    private BigDecimal preCleanSlabLen;

    @ApiModelProperty(value = "清理前板坯最大长度")
    private BigDecimal preCleanSlabMaxLen;

    @ApiModelProperty(value = "清理前板坯最小长度")
    private BigDecimal preCleanSlabMinLen;

    @ApiModelProperty(value = "清理前板坯重量")
    private BigDecimal preCleanSlabWt;

    @ApiModelProperty(value = "清理前板坯最大重量")
    private BigDecimal preCleanSlabMaxWt;

    @ApiModelProperty(value = "清理前板坯最小重量")
    private BigDecimal preCleanSlabMinWt;

    @ApiModelProperty(value = "结晶器厚度")
    private BigDecimal moldThick;

    @ApiModelProperty(value = "结晶器宽度")
    private BigDecimal moldWid;

    @ApiModelProperty(value = "进加热炉板坯厚度")
    private BigDecimal infurSlabThick;

    @ApiModelProperty(value = "进加热炉板坯宽度")
    private BigDecimal infurSlabWid;

    @ApiModelProperty(value = "进加热炉板坯长度")
    private BigDecimal infurSlabLen;

    @ApiModelProperty(value = "进加热炉板坯最大长度")
    private BigDecimal infurSlabMaxLen;

    @ApiModelProperty(value = "进加热炉板坯最小长度")
    private BigDecimal infurSlabMinLen;

    @ApiModelProperty(value = "进加热炉板坯重量")
    private BigDecimal infurSlabWt;

    @ApiModelProperty(value = "进加热炉板坯最大重量")
    private BigDecimal infurSlabMaxWt;

    @ApiModelProperty(value = "进加热炉板坯最小重量")
    private BigDecimal infurSlabMinWt;

    @ApiModelProperty(value = "必要板坯长度")
    private BigDecimal needSlabLen;

    @ApiModelProperty(value = "必要板坯重量")
    private BigDecimal needSlabWt;

    @ApiModelProperty(value = "固定板坯长度标记")
    private String fixSlabLenFlag;

    @ApiModelProperty(value = "固定板坯长度")
    private BigDecimal fixSlabLen;

    @ApiModelProperty(value = "最大轧件对应的清理前板坯长度")
    private BigDecimal rollMaxPreCleanSlabLen;

    @ApiModelProperty(value = "最大轧件对应的清理前板坯重量")
    private BigDecimal rollMaxPreCleanSlabWt;

    @ApiModelProperty(value = "板坯位置代码")
    private String slabPlaceCode;

    @ApiModelProperty(value = "厚板板坯火焰清理区分")
    private String hpFlameCleanDiv;

    @ApiModelProperty(value = "板坯精整基准代码")
    private String slabFinishCode;

    @ApiModelProperty(value = "板坯清理重量减少率_静态表")
    private BigDecimal slabCleanWtLossRateSt;

    @ApiModelProperty(value = "板坯清理重量减少率_画面")
    private BigDecimal slabCleanWtLossRateFr;

    @ApiModelProperty(value = "钢板缓冷代码")
    private String coolCode;

    @ApiModelProperty(value = "最后短板坯标记")
    private String lastSlabFlag;

    @ApiModelProperty(value = "附加板坯标记")
    private String addSlabFlag;

    @ApiModelProperty(value = "板坯预定通过工序1")
    private String slabPreProc1;

    @ApiModelProperty(value = "板坯预定通过工序2")
    private String slabPreProc2;

    @ApiModelProperty(value = "板坯预定通过工序3")
    private String slabPreProc3;

    @ApiModelProperty(value = "板坯预定通过工序4")
    private String slabPreProc4;

    @ApiModelProperty(value = "板坯预定通过工序5")
    private String slabPreProc5;

    @ApiModelProperty(value = "板坯预定通过工序6")
    private String slabPreProc6;

    @ApiModelProperty(value = "板坯预定通过工序7")
    private String slabPreProc7;

    @ApiModelProperty(value = "板坯预定通过工序8")
    private String slabPreProc8;

    @ApiModelProperty(value = "板坯预定通过工序9")
    private String slabPreProc9;

    @ApiModelProperty(value = "板坯预定通过工序10")
    private String slabPreProc10;

    @ApiModelProperty(value = "板坯预定通过工序11")
    private String slabPreProc11;

    @ApiModelProperty(value = "板坯预定通过工序12")
    private String slabPreProc12;

    @ApiModelProperty(value = "板坯预定通过工序13")
    private String slabPreProc13;

    @ApiModelProperty(value = "板坯预定通过工序14")
    private String slabPreProc14;

    @ApiModelProperty(value = "板坯预定通过工序15")
    private String slabPreProc15;

    @ApiModelProperty(value = "板坯堆放指示")
    private String slabStackIndicate;

    @ApiModelProperty(value = "热送区分")
    private String hotSendDiv;

    @ApiModelProperty(value = "加热炉类型")
    private String furType;

    @ApiModelProperty(value = "转置标记")
    private String transFlag;

    @ApiModelProperty(value = "热装标记")
    private String hotChargeFlag;

    @ApiModelProperty(value = "轧制计划号")
    private String rollPlanNo;

    @ApiModelProperty(value = "新试号")
    private String newTestNo;

    @ApiModelProperty(value = "组板时间")
    private Date formPlateTime;

    @ApiModelProperty(value = "钢板形状代码")
    private String shpCode;

    @ApiModelProperty(value = "制造命令号")
    private String pono;

    @ApiModelProperty(value = "钢锭材料设计种类")
    private String igMatDesignKind;

    @ApiModelProperty(value = "锭坯型")

    private String ingotType;

    @ApiModelProperty(value = "产线号")
    private String mscLineNo;

    @ApiModelProperty(value = "租户ID")
    private Long tenantId;

    @ApiModelProperty(value = "是否合并板坯(N:未合并、A:合并后、B：合并前那两条)")
    private String isMerge;


}
