package com.xisc.pm.domain.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.Id;
import java.io.Serializable;
import java.util.Date;


/**
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-08-16 16:17:29
 */

@Data
public class WmMatPileVO1 implements Serializable {
    private static final long serialVersionUID = -86105614712213859L;

    @ApiModelProperty("表ID，主键")
    @Id
    private Long matPileId;

    @ApiModelProperty(value = "材料ID")
    private Long matId;

    @ApiModelProperty(value = "材料号")
    private String matNo;

    @ApiModelProperty(value = "库区ID")
    private Long stockId;

    @ApiModelProperty(value = "垛位ID")
    private Long pileId;

    @ApiModelProperty(value = "库区代码")
    private String stockCode;

    @ApiModelProperty(value = "垛位号")
    private String pileNo;

    @ApiModelProperty(value = "层号")
    private Long layerNo;

    @ApiModelProperty(value = "卡车号")
    private String truckNo;

    @ApiModelProperty(value = "吊车号")
    private String craneNo;

    @ApiModelProperty(value = "入库时间")
    private Date inStockTime;

    @ApiModelProperty(value = "入垛时间")
    private Date inPileTime;

    @ApiModelProperty(value = "物料种类（HP CR HR SM WR EM）（钢板、板坯）")
    private String matKind;

    @ApiModelProperty(value = "转库计划标记（1：在途）")
    private String transferFlag;

    @ApiModelProperty(value = "租户ID")
    private Long tenantId;

}
