package com.xisc.pm.infra.mapper;

import com.xisc.pm.api.dto.QdToPoOrderDTO;
import com.xisc.pm.domain.entity.PmCompositeOrderRel;
import com.xisc.pm.domain.vo.QdToLineupResultSteelVO;
import io.choerodon.mybatis.common.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 复合板成品合同与基材合同对应关系表(PmCompositeOrderRel)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-09-25 09:20:37
 */
public interface PmCompositeOrderRelMapper extends BaseMapper<PmCompositeOrderRel> {
    /**
     * 基础查询
     *
     * @param pmCompositeOrderRel 查询条件
     * @return 返回值
     */
    List<PmCompositeOrderRel> selectList(PmCompositeOrderRel pmCompositeOrderRel);

    List<QdToPoOrderDTO> listQdOrder(@Param(value = "orderNo") String orderNo,
                                     @Param(value = "orderNoList") List<String> orderNoList,
                                     @Param(value = "tenantId") Long tenantId);

    List<QdToLineupResultSteelVO> selectStNoBySteel(@Param(value = "orderNoList") List<String> orderNoList,
                                                    @Param(value = "tenantId") Long tenantId);

    List<String> listQdToLineupResultSteel(@Param(value = "stNo") String stNo,
                                           @Param(value = "tenantId") Long tenantId);

    List<QdToPoOrderDTO> selectQdAndCtOrder(@Param(value = "orderNoList") List<String> orderNoList,
                                            @Param(value = "tenantId") Long tenantId);

    List<QdToPoOrderDTO> queryQdOrderByOrder(@Param(value = "orderNoList")List<String> orderNoList,
                                             @Param(value = "tenantId")Long tenantId);
}

