package com.xisc.pm.infra.mapper;

import com.xisc.pm.api.dto.PmPdCcSlabStoveParamDTO;
import com.xisc.pm.api.dto.PmPdCcSlabStoveResDTO;
import com.xisc.pm.domain.entity.PmPdCcSlab;
import io.choerodon.mybatis.common.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 组板连铸板坯表(PmPdCcSlab)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-31 16:36:57
 */
public interface PmPdCcSlabMapper extends BaseMapper<PmPdCcSlab> {
    /**
     * 基础查询
     *
     * @param pmPdCcSlab 查询条件
     * @return 返回值
     */
    List<PmPdCcSlab> selectList(PmPdCcSlab pmPdCcSlab);

    /**
     * 组炉材料收池查询
     *
     * @param dto      查询参数
     * @param tenantId 租户
     * @param outSgNoList 内部钢种集合
     * @return
     */
    List<PmPdCcSlabStoveResDTO> selectStoveList(@Param("dto") PmPdCcSlabStoveParamDTO dto, @Param("tenantId") Long tenantId, @Param("outSgNoList") List<String> outSgNoList);
}

