package com.xisc.pm.infra.mapper;

import com.xisc.pm.api.dto.PmPdContPanelMaterialDTO;
import com.xisc.pm.domain.entity.PmPdContSum;
import io.choerodon.mybatis.common.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 组板合同总量表(PmPdContSum)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-07-30 10:29:32
 */
public interface PmPdContSumMapper extends BaseMapper<PmPdContSum> {
    /**
     * 基础查询
     *
     * @param pmPdContSum 查询条件
     * @return 返回值
     */
    List<PmPdContSum> selectList(PmPdContSum pmPdContSum);

    /**
     * 根据合同号查询合同主表，合同属性表，总量表获取数据
     *
     * @param orderNoFrom 合同号起
     * @param orderNoTo   合同号至
     * @param tenantId    租户
     * @return
     */
    List<PmPdContPanelMaterialDTO> selectConPanelMaterialsList(@Param("orderNoFrom") String orderNoFrom,
                                                               @Param("orderNoTo") String orderNoTo,
                                                               @Param("tenantId") Long tenantId);

    /**
     * 通过MatNo删除
     *
     * @param tenantId
     * @param removePdMatNo
     */
    int deleteByMatNo(@Param("tenantId") Long tenantId, @Param("removePdMatNo") List<String> removePdMatNo);
}

