package com.xisc.pm.infra.mapper;

import com.xisc.pm.api.dto.PmPolicyGroupReqDTO;
import com.xisc.pm.app.service.autoboard.dto.PmOrderGroupDemension;
import com.xisc.pm.domain.entity.PmPolicyGroup;
import io.choerodon.mybatis.common.BaseMapper;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * 策略组表(PmPolicyGroup)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-11-08 09:38:29
 */
public interface PmPolicyGroupMapper extends BaseMapper<PmPolicyGroup> {
    /**
     * 基础查询
     *
     * @param pmPolicyGroup 查询条件
     * @return 返回值
     */
    List<PmPolicyGroup> selectList(PmPolicyGroup pmPolicyGroup);

    List<PmPolicyGroup> queryList(@Param(value = "dto")PmPolicyGroupReqDTO dto, @Param(value = "tenantId")Long tenantId, @Param(value = "policyIdList") List<String> policyIdList);

    List<PmPolicyGroup> getProdLineCodeByGroupIdList(@Param(value = "policyGroupIdList")List<Long> policyGroupIdList, @Param(value = "tenantId")Long tenantId);

    List<PmOrderGroupDemension> selectContGroupConditionByGroupId(@Param(value = "policyGroupId") Long policyGroupId, @Param(value = "tenantId")Long tenantId);
}

