package com.xisc.pm.infra.mapper;

import com.xisc.pm.api.dto.PmSlabMethodDTO;
import io.choerodon.mybatis.common.BaseMapper;
import com.xisc.pm.domain.entity.PmSlabMethod;

import java.util.List;

/**
 * 生产线组板方式表(PmSlabMethod)应用服务
 *
 * @author jie.yang04@hand-china.com
 * @since 2024-10-09 09:43:33
 */
public interface PmSlabMethodMapper extends BaseMapper<PmSlabMethod> {
    /**
     * 基础查询
     * @param pmSlabMethod 查询条件
     * @return 返回值
     */
    List<PmSlabMethod> selectList(PmSlabMethod pmSlabMethod);

    /**
     * 按prod生产线id列表选择
     *
     * @param tenantId 租户id
     * @param prodLineId prod生产线编号
     * @return {@link List }<{@link PmSlabMethod }>
     *
     */
    List<PmSlabMethodDTO> selectByProdLineIdList(Long tenantId, Long prodLineId);

}

