package com.xisc.pm.infra.mapper;

import com.xisc.pm.api.dto.PmRuntimeContractLineDTO;
import com.xisc.pm.api.dto.PmRuntimeContractReqDTO;
import com.xisc.pm.domain.entity.PmSpecTableColumn;
import io.choerodon.mybatis.common.BaseMapper;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * 合同结构规格表(PmSpecTableColumn)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-10-12 09:10:23
 */
public interface PmSpecTableColumnMapper extends BaseMapper<PmSpecTableColumn> {
    /**
     * 基础查询
     *
     * @param pmSpecTableColumn 查询条件
     * @return 返回值
     */
    List<PmSpecTableColumn> selectList(PmSpecTableColumn pmSpecTableColumn);

    /**
     * 根据条件查询合同号
     *
     * @param dto
     * @param tenantId
     * @return
     */
    List<String> selectOrderNoList(@Param(value="dto") PmRuntimeContractReqDTO dto, @Param(value="tenantId")Long tenantId);

    /**
     * 根据钢种对应合同信息
     * @param dto
     * @param tenantId
     * @return
     */
    List<String> selectLineList(@Param(value="dto") PmRuntimeContractLineDTO dto, @Param(value="tenantId")Long tenantId);
}

