package com.xisc.pm.infra.mapper;

import com.xisc.pm.domain.entity.PmSteelCastHeat;
import io.choerodon.mybatis.common.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 炼钢连铸制造命令炉次表 (PmSteelCastHeat)应用服务
 *
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024-08-15 08:20:12
 */
public interface PmSteelCastHeatMapper extends BaseMapper<PmSteelCastHeat> {
    /**
     * 基础查询
     *
     * @param pmSteelCastHeat 查询条件
     * @return 返回值
     */
    List<PmSteelCastHeat> selectList(PmSteelCastHeat pmSteelCastHeat);

    /**
     * 查询列表
     *
     * @param dto      入参
     * @param tenantId 租户
     * @return
     */
    List<PmSteelCastHeat> queryList(@Param(value = "dto") PmSteelCastHeat dto, @Param(value = "tenantId") Long tenantId);

    List<String> queryPonoIsAdjust(@Param(value = "statusPonoList")List<String> statusPonoList, @Param(value = "tenantId")Long tenantId);
}

