package com.xisc.pm.infra.mapper;

import com.xisc.pm.domain.vo.QdToLineupResultHeattreatVO;
import io.choerodon.mybatis.common.BaseMapper;

import java.util.List;

/**
 * 合同处理热处理工艺标准(QdToLineupResultHeattreat)应用服务
 *
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-08-16 08:36:52
 */
public interface QdToLineupResultHeattreatMapper extends BaseMapper<QdToLineupResultHeattreatVO> {
    /**
     * 基础查询
     *
     * @param qdToLineupResultHeattreatVO 查询条件
     * @return 返回值
     */
    List<QdToLineupResultHeattreatVO> selectList(QdToLineupResultHeattreatVO qdToLineupResultHeattreatVO);
    
    /**
     * 根据产线号与查到的合同号，读取合同处理加热工艺标准 (QD_TO_LINEUP_RESULT_HEAT)/ QD_TO_LINEUP_RESULT_ROLLING[质量模块]
     * @param orderNoList
     * @param mscLineNo
     * @return
     */
    List<QdToLineupResultHeattreatVO> selectReultHeatTreat(List<String> orderNoList, String mscLineNo);
}

