package com.xisc.pm.infra.mapper;

import com.xisc.pm.domain.entity.PmContMscTech;
import com.xisc.pm.domain.vo.QdToPoLineCombVO1;
import io.choerodon.mybatis.common.BaseMapper;

import java.util.List;

/**
 * 合同处理产线组合(QdToPoLineComb)应用服务
 *
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-08-14 15:45:45
 */
public interface QdToPoLineCombMapper extends BaseMapper<QdToPoLineCombVO1> {
    /**
     * 基础查询
     *
     * @param qdToPoLineCombVO1 查询条件
     * @return 返回值
     */
    List<QdToPoLineCombVO1> selectList(QdToPoLineCombVO1 qdToPoLineCombVO1);

    /**
     * 查询生产工艺参数通过合同号
     *
     * @param keySet
     * @param tenantId
     * @return
     */
    List<PmContMscTech> selectPmContMscTech(List<String> keySet, Long tenantId);
}

