package com.xisc.pm.infra.mapper;

import com.xisc.pm.domain.vo.MmSlabVO;
import com.xisc.pm.domain.vo.WmMatPileVO1;
import com.xisc.pm.domain.vo.WmMatPileVo;
import com.xisc.pm.domain.vo.WmStockInfoVO;
import io.choerodon.mybatis.common.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 材料垛位信息表(WmMatPile)应用服务
 *
 * @author 蒋雨航 yuhang.jiang02@hand-china.com
 * @since 2024-08-16 16:17:29
 */
public interface WmMatPileMapper extends BaseMapper<WmMatPileVO1> {
    /**
     * 基础查询
     *
     * @param wmMatPileVO1 查询条件
     * @return 返回值
     */
    List<WmMatPileVO1> selectList(WmMatPileVO1 wmMatPileVO1);
    
    /**
     * 查询垛位信息
     * @param matNo
     * @param tenantId
     * @return
     */
    List<WmMatPileVo> selectWmMatPileByMatNo(@Param("matNo") String matNo,@Param("tenantId") Long tenantId);
    
    /**
     * 查询库位信息
     * @param stockCode
     * @param tenantId
     * @return
     */
    List<WmStockInfoVO> getStockLineByCode(@Param("stockCode") String stockCode,@Param("tenantId") Long tenantId);

    List<MmSlabVO> getProdYearByMmSlab(@Param("matNoList")List<String> matNoList, @Param("tenantId")Long tenantId);
}

